/*
Copyright (c) 2010 - 2023, Nordic Semiconductor ASA All rights reserved.

SPDX-License-Identifier: BSD-3-Clause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. Neither the name of Nordic Semiconductor ASA nor the names of its
   contributors may be used to endorse or promote products derived from this
   software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL NORDIC SEMICONDUCTOR ASA OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
 *
 * @file     /jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/_generated/Header/nrf5340_network.h
 * @brief    CMSIS HeaderFile
 * @version  1
 * @date     Thu Mar 23 14:54:55 2023
 * @note     Generated by SVDConv V3.3.44
 *           from File '/jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/source/files/svd/external/nrf5340_network.svd',
 *           last modified on Thu Mar 23 14:54:25 2023
 */


/** @addtogroup Nordic Semiconductor
  * @{
  */


/** @addtogroup nrf5340_network
  * @{
  */


#ifndef NRF5340_NETWORK_H
#define NRF5340_NETWORK_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M33 Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  MemoryManagement_IRQn     = -12,              /*!< -12  Memory Management, MPU mismatch, including Access Violation
                                                     and No Match                                                              */
  BusFault_IRQn             = -11,              /*!< -11  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                     related Fault                                                             */
  UsageFault_IRQn           = -10,              /*!< -10  Usage Fault, i.e. Undef Instruction, Illegal State Transition        */
  SecureFault_IRQn          =  -9,              /*!< -9 Secure Fault Handler                                                   */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  DebugMonitor_IRQn         =  -4,              /*!< -4 Debug Monitor                                                          */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* ======================================  nrf5340_network Specific Interrupt Numbers  ======================================= */
  CLOCK_POWER_IRQn          =   5,              /*!< 5  CLOCK_POWER                                                            */
  RADIO_IRQn                =   8,              /*!< 8  RADIO                                                                  */
  RNG_IRQn                  =   9,              /*!< 9  RNG                                                                    */
  GPIOTE_IRQn               =  10,              /*!< 10 GPIOTE                                                                 */
  WDT_IRQn                  =  11,              /*!< 11 WDT                                                                    */
  TIMER0_IRQn               =  12,              /*!< 12 TIMER0                                                                 */
  ECB_IRQn                  =  13,              /*!< 13 ECB                                                                    */
  AAR_CCM_IRQn              =  14,              /*!< 14 AAR_CCM                                                                */
  TEMP_IRQn                 =  16,              /*!< 16 TEMP                                                                   */
  RTC0_IRQn                 =  17,              /*!< 17 RTC0                                                                   */
  IPC_IRQn                  =  18,              /*!< 18 IPC                                                                    */
  SERIAL0_IRQn              =  19,              /*!< 19 SERIAL0                                                                */
  EGU0_IRQn                 =  20,              /*!< 20 EGU0                                                                   */
  RTC1_IRQn                 =  22,              /*!< 22 RTC1                                                                   */
  TIMER1_IRQn               =  24,              /*!< 24 TIMER1                                                                 */
  TIMER2_IRQn               =  25,              /*!< 25 TIMER2                                                                 */
  SWI0_IRQn                 =  26,              /*!< 26 SWI0                                                                   */
  SWI1_IRQn                 =  27,              /*!< 27 SWI1                                                                   */
  SWI2_IRQn                 =  28,              /*!< 28 SWI2                                                                   */
  SWI3_IRQn                 =  29               /*!< 29 SWI3                                                                   */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M33 Processor and Core Peripherals  =========================== */
#define __CM33_REV                 0x0004U      /*!< CM33 Core Revision                                                        */
#define __INTERRUPTS_MAX                   129        /*!< Top interrupt number                                                      */
#define __DSP_PRESENT                  0        /*!< DSP present or not                                                        */
#define __NVIC_PRIO_BITS               3        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __MPU_PRESENT                  1        /*!< MPU present                                                               */
#define __FPU_PRESENT                  0        /*!< FPU present                                                               */
#define __FPU_DP                       0        /*!< unused, Device has no FPU                                                 */
#define __SAUREGION_PRESENT            0        /*!< SAU region present                                                        */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm33.h"                          /*!< ARM Cortex-M33 processor and core peripherals                             */
#include "system_nrf5340_network.h"             /*!< nrf5340_network System                                                    */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief FICR_INFO [INFO] (Device info)
  */
typedef struct {
  __IM  uint32_t  CONFIGID;                     /*!< Configuration identifier                                                  */
  __IM  uint32_t  DEVICEID[2];                  /*!< Description collection: Device identifier                                 */
  __IM  uint32_t  PART;                         /*!< Part code                                                                 */
  __IM  uint32_t  VARIANT;                      /*!< Part Variant, Hardware version and Production configuration               */
  __IM  uint32_t  PACKAGE;                      /*!< Package option                                                            */
  __IM  uint32_t  RAM;                          /*!< RAM variant                                                               */
  __IM  uint32_t  FLASH;                        /*!< Flash variant                                                             */
  __IM  uint32_t  CODEPAGESIZE;                 /*!< Code memory page size in bytes                                            */
  __IM  uint32_t  CODESIZE;                     /*!< Code memory size                                                          */
  __IM  uint32_t  DEVICETYPE;                   /*!< Device type                                                               */
} FICR_INFO_Type;                               /*!< Size = 44 (0x2c)                                                          */


/**
  * @brief FICR_TRIMCNF [TRIMCNF] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  ADDR;                         /*!< Description cluster: Address                                              */
  __IM  uint32_t  DATA;                         /*!< Description cluster: Data                                                 */
} FICR_TRIMCNF_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief VREQCTRL_VREGRADIO [VREGRADIO] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  VREQH;                        /*!< Request high voltage on RADIO After requesting high voltage,
                                                     the user must wait until VREQHREADY is set to Ready                       */
  __IM  uint32_t  RESERVED;
  __IM  uint32_t  VREQHREADY;                   /*!< High voltage on RADIO is ready                                            */
} VREQCTRL_VREGRADIO_Type;                      /*!< Size = 12 (0xc)                                                           */


/**
  * @brief CTRLAPPERI_MAILBOX [MAILBOX] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  RXDATA;                       /*!< Data sent from the debugger to the CPU.                                   */
  __IM  uint32_t  RXSTATUS;                     /*!< This register shows a status that indicates if data sent from
                                                     the debugger to the CPU has been read.                                    */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  TXDATA;                       /*!< Data sent from the CPU to the debugger.                                   */
  __IM  uint32_t  TXSTATUS;                     /*!< This register shows a status that indicates if the data sent
                                                     from the CPU to the debugger has been read.                               */
} CTRLAPPERI_MAILBOX_Type;                      /*!< Size = 136 (0x88)                                                         */


/**
  * @brief CTRLAPPERI_ERASEPROTECT [ERASEPROTECT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LOCK;                         /*!< This register locks the ERASEPROTECT.DISABLE register from being
                                                     written until next reset.                                                 */
  __IOM uint32_t  DISABLE;                      /*!< This register disables the ERASEPROTECT register and performs
                                                     an ERASEALL operation.                                                    */
} CTRLAPPERI_ERASEPROTECT_Type;                 /*!< Size = 8 (0x8)                                                            */


/**
  * @brief CTRLAPPERI_APPROTECT [APPROTECT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LOCK;                         /*!< This register locks the APPROTECT.DISABLE register from being
                                                     written to until next reset.                                              */
  __IOM uint32_t  DISABLE;                      /*!< This register disables the APPROTECT register and enables debug
                                                     access to non-secure mode.                                                */
} CTRLAPPERI_APPROTECT_Type;                    /*!< Size = 8 (0x8)                                                            */


/**
  * @brief RADIO_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DFEGPIO[8];                   /*!< Description collection: Pin select for DFE pin n                          */
} RADIO_PSEL_Type;                              /*!< Size = 32 (0x20)                                                          */


/**
  * @brief RADIO_DFEPACKET [DFEPACKET] (DFE packet EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of buffer words to transfer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of samples transferred in the last transaction                     */
} RADIO_DFEPACKET_Type;                         /*!< Size = 12 (0xc)                                                           */


/**
  * @brief DPPIC_TASKS_CHG [TASKS_CHG] (Channel group tasks)
  */
typedef struct {
  __OM  uint32_t  EN;                           /*!< Description cluster: Enable channel group n                               */
  __OM  uint32_t  DIS;                          /*!< Description cluster: Disable channel group n                              */
} DPPIC_TASKS_CHG_Type;                         /*!< Size = 8 (0x8)                                                            */


/**
  * @brief DPPIC_SUBSCRIBE_CHG [SUBSCRIBE_CHG] (Subscribe configuration for tasks)
  */
typedef struct {
  __IOM uint32_t  EN;                           /*!< Description cluster: Subscribe configuration for task CHG[n].EN           */
  __IOM uint32_t  DIS;                          /*!< Description cluster: Subscribe configuration for task CHG[n].DIS          */
} DPPIC_SUBSCRIBE_CHG_Type;                     /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN                                                        */
} SPIM_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Number of bytes in transmit buffer                                        */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_IFTIMING [IFTIMING] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RXDELAY;                      /*!< Sample delay for input serial data on MISO                                */
  __IOM uint32_t  CSNDUR;                       /*!< Minimum duration between edge of CSN and edge of SCK. When SHORTS.END_START
                                                     is used, this is also the minimum duration CSN must stay
                                                     high between transactions.                                                */
} SPIM_IFTIMING_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN signal                                                 */
} SPIS_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes received in last granted transaction                      */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transmitted in last granted transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIM_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIS_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIS_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in RXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last RXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in TXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last TXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RTS;                          /*!< Pin select for RTS signal                                                 */
  __IOM uint32_t  TXD;                          /*!< Pin select for TXD signal                                                 */
  __IOM uint32_t  CTS;                          /*!< Pin select for CTS signal                                                 */
  __IOM uint32_t  RXD;                          /*!< Pin select for RXD signal                                                 */
} UARTE_PSEL_Type;                              /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_RXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief UARTE_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_TXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief ACL_ACL [ACL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  ADDR;                         /*!< Description cluster: Start address of region to protect. The
                                                     start address must be word-aligned.                                       */
  __IOM uint32_t  SIZE;                         /*!< Description cluster: Size of region to protect counting from
                                                     address ACL[n].ADDR. Writing a '0' has no effect.                         */
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access permissions for region n as defined
                                                     by start address ACL[n].ADDR and size ACL[n].SIZE                         */
  __IM  uint32_t  RESERVED;
} ACL_ACL_Type;                                 /*!< Size = 16 (0x10)                                                          */


/**
  * @brief VMC_RAM [RAM] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  POWER;                        /*!< Description cluster: RAM[n] power control register                        */
  __IOM uint32_t  POWERSET;                     /*!< Description cluster: RAM[n] power control set register                    */
  __IOM uint32_t  POWERCLR;                     /*!< Description cluster: RAM[n] power control clear register                  */
  __IM  uint32_t  RESERVED;
} VMC_RAM_Type;                                 /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                          FICR_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Factory Information Configuration Registers (FICR_NS)
  */

typedef struct {                                /*!< FICR_NS Structure                                                         */
  __IM  uint32_t  RESERVED[128];
  __IOM FICR_INFO_Type INFO;                    /*!< Device info                                                               */
  __IM  uint32_t  RESERVED1[21];
  __IM  uint32_t  ER[4];                        /*!< Description collection: Encryption Root, word n                           */
  __IM  uint32_t  IR[4];                        /*!< Description collection: Identity Root, word n                             */
  __IM  uint32_t  DEVICEADDRTYPE;               /*!< Device address type                                                       */
  __IM  uint32_t  DEVICEADDR[2];                /*!< Description collection: Device address n                                  */
  __IM  uint32_t  RESERVED2[21];
  __IOM FICR_TRIMCNF_Type TRIMCNF[32];          /*!< Unspecified                                                               */
} NRF_FICR_Type;                                /*!< Size = 1024 (0x400)                                                       */



/* =========================================================================================================================== */
/* ================                                          UICR_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief User Information Configuration Registers (UICR_NS)
  */

typedef struct {                                /*!< UICR_NS Structure                                                         */
  __IOM uint32_t  APPROTECT;                    /*!< Access port protection                                                    */
  __IOM uint32_t  ERASEPROTECT;                 /*!< Erase protection                                                          */
  __IM  uint32_t  RESERVED[126];
  __IOM uint32_t  NRFFW[32];                    /*!< Description collection: Reserved for Nordic firmware design               */
  __IM  uint32_t  RESERVED1[32];
  __IOM uint32_t  CUSTOMER[32];                 /*!< Description collection: Reserved for customer                             */
} NRF_UICR_Type;                                /*!< Size = 896 (0x380)                                                        */



/* =========================================================================================================================== */
/* ================                                          CTI_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Cross-Trigger Interface control. NOTE: this is not a separate peripheral, but describes CM33 functionality. (CTI_NS)
  */

typedef struct {                                /*!< CTI_NS Structure                                                          */
  __IOM uint32_t  CTICONTROL;                   /*!< CTI Control register                                                      */
  __IM  uint32_t  RESERVED[3];
  __OM  uint32_t  CTIINTACK;                    /*!< CTI Interrupt Acknowledge register                                        */
  __IOM uint32_t  CTIAPPSET;                    /*!< CTI Application Trigger Set register                                      */
  __OM  uint32_t  CTIAPPCLEAR;                  /*!< CTI Application Trigger Clear register                                    */
  __OM  uint32_t  CTIAPPPULSE;                  /*!< CTI Application Pulse register                                            */
  __IOM uint32_t  CTIINEN[8];                   /*!< Description collection: CTI Trigger input                                 */
  __IM  uint32_t  RESERVED1[24];
  __IOM uint32_t  CTIOUTEN[8];                  /*!< Description collection: CTI Trigger output                                */
  __IM  uint32_t  RESERVED2[28];
  __IM  uint32_t  CTITRIGINSTATUS;              /*!< CTI Trigger In Status register                                            */
  __IM  uint32_t  CTITRIGOUTSTATUS;             /*!< CTI Trigger Out Status register                                           */
  __IM  uint32_t  CTICHINSTATUS;                /*!< CTI Channel In Status register                                            */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  CTIGATE;                      /*!< Enable CTI Channel Gate register                                          */
  __IM  uint32_t  RESERVED4[926];
  __IM  uint32_t  DEVARCH;                      /*!< Device Architecture register                                              */
  __IM  uint32_t  RESERVED5[2];
  __IM  uint32_t  DEVID;                        /*!< Device Configuration register                                             */
  __IM  uint32_t  DEVTYPE;                      /*!< Device Type Identifier register                                           */
  __IM  uint32_t  PIDR4;                        /*!< Peripheral ID4 Register                                                   */
  __IM  uint32_t  PIDR5;                        /*!< Peripheral ID5 register                                                   */
  __IM  uint32_t  PIDR6;                        /*!< Peripheral ID6 register                                                   */
  __IM  uint32_t  PIDR7;                        /*!< Peripheral ID7 register                                                   */
  __IM  uint32_t  PIDR0;                        /*!< Peripheral ID0 Register                                                   */
  __IM  uint32_t  PIDR1;                        /*!< Peripheral ID1 Register                                                   */
  __IM  uint32_t  PIDR2;                        /*!< Peripheral ID2 Register                                                   */
  __IM  uint32_t  PIDR3;                        /*!< Peripheral ID3 Register                                                   */
  __IM  uint32_t  CIDR0;                        /*!< Component ID0 Register                                                    */
  __IM  uint32_t  CIDR1;                        /*!< Component ID1 Register                                                    */
  __IM  uint32_t  CIDR2;                        /*!< Component ID2 Register                                                    */
  __IM  uint32_t  CIDR3;                        /*!< Component ID3 Register                                                    */
} NRF_CTI_Type;                                 /*!< Size = 4096 (0x1000)                                                      */



/* =========================================================================================================================== */
/* ================                                          DCNF_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Domain configuration management (DCNF_NS)
  */

typedef struct {                                /*!< DCNF_NS Structure                                                         */
  __IM  uint32_t  RESERVED[264];
  __IM  uint32_t  CPUID;                        /*!< CPU ID of this subsystem                                                  */
} NRF_DCNF_Type;                                /*!< Size = 1060 (0x424)                                                       */



/* =========================================================================================================================== */
/* ================                                        VREQCTRL_NS                                        ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage request control (VREQCTRL_NS)
  */

typedef struct {                                /*!< VREQCTRL_NS Structure                                                     */
  __IM  uint32_t  RESERVED[320];
  __IOM VREQCTRL_VREGRADIO_Type VREGRADIO;      /*!< Unspecified                                                               */
} NRF_VREQCTRL_Type;                            /*!< Size = 1292 (0x50c)                                                       */



/* =========================================================================================================================== */
/* ================                                         CLOCK_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock management (CLOCK_NS)
  */

typedef struct {                                /*!< CLOCK_NS Structure                                                        */
  __OM  uint32_t  TASKS_HFCLKSTART;             /*!< Start HFCLK128M/HFCLK64M source as selected in HFCLKSRC                   */
  __OM  uint32_t  TASKS_HFCLKSTOP;              /*!< Stop HFCLK128M/HFCLK64M source                                            */
  __OM  uint32_t  TASKS_LFCLKSTART;             /*!< Start LFCLK source as selected in LFCLKSRC                                */
  __OM  uint32_t  TASKS_LFCLKSTOP;              /*!< Stop LFCLK source                                                         */
  __OM  uint32_t  TASKS_CAL;                    /*!< Start calibration of LFRC oscillator                                      */
  __IM  uint32_t  RESERVED[27];
  __IOM uint32_t  SUBSCRIBE_HFCLKSTART;         /*!< Subscribe configuration for task HFCLKSTART                               */
  __IOM uint32_t  SUBSCRIBE_HFCLKSTOP;          /*!< Subscribe configuration for task HFCLKSTOP                                */
  __IOM uint32_t  SUBSCRIBE_LFCLKSTART;         /*!< Subscribe configuration for task LFCLKSTART                               */
  __IOM uint32_t  SUBSCRIBE_LFCLKSTOP;          /*!< Subscribe configuration for task LFCLKSTOP                                */
  __IOM uint32_t  SUBSCRIBE_CAL;                /*!< Subscribe configuration for task CAL                                      */
  __IM  uint32_t  RESERVED1[27];
  __IOM uint32_t  EVENTS_HFCLKSTARTED;          /*!< HFCLK128M/HFCLK64M source started                                         */
  __IOM uint32_t  EVENTS_LFCLKSTARTED;          /*!< LFCLK source started                                                      */
  __IM  uint32_t  RESERVED2[5];
  __IOM uint32_t  EVENTS_DONE;                  /*!< Calibration of LFRC oscillator complete event                             */
  __IM  uint32_t  RESERVED3[24];
  __IOM uint32_t  PUBLISH_HFCLKSTARTED;         /*!< Publish configuration for event HFCLKSTARTED                              */
  __IOM uint32_t  PUBLISH_LFCLKSTARTED;         /*!< Publish configuration for event LFCLKSTARTED                              */
  __IM  uint32_t  RESERVED4[5];
  __IOM uint32_t  PUBLISH_DONE;                 /*!< Publish configuration for event DONE                                      */
  __IM  uint32_t  RESERVED5[88];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED6[62];
  __IM  uint32_t  HFCLKRUN;                     /*!< Status indicating that HFCLKSTART task has been triggered                 */
  __IM  uint32_t  HFCLKSTAT;                    /*!< Status indicating which HFCLK128M/HFCLK64M source is running
                                                     This register value in any CLOCK instance reflects status
                                                     only due to configurations/actions in that CLOCK instance.                */
  __IM  uint32_t  RESERVED7;
  __IM  uint32_t  LFCLKRUN;                     /*!< Status indicating that LFCLKSTART task has been triggered                 */
  __IM  uint32_t  LFCLKSTAT;                    /*!< Status indicating which LFCLK source is running This register
                                                     value in any CLOCK instance reflects status only due to
                                                     configurations/actions in that CLOCK instance.                            */
  __IM  uint32_t  LFCLKSRCCOPY;                 /*!< Copy of LFCLKSRC register, set when LFCLKSTART task was triggered         */
  __IM  uint32_t  RESERVED8[61];
  __IOM uint32_t  HFCLKSRC;                     /*!< Clock source for HFCLK128M/HFCLK64M                                       */
  __IOM uint32_t  LFCLKSRC;                     /*!< Clock source for LFCLK                                                    */
  __IM  uint32_t  RESERVED9[15];
  __IOM uint32_t  HFCLKCTRL;                    /*!< HFCLK128M frequency configuration                                         */
  __IM  uint32_t  RESERVED10[5];
  __IOM uint32_t  HFCLKALWAYSRUN;               /*!< Automatic or manual control of HFCLK128M/HFCLK64M                         */
  __IOM uint32_t  LFCLKALWAYSRUN;               /*!< Automatic or manual control of LFCLK                                      */
} NRF_CLOCK_Type;                               /*!< Size = 1400 (0x578)                                                       */



/* =========================================================================================================================== */
/* ================                                         POWER_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Power control (POWER_NS)
  */

typedef struct {                                /*!< POWER_NS Structure                                                        */
  __IM  uint32_t  RESERVED[30];
  __OM  uint32_t  TASKS_CONSTLAT;               /*!< Enable Constant Latency mode                                              */
  __OM  uint32_t  TASKS_LOWPWR;                 /*!< Enable Low-Power mode (variable latency)                                  */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  SUBSCRIBE_CONSTLAT;           /*!< Subscribe configuration for task CONSTLAT                                 */
  __IOM uint32_t  SUBSCRIBE_LOWPWR;             /*!< Subscribe configuration for task LOWPWR                                   */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_POFWARN;               /*!< Power failure warning                                                     */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_SLEEPENTER;            /*!< CPU entered WFI/WFE sleep                                                 */
  __IOM uint32_t  EVENTS_SLEEPEXIT;             /*!< CPU exited WFI/WFE sleep                                                  */
  __IM  uint32_t  RESERVED4[27];
  __IOM uint32_t  PUBLISH_POFWARN;              /*!< Publish configuration for event POFWARN                                   */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  PUBLISH_SLEEPENTER;           /*!< Publish configuration for event SLEEPENTER                                */
  __IOM uint32_t  PUBLISH_SLEEPEXIT;            /*!< Publish configuration for event SLEEPEXIT                                 */
  __IM  uint32_t  RESERVED6[89];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[132];
  __IOM uint32_t  GPREGRET[2];                  /*!< Description collection: General purpose retention register                */
} NRF_POWER_Type;                               /*!< Size = 1316 (0x524)                                                       */



/* =========================================================================================================================== */
/* ================                                         RESET_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Reset control (RESET_NS)
  */

typedef struct {                                /*!< RESET_NS Structure                                                        */
  __IM  uint32_t  RESERVED[256];
  __IOM uint32_t  RESETREAS;                    /*!< Reset reason                                                              */
} NRF_RESET_Type;                               /*!< Size = 1028 (0x404)                                                       */



/* =========================================================================================================================== */
/* ================                                         CTRLAP_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Control access port (CTRLAP_NS)
  */

typedef struct {                                /*!< CTRLAP_NS Structure                                                       */
  __IM  uint32_t  RESERVED[256];
  __IOM CTRLAPPERI_MAILBOX_Type MAILBOX;        /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED1[30];
  __IOM CTRLAPPERI_ERASEPROTECT_Type ERASEPROTECT;/*!< Unspecified                                                             */
  __IM  uint32_t  RESERVED2[14];
  __IOM CTRLAPPERI_APPROTECT_Type APPROTECT;    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED3[46];
  __IM  uint32_t  STATUS;                       /*!< Status bits for CTRL-AP peripheral.                                       */
} NRF_CTRLAPPERI_Type;                          /*!< Size = 1540 (0x604)                                                       */



/* =========================================================================================================================== */
/* ================                                         RADIO_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief 2.4 GHz radio (RADIO_NS)
  */

typedef struct {                                /*!< RADIO_NS Structure                                                        */
  __OM  uint32_t  TASKS_TXEN;                   /*!< Enable RADIO in TX mode                                                   */
  __OM  uint32_t  TASKS_RXEN;                   /*!< Enable RADIO in RX mode                                                   */
  __OM  uint32_t  TASKS_START;                  /*!< Start RADIO                                                               */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop RADIO                                                                */
  __OM  uint32_t  TASKS_DISABLE;                /*!< Disable RADIO                                                             */
  __OM  uint32_t  TASKS_RSSISTART;              /*!< Start the RSSI and take one single sample of the receive signal
                                                     strength                                                                  */
  __OM  uint32_t  TASKS_RSSISTOP;               /*!< Stop the RSSI measurement                                                 */
  __OM  uint32_t  TASKS_BCSTART;                /*!< Start the bit counter                                                     */
  __OM  uint32_t  TASKS_BCSTOP;                 /*!< Stop the bit counter                                                      */
  __OM  uint32_t  TASKS_EDSTART;                /*!< Start the energy detect measurement used in IEEE 802.15.4 mode            */
  __OM  uint32_t  TASKS_EDSTOP;                 /*!< Stop the energy detect measurement                                        */
  __OM  uint32_t  TASKS_CCASTART;               /*!< Start the clear channel assessment used in IEEE 802.15.4 mode             */
  __OM  uint32_t  TASKS_CCASTOP;                /*!< Stop the clear channel assessment                                         */
  __IM  uint32_t  RESERVED[19];
  __IOM uint32_t  SUBSCRIBE_TXEN;               /*!< Subscribe configuration for task TXEN                                     */
  __IOM uint32_t  SUBSCRIBE_RXEN;               /*!< Subscribe configuration for task RXEN                                     */
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_DISABLE;            /*!< Subscribe configuration for task DISABLE                                  */
  __IOM uint32_t  SUBSCRIBE_RSSISTART;          /*!< Subscribe configuration for task RSSISTART                                */
  __IOM uint32_t  SUBSCRIBE_RSSISTOP;           /*!< Subscribe configuration for task RSSISTOP                                 */
  __IOM uint32_t  SUBSCRIBE_BCSTART;            /*!< Subscribe configuration for task BCSTART                                  */
  __IOM uint32_t  SUBSCRIBE_BCSTOP;             /*!< Subscribe configuration for task BCSTOP                                   */
  __IOM uint32_t  SUBSCRIBE_EDSTART;            /*!< Subscribe configuration for task EDSTART                                  */
  __IOM uint32_t  SUBSCRIBE_EDSTOP;             /*!< Subscribe configuration for task EDSTOP                                   */
  __IOM uint32_t  SUBSCRIBE_CCASTART;           /*!< Subscribe configuration for task CCASTART                                 */
  __IOM uint32_t  SUBSCRIBE_CCASTOP;            /*!< Subscribe configuration for task CCASTOP                                  */
  __IM  uint32_t  RESERVED1[19];
  __IOM uint32_t  EVENTS_READY;                 /*!< RADIO has ramped up and is ready to be started                            */
  __IOM uint32_t  EVENTS_ADDRESS;               /*!< Address sent or received                                                  */
  __IOM uint32_t  EVENTS_PAYLOAD;               /*!< Packet payload sent or received                                           */
  __IOM uint32_t  EVENTS_END;                   /*!< Packet sent or received                                                   */
  __IOM uint32_t  EVENTS_DISABLED;              /*!< RADIO has been disabled                                                   */
  __IOM uint32_t  EVENTS_DEVMATCH;              /*!< A device address match occurred on the last received packet               */
  __IOM uint32_t  EVENTS_DEVMISS;               /*!< No device address match occurred on the last received packet              */
  __IOM uint32_t  EVENTS_RSSIEND;               /*!< Sampling of receive signal strength complete                              */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_BCMATCH;               /*!< Bit counter reached bit count value                                       */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  EVENTS_CRCOK;                 /*!< Packet received with CRC ok                                               */
  __IOM uint32_t  EVENTS_CRCERROR;              /*!< Packet received with CRC error                                            */
  __IOM uint32_t  EVENTS_FRAMESTART;            /*!< IEEE 802.15.4 length field received                                       */
  __IOM uint32_t  EVENTS_EDEND;                 /*!< Sampling of energy detection complete. A new ED sample is ready
                                                     for readout from the RADIO.EDSAMPLE register.                             */
  __IOM uint32_t  EVENTS_EDSTOPPED;             /*!< The sampling of energy detection has stopped                              */
  __IOM uint32_t  EVENTS_CCAIDLE;               /*!< Wireless medium in idle - clear to send                                   */
  __IOM uint32_t  EVENTS_CCABUSY;               /*!< Wireless medium busy - do not send                                        */
  __IOM uint32_t  EVENTS_CCASTOPPED;            /*!< The CCA has stopped                                                       */
  __IOM uint32_t  EVENTS_RATEBOOST;             /*!< Ble_LR CI field received, receive mode is changed from Ble_LR125Kbit
                                                     to Ble_LR500Kbit.                                                         */
  __IOM uint32_t  EVENTS_TXREADY;               /*!< RADIO has ramped up and is ready to be started TX path                    */
  __IOM uint32_t  EVENTS_RXREADY;               /*!< RADIO has ramped up and is ready to be started RX path                    */
  __IOM uint32_t  EVENTS_MHRMATCH;              /*!< MAC header match found                                                    */
  __IM  uint32_t  RESERVED4[2];
  __IOM uint32_t  EVENTS_SYNC;                  /*!< Preamble indicator                                                        */
  __IOM uint32_t  EVENTS_PHYEND;                /*!< Generated when last bit is sent on air, or received from air              */
  __IOM uint32_t  EVENTS_CTEPRESENT;            /*!< CTE is present (early warning right after receiving CTEInfo
                                                     byte)                                                                     */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  PUBLISH_READY;                /*!< Publish configuration for event READY                                     */
  __IOM uint32_t  PUBLISH_ADDRESS;              /*!< Publish configuration for event ADDRESS                                   */
  __IOM uint32_t  PUBLISH_PAYLOAD;              /*!< Publish configuration for event PAYLOAD                                   */
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IOM uint32_t  PUBLISH_DISABLED;             /*!< Publish configuration for event DISABLED                                  */
  __IOM uint32_t  PUBLISH_DEVMATCH;             /*!< Publish configuration for event DEVMATCH                                  */
  __IOM uint32_t  PUBLISH_DEVMISS;              /*!< Publish configuration for event DEVMISS                                   */
  __IOM uint32_t  PUBLISH_RSSIEND;              /*!< Publish configuration for event RSSIEND                                   */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  PUBLISH_BCMATCH;              /*!< Publish configuration for event BCMATCH                                   */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  PUBLISH_CRCOK;                /*!< Publish configuration for event CRCOK                                     */
  __IOM uint32_t  PUBLISH_CRCERROR;             /*!< Publish configuration for event CRCERROR                                  */
  __IOM uint32_t  PUBLISH_FRAMESTART;           /*!< Publish configuration for event FRAMESTART                                */
  __IOM uint32_t  PUBLISH_EDEND;                /*!< Publish configuration for event EDEND                                     */
  __IOM uint32_t  PUBLISH_EDSTOPPED;            /*!< Publish configuration for event EDSTOPPED                                 */
  __IOM uint32_t  PUBLISH_CCAIDLE;              /*!< Publish configuration for event CCAIDLE                                   */
  __IOM uint32_t  PUBLISH_CCABUSY;              /*!< Publish configuration for event CCABUSY                                   */
  __IOM uint32_t  PUBLISH_CCASTOPPED;           /*!< Publish configuration for event CCASTOPPED                                */
  __IOM uint32_t  PUBLISH_RATEBOOST;            /*!< Publish configuration for event RATEBOOST                                 */
  __IOM uint32_t  PUBLISH_TXREADY;              /*!< Publish configuration for event TXREADY                                   */
  __IOM uint32_t  PUBLISH_RXREADY;              /*!< Publish configuration for event RXREADY                                   */
  __IOM uint32_t  PUBLISH_MHRMATCH;             /*!< Publish configuration for event MHRMATCH                                  */
  __IM  uint32_t  RESERVED8[2];
  __IOM uint32_t  PUBLISH_SYNC;                 /*!< Publish configuration for event SYNC                                      */
  __IOM uint32_t  PUBLISH_PHYEND;               /*!< Publish configuration for event PHYEND                                    */
  __IOM uint32_t  PUBLISH_CTEPRESENT;           /*!< Publish configuration for event CTEPRESENT                                */
  __IM  uint32_t  RESERVED9[3];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED10[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED11[61];
  __IM  uint32_t  CRCSTATUS;                    /*!< CRC status                                                                */
  __IM  uint32_t  RESERVED12;
  __IM  uint32_t  RXMATCH;                      /*!< Received address                                                          */
  __IM  uint32_t  RXCRC;                        /*!< CRC field of previously received packet                                   */
  __IM  uint32_t  DAI;                          /*!< Device address match index                                                */
  __IM  uint32_t  PDUSTAT;                      /*!< Payload status                                                            */
  __IM  uint32_t  RESERVED13[13];
  __IM  uint32_t  CTESTATUS;                    /*!< CTEInfo parsed from received packet                                       */
  __IM  uint32_t  RESERVED14[2];
  __IM  uint32_t  DFESTATUS;                    /*!< DFE status information                                                    */
  __IM  uint32_t  RESERVED15[42];
  __IOM uint32_t  PACKETPTR;                    /*!< Packet pointer                                                            */
  __IOM uint32_t  FREQUENCY;                    /*!< Frequency                                                                 */
  __IOM uint32_t  TXPOWER;                      /*!< Output power                                                              */
  __IOM uint32_t  MODE;                         /*!< Data rate and modulation                                                  */
  __IOM uint32_t  PCNF0;                        /*!< Packet configuration register 0                                           */
  __IOM uint32_t  PCNF1;                        /*!< Packet configuration register 1                                           */
  __IOM uint32_t  BASE0;                        /*!< Base address 0                                                            */
  __IOM uint32_t  BASE1;                        /*!< Base address 1                                                            */
  __IOM uint32_t  PREFIX0;                      /*!< Prefixes bytes for logical addresses 0-3                                  */
  __IOM uint32_t  PREFIX1;                      /*!< Prefixes bytes for logical addresses 4-7                                  */
  __IOM uint32_t  TXADDRESS;                    /*!< Transmit address select                                                   */
  __IOM uint32_t  RXADDRESSES;                  /*!< Receive address select                                                    */
  __IOM uint32_t  CRCCNF;                       /*!< CRC configuration                                                         */
  __IOM uint32_t  CRCPOLY;                      /*!< CRC polynomial                                                            */
  __IOM uint32_t  CRCINIT;                      /*!< CRC initial value                                                         */
  __IM  uint32_t  RESERVED16;
  __IOM uint32_t  TIFS;                         /*!< Interframe spacing in us                                                  */
  __IM  uint32_t  RSSISAMPLE;                   /*!< RSSI sample                                                               */
  __IM  uint32_t  RESERVED17;
  __IM  uint32_t  STATE;                        /*!< Current radio state                                                       */
  __IOM uint32_t  DATAWHITEIV;                  /*!< Data whitening initial value                                              */
  __IM  uint32_t  RESERVED18[2];
  __IOM uint32_t  BCC;                          /*!< Bit counter compare                                                       */
  __IM  uint32_t  RESERVED19[39];
  __IOM uint32_t  DAB[8];                       /*!< Description collection: Device address base segment n                     */
  __IOM uint32_t  DAP[8];                       /*!< Description collection: Device address prefix n                           */
  __IOM uint32_t  DACNF;                        /*!< Device address match configuration                                        */
  __IOM uint32_t  MHRMATCHCONF;                 /*!< Search pattern configuration                                              */
  __IOM uint32_t  MHRMATCHMAS;                  /*!< Pattern mask                                                              */
  __IM  uint32_t  RESERVED20;
  __IOM uint32_t  MODECNF0;                     /*!< Radio mode configuration register 0                                       */
  __IM  uint32_t  RESERVED21[3];
  __IOM uint32_t  SFD;                          /*!< IEEE 802.15.4 start of frame delimiter                                    */
  __IOM uint32_t  EDCNT;                        /*!< IEEE 802.15.4 energy detect loop count                                    */
  __IM  uint32_t  EDSAMPLE;                     /*!< IEEE 802.15.4 energy detect level                                         */
  __IOM uint32_t  CCACTRL;                      /*!< IEEE 802.15.4 clear channel assessment control                            */
  __IM  uint32_t  RESERVED22[164];
  __IOM uint32_t  DFEMODE;                      /*!< Whether to use Angle-of-Arrival (AOA) or Angle-of-Departure
                                                     (AOD)                                                                     */
  __IOM uint32_t  CTEINLINECONF;                /*!< Configuration for CTE inline mode                                         */
  __IM  uint32_t  RESERVED23[2];
  __IOM uint32_t  DFECTRL1;                     /*!< Various configuration for Direction finding                               */
  __IOM uint32_t  DFECTRL2;                     /*!< Start offset for Direction finding                                        */
  __IM  uint32_t  RESERVED24[4];
  __IOM uint32_t  SWITCHPATTERN;                /*!< GPIO patterns to be used for each antenna                                 */
  __IOM uint32_t  CLEARPATTERN;                 /*!< Clear the GPIO pattern array for antenna control                          */
  __IOM RADIO_PSEL_Type PSEL;                   /*!< Unspecified                                                               */
  __IOM RADIO_DFEPACKET_Type DFEPACKET;         /*!< DFE packet EasyDMA channel                                                */
  __IM  uint32_t  RESERVED25[424];
  __IOM uint32_t  POWER;                        /*!< Peripheral power control                                                  */
} NRF_RADIO_Type;                               /*!< Size = 4096 (0x1000)                                                      */



/* =========================================================================================================================== */
/* ================                                          RNG_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Random Number Generator (RNG_NS)
  */

typedef struct {                                /*!< RNG_NS Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Task starting the random number generator                                 */
  __OM  uint32_t  TASKS_STOP;                   /*!< Task stopping the random number generator                                 */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_VALRDY;                /*!< Event being generated for every new random number written to
                                                     the VALUE register                                                        */
  __IM  uint32_t  RESERVED2[31];
  __IOM uint32_t  PUBLISH_VALRDY;               /*!< Publish configuration for event VALRDY                                    */
  __IM  uint32_t  RESERVED3[31];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED4[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[126];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  VALUE;                        /*!< Output random number                                                      */
} NRF_RNG_Type;                                 /*!< Size = 1292 (0x50c)                                                       */



/* =========================================================================================================================== */
/* ================                                         GPIOTE_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Tasks and Events (GPIOTE_NS)
  */

typedef struct {                                /*!< GPIOTE_NS Structure                                                       */
  __OM  uint32_t  TASKS_OUT[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is configured in CONFIG[n].POLARITY.        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_SET[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it high.                          */
  __IM  uint32_t  RESERVED1[4];
  __OM  uint32_t  TASKS_CLR[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it low.                           */
  __IOM uint32_t  SUBSCRIBE_OUT[8];             /*!< Description collection: Subscribe configuration for task OUT[n]           */
  __IM  uint32_t  RESERVED2[4];
  __IOM uint32_t  SUBSCRIBE_SET[8];             /*!< Description collection: Subscribe configuration for task SET[n]           */
  __IM  uint32_t  RESERVED3[4];
  __IOM uint32_t  SUBSCRIBE_CLR[8];             /*!< Description collection: Subscribe configuration for task CLR[n]           */
  __IOM uint32_t  EVENTS_IN[8];                 /*!< Description collection: Event generated from pin specified in
                                                     CONFIG[n].PSEL                                                            */
  __IM  uint32_t  RESERVED4[23];
  __IOM uint32_t  EVENTS_PORT;                  /*!< Event generated from multiple input GPIO pins with SENSE mechanism
                                                     enabled                                                                   */
  __IOM uint32_t  PUBLISH_IN[8];                /*!< Description collection: Publish configuration for event IN[n]             */
  __IM  uint32_t  RESERVED5[23];
  __IOM uint32_t  PUBLISH_PORT;                 /*!< Publish configuration for event PORT                                      */
  __IM  uint32_t  RESERVED6[65];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[126];
  __IOM uint32_t  LATENCY;                      /*!< Latency selection for Event mode (MODE=Event) with rising or
                                                     falling edge detection on the pin.                                        */
  __IM  uint32_t  RESERVED8[2];
  __IOM uint32_t  CONFIG[8];                    /*!< Description collection: Configuration for OUT[n], SET[n], and
                                                     CLR[n] tasks and IN[n] event                                              */
} NRF_GPIOTE_Type;                              /*!< Size = 1328 (0x530)                                                       */



/* =========================================================================================================================== */
/* ================                                          WDT_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer (WDT_NS)
  */

typedef struct {                                /*!< WDT_NS Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Start WDT                                                                 */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop WDT                                                                  */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_TIMEOUT;               /*!< Watchdog timeout                                                          */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< Watchdog stopped                                                          */
  __IM  uint32_t  RESERVED2[30];
  __IOM uint32_t  PUBLISH_TIMEOUT;              /*!< Publish configuration for event TIMEOUT                                   */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED3[95];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[6];
  __IOM uint32_t  NMIENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  NMIENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[53];
  __IM  uint32_t  RUNSTATUS;                    /*!< Run status                                                                */
  __IM  uint32_t  REQSTATUS;                    /*!< Request status                                                            */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  CRV;                          /*!< Counter reload value                                                      */
  __IOM uint32_t  RREN;                         /*!< Enable register for reload request registers                              */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED7[4];
  __OM  uint32_t  TSEN;                         /*!< Task stop enable                                                          */
  __IM  uint32_t  RESERVED8[55];
  __OM  uint32_t  RR[8];                        /*!< Description collection: Reload request n                                  */
} NRF_WDT_Type;                                 /*!< Size = 1568 (0x620)                                                       */



/* =========================================================================================================================== */
/* ================                                         TIMER0_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Timer/Counter 0 (TIMER0_NS)
  */

typedef struct {                                /*!< TIMER0_NS Structure                                                       */
  __OM  uint32_t  TASKS_START;                  /*!< Start Timer                                                               */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop Timer                                                                */
  __OM  uint32_t  TASKS_COUNT;                  /*!< Increment Timer (Counter mode only)                                       */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear time                                                                */
  __OM  uint32_t  TASKS_SHUTDOWN;               /*!< Deprecated register - Shut down timer                                     */
  __IM  uint32_t  RESERVED[11];
  __OM  uint32_t  TASKS_CAPTURE[8];             /*!< Description collection: Capture Timer value to CC[n] register             */
  __IM  uint32_t  RESERVED1[8];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_COUNT;              /*!< Subscribe configuration for task COUNT                                    */
  __IOM uint32_t  SUBSCRIBE_CLEAR;              /*!< Subscribe configuration for task CLEAR                                    */
  __IOM uint32_t  SUBSCRIBE_SHUTDOWN;           /*!< Deprecated register - Subscribe configuration for task SHUTDOWN           */
  __IM  uint32_t  RESERVED2[11];
  __IOM uint32_t  SUBSCRIBE_CAPTURE[8];         /*!< Description collection: Subscribe configuration for task CAPTURE[n]       */
  __IM  uint32_t  RESERVED3[24];
  __IOM uint32_t  EVENTS_COMPARE[8];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED4[24];
  __IOM uint32_t  PUBLISH_COMPARE[8];           /*!< Description collection: Publish configuration for event COMPARE[n]        */
  __IM  uint32_t  RESERVED5[8];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[126];
  __IOM uint32_t  MODE;                         /*!< Timer mode selection                                                      */
  __IOM uint32_t  BITMODE;                      /*!< Configure the number of bits used by the TIMER                            */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  PRESCALER;                    /*!< Timer prescaler register                                                  */
  __IM  uint32_t  RESERVED9[11];
  __IOM uint32_t  CC[8];                        /*!< Description collection: Capture/Compare register n                        */
  __IM  uint32_t  RESERVED10[8];
  __IOM uint32_t  ONESHOTEN[8];                 /*!< Description collection: Enable one-shot operation for Capture/Compare
                                                     channel n                                                                 */
} NRF_TIMER_Type;                               /*!< Size = 1440 (0x5a0)                                                       */



/* =========================================================================================================================== */
/* ================                                          ECB_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief AES ECB Mode Encryption (ECB_NS)
  */

typedef struct {                                /*!< ECB_NS Structure                                                          */
  __OM  uint32_t  TASKS_STARTECB;               /*!< Start ECB block encrypt                                                   */
  __OM  uint32_t  TASKS_STOPECB;                /*!< Abort a possible executing ECB operation                                  */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_STARTECB;           /*!< Subscribe configuration for task STARTECB                                 */
  __IOM uint32_t  SUBSCRIBE_STOPECB;            /*!< Subscribe configuration for task STOPECB                                  */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_ENDECB;                /*!< ECB block encrypt complete                                                */
  __IOM uint32_t  EVENTS_ERRORECB;              /*!< ECB block encrypt aborted because of a STOPECB task or due to
                                                     an error                                                                  */
  __IM  uint32_t  RESERVED2[30];
  __IOM uint32_t  PUBLISH_ENDECB;               /*!< Publish configuration for event ENDECB                                    */
  __IOM uint32_t  PUBLISH_ERRORECB;             /*!< Publish configuration for event ERRORECB                                  */
  __IM  uint32_t  RESERVED3[95];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[126];
  __IOM uint32_t  ECBDATAPTR;                   /*!< ECB block encrypt memory pointers                                         */
} NRF_ECB_Type;                                 /*!< Size = 1288 (0x508)                                                       */



/* =========================================================================================================================== */
/* ================                                          AAR_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Accelerated Address Resolver (AAR_NS)
  */

typedef struct {                                /*!< AAR_NS Structure                                                          */
  __OM  uint32_t  TASKS_START;                  /*!< Start resolving addresses based on IRKs specified in the IRK
                                                     data structure                                                            */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop resolving addresses                                                  */
  __IM  uint32_t  RESERVED1[29];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED3[29];
  __IOM uint32_t  EVENTS_END;                   /*!< Address resolution procedure complete                                     */
  __IOM uint32_t  EVENTS_RESOLVED;              /*!< Address resolved                                                          */
  __IOM uint32_t  EVENTS_NOTRESOLVED;           /*!< Address not resolved                                                      */
  __IM  uint32_t  RESERVED4[29];
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IOM uint32_t  PUBLISH_RESOLVED;             /*!< Publish configuration for event RESOLVED                                  */
  __IOM uint32_t  PUBLISH_NOTRESOLVED;          /*!< Publish configuration for event NOTRESOLVED                               */
  __IM  uint32_t  RESERVED5[94];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[61];
  __IM  uint32_t  STATUS;                       /*!< Resolution status                                                         */
  __IM  uint32_t  RESERVED7[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable AAR                                                                */
  __IOM uint32_t  NIRK;                         /*!< Number of IRKs                                                            */
  __IOM uint32_t  IRKPTR;                       /*!< Pointer to IRK data structure                                             */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  ADDRPTR;                      /*!< Pointer to the resolvable address                                         */
  __IOM uint32_t  SCRATCHPTR;                   /*!< Pointer to data area used for temporary storage                           */
} NRF_AAR_Type;                                 /*!< Size = 1304 (0x518)                                                       */



/* =========================================================================================================================== */
/* ================                                          CCM_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief AES CCM mode encryption (CCM_NS)
  */

typedef struct {                                /*!< CCM_NS Structure                                                          */
  __OM  uint32_t  TASKS_KSGEN;                  /*!< Start generation of keystream. This operation will stop by itself
                                                     when completed.                                                           */
  __OM  uint32_t  TASKS_CRYPT;                  /*!< Start encryption/decryption. This operation will stop by itself
                                                     when completed.                                                           */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop encryption/decryption                                                */
  __OM  uint32_t  TASKS_RATEOVERRIDE;           /*!< Override DATARATE setting in MODE register with the contents
                                                     of the RATEOVERRIDE register for any ongoing encryption/decryption        */
  __IM  uint32_t  RESERVED[28];
  __IOM uint32_t  SUBSCRIBE_KSGEN;              /*!< Subscribe configuration for task KSGEN                                    */
  __IOM uint32_t  SUBSCRIBE_CRYPT;              /*!< Subscribe configuration for task CRYPT                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_RATEOVERRIDE;       /*!< Subscribe configuration for task RATEOVERRIDE                             */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  EVENTS_ENDKSGEN;              /*!< Keystream generation complete                                             */
  __IOM uint32_t  EVENTS_ENDCRYPT;              /*!< Encrypt/decrypt complete                                                  */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Deprecated register - CCM error event                                     */
  __IM  uint32_t  RESERVED2[29];
  __IOM uint32_t  PUBLISH_ENDKSGEN;             /*!< Publish configuration for event ENDKSGEN                                  */
  __IOM uint32_t  PUBLISH_ENDCRYPT;             /*!< Publish configuration for event ENDCRYPT                                  */
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Deprecated register - Publish configuration for event ERROR               */
  __IM  uint32_t  RESERVED3[29];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED4[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[61];
  __IM  uint32_t  MICSTATUS;                    /*!< MIC check result                                                          */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable                                                                    */
  __IOM uint32_t  MODE;                         /*!< Operation mode                                                            */
  __IOM uint32_t  CNFPTR;                       /*!< Pointer to data structure holding the AES key and the NONCE
                                                     vector                                                                    */
  __IOM uint32_t  INPTR;                        /*!< Input pointer                                                             */
  __IOM uint32_t  OUTPTR;                       /*!< Output pointer                                                            */
  __IOM uint32_t  SCRATCHPTR;                   /*!< Pointer to data area used for temporary storage                           */
  __IOM uint32_t  MAXPACKETSIZE;                /*!< Length of keystream generated when MODE.LENGTH = Extended                 */
  __IOM uint32_t  RATEOVERRIDE;                 /*!< Data rate override setting.                                               */
  __IOM uint32_t  HEADERMASK;                   /*!< Header (S0) mask.                                                         */
} NRF_CCM_Type;                                 /*!< Size = 1316 (0x524)                                                       */



/* =========================================================================================================================== */
/* ================                                         DPPIC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Distributed programmable peripheral interconnect controller (DPPIC_NS)
  */

typedef struct {                                /*!< DPPIC_NS Structure                                                        */
  __OM  DPPIC_TASKS_CHG_Type TASKS_CHG[6];      /*!< Channel group tasks                                                       */
  __IM  uint32_t  RESERVED[20];
  __IOM DPPIC_SUBSCRIBE_CHG_Type SUBSCRIBE_CHG[6];/*!< Subscribe configuration for tasks                                       */
  __IM  uint32_t  RESERVED1[276];
  __IOM uint32_t  CHEN;                         /*!< Channel enable register                                                   */
  __IOM uint32_t  CHENSET;                      /*!< Channel enable set register                                               */
  __IOM uint32_t  CHENCLR;                      /*!< Channel enable clear register                                             */
  __IM  uint32_t  RESERVED2[189];
  __IOM uint32_t  CHG[6];                       /*!< Description collection: Channel group n Note: Writes to this
                                                     register are ignored if either SUBSCRIBE_CHG[n].EN or SUBSCRIBE_CHG[n].DI
                                                     is enabled                                                                */
} NRF_DPPIC_Type;                               /*!< Size = 2072 (0x818)                                                       */



/* =========================================================================================================================== */
/* ================                                          TEMP_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor (TEMP_NS)
  */

typedef struct {                                /*!< TEMP_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Start temperature measurement                                             */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop temperature measurement                                              */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_DATARDY;               /*!< Temperature measurement complete, data ready                              */
  __IM  uint32_t  RESERVED2[31];
  __IOM uint32_t  PUBLISH_DATARDY;              /*!< Publish configuration for event DATARDY                                   */
  __IM  uint32_t  RESERVED3[96];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[127];
  __IM  int32_t   TEMP;                         /*!< Temperature in degC (0.25deg steps)                                       */
  __IM  uint32_t  RESERVED5[5];
  __IOM uint32_t  A0;                           /*!< Slope of first piecewise linear function                                  */
  __IOM uint32_t  A1;                           /*!< Slope of second piecewise linear function                                 */
  __IOM uint32_t  A2;                           /*!< Slope of third piecewise linear function                                  */
  __IOM uint32_t  A3;                           /*!< Slope of fourth piecewise linear function                                 */
  __IOM uint32_t  A4;                           /*!< Slope of fifth piecewise linear function                                  */
  __IOM uint32_t  A5;                           /*!< Slope of sixth piecewise linear function                                  */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  B0;                           /*!< y-intercept of first piecewise linear function                            */
  __IOM uint32_t  B1;                           /*!< y-intercept of second piecewise linear function                           */
  __IOM uint32_t  B2;                           /*!< y-intercept of third piecewise linear function                            */
  __IOM uint32_t  B3;                           /*!< y-intercept of fourth piecewise linear function                           */
  __IOM uint32_t  B4;                           /*!< y-intercept of fifth piecewise linear function                            */
  __IOM uint32_t  B5;                           /*!< y-intercept of sixth piecewise linear function                            */
  __IM  uint32_t  RESERVED7[2];
  __IOM uint32_t  T0;                           /*!< Endpoint of first piecewise linear function                               */
  __IOM uint32_t  T1;                           /*!< Endpoint of second piecewise linear function                              */
  __IOM uint32_t  T2;                           /*!< Endpoint of third piecewise linear function                               */
  __IOM uint32_t  T3;                           /*!< Endpoint of fourth piecewise linear function                              */
  __IOM uint32_t  T4;                           /*!< Endpoint of fifth piecewise linear function                               */
} NRF_TEMP_Type;                                /*!< Size = 1396 (0x574)                                                       */



/* =========================================================================================================================== */
/* ================                                          RTC0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-time counter 0 (RTC0_NS)
  */

typedef struct {                                /*!< RTC0_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Start RTC counter                                                         */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop RTC counter                                                          */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear RTC counter                                                         */
  __OM  uint32_t  TASKS_TRIGOVRFLW;             /*!< Set counter to 0xFFFFF0                                                   */
  __IM  uint32_t  RESERVED[12];
  __OM  uint32_t  TASKS_CAPTURE[4];             /*!< Description collection: Capture RTC counter to CC[n] register             */
  __IM  uint32_t  RESERVED1[12];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_CLEAR;              /*!< Subscribe configuration for task CLEAR                                    */
  __IOM uint32_t  SUBSCRIBE_TRIGOVRFLW;         /*!< Subscribe configuration for task TRIGOVRFLW                               */
  __IM  uint32_t  RESERVED2[12];
  __IOM uint32_t  SUBSCRIBE_CAPTURE[4];         /*!< Description collection: Subscribe configuration for task CAPTURE[n]       */
  __IM  uint32_t  RESERVED3[12];
  __IOM uint32_t  EVENTS_TICK;                  /*!< Event on counter increment                                                */
  __IOM uint32_t  EVENTS_OVRFLW;                /*!< Event on counter overflow                                                 */
  __IM  uint32_t  RESERVED4[14];
  __IOM uint32_t  EVENTS_COMPARE[4];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED5[12];
  __IOM uint32_t  PUBLISH_TICK;                 /*!< Publish configuration for event TICK                                      */
  __IOM uint32_t  PUBLISH_OVRFLW;               /*!< Publish configuration for event OVRFLW                                    */
  __IM  uint32_t  RESERVED6[14];
  __IOM uint32_t  PUBLISH_COMPARE[4];           /*!< Description collection: Publish configuration for event COMPARE[n]        */
  __IM  uint32_t  RESERVED7[12];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED8[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED9[13];
  __IOM uint32_t  EVTEN;                        /*!< Enable or disable event routing                                           */
  __IOM uint32_t  EVTENSET;                     /*!< Enable event routing                                                      */
  __IOM uint32_t  EVTENCLR;                     /*!< Disable event routing                                                     */
  __IM  uint32_t  RESERVED10[110];
  __IM  uint32_t  COUNTER;                      /*!< Current counter value                                                     */
  __IOM uint32_t  PRESCALER;                    /*!< 12-bit prescaler for counter frequency (32768 / (PRESCALER +
                                                     1)). Must be written when RTC is stopped.                                 */
  __IM  uint32_t  RESERVED11[13];
  __IOM uint32_t  CC[4];                        /*!< Description collection: Compare register n                                */
} NRF_RTC_Type;                                 /*!< Size = 1360 (0x550)                                                       */



/* =========================================================================================================================== */
/* ================                                          IPC_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Interprocessor communication (IPC_NS)
  */

typedef struct {                                /*!< IPC_NS Structure                                                          */
  __OM  uint32_t  TASKS_SEND[16];               /*!< Description collection: Trigger events on IPC channel enabled
                                                     in SEND_CNF[n]                                                            */
  __IM  uint32_t  RESERVED[16];
  __IOM uint32_t  SUBSCRIBE_SEND[16];           /*!< Description collection: Subscribe configuration for task SEND[n]          */
  __IM  uint32_t  RESERVED1[16];
  __IOM uint32_t  EVENTS_RECEIVE[16];           /*!< Description collection: Event received on one or more of the
                                                     enabled IPC channels in RECEIVE_CNF[n]                                    */
  __IM  uint32_t  RESERVED2[16];
  __IOM uint32_t  PUBLISH_RECEIVE[16];          /*!< Description collection: Publish configuration for event RECEIVE[n]        */
  __IM  uint32_t  RESERVED3[80];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED4[128];
  __IOM uint32_t  SEND_CNF[16];                 /*!< Description collection: Send event configuration for TASKS_SEND[n]        */
  __IM  uint32_t  RESERVED5[16];
  __IOM uint32_t  RECEIVE_CNF[16];              /*!< Description collection: Receive event configuration for EVENTS_RECEIVE[n] */
  __IM  uint32_t  RESERVED6[16];
  __IOM uint32_t  GPMEM[2];                     /*!< Description collection: General purpose memory                            */
} NRF_IPC_Type;                                 /*!< Size = 1560 (0x618)                                                       */



/* =========================================================================================================================== */
/* ================                                         SPIM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Peripheral Interface Master with EasyDMA (SPIM0_NS)
  */

typedef struct {                                /*!< SPIM0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_START;                  /*!< Start SPI transaction                                                     */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop SPI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend SPI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume SPI transaction                                                    */
  __IM  uint32_t  RESERVED2[27];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED4[24];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< SPI transaction has stopped                                               */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  EVENTS_END;                   /*!< End of RXD buffer and TXD buffer reached                                  */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< End of TXD buffer reached                                                 */
  __IM  uint32_t  RESERVED8[10];
  __IOM uint32_t  EVENTS_STARTED;               /*!< Transaction started                                                       */
  __IM  uint32_t  RESERVED9[13];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED11;
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED12;
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IM  uint32_t  RESERVED13[10];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IM  uint32_t  RESERVED14[12];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED15[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED16[61];
  __IOM uint32_t  STALLSTAT;                    /*!< Stall status for EasyDMA RAM accesses. The fields in this register
                                                     are set to STALL by hardware whenever a stall occurres
                                                     and can be cleared (set to NOSTALL) by the CPU.                           */
  __IM  uint32_t  RESERVED17[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPIM                                                               */
  __IM  uint32_t  RESERVED18;
  __IOM SPIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED19[3];
  __IOM uint32_t  FREQUENCY;                    /*!< SPI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED20[3];
  __IOM SPIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM SPIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED21[2];
  __IOM SPIM_IFTIMING_Type IFTIMING;            /*!< Unspecified                                                               */
  __IOM uint32_t  CSNPOL;                       /*!< Polarity of CSN output                                                    */
  __IOM uint32_t  PSELDCX;                      /*!< Pin select for DCX signal                                                 */
  __IOM uint32_t  DCXCNT;                       /*!< DCX configuration                                                         */
  __IM  uint32_t  RESERVED22[19];
  __IOM uint32_t  ORC;                          /*!< Byte transmitted after TXD.MAXCNT bytes have been transmitted
                                                     in the case when RXD.MAXCNT is greater than TXD.MAXCNT                    */
} NRF_SPIM_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         SPIS0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief SPI Slave (SPIS0_NS)
  */

typedef struct {                                /*!< SPIS0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[9];
  __OM  uint32_t  TASKS_ACQUIRE;                /*!< Acquire SPI semaphore                                                     */
  __OM  uint32_t  TASKS_RELEASE;                /*!< Release SPI semaphore, enabling the SPI slave to acquire it               */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  SUBSCRIBE_ACQUIRE;            /*!< Subscribe configuration for task ACQUIRE                                  */
  __IOM uint32_t  SUBSCRIBE_RELEASE;            /*!< Subscribe configuration for task RELEASE                                  */
  __IM  uint32_t  RESERVED2[22];
  __IOM uint32_t  EVENTS_END;                   /*!< Granted transaction completed                                             */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED4[5];
  __IOM uint32_t  EVENTS_ACQUIRED;              /*!< Semaphore acquired                                                        */
  __IM  uint32_t  RESERVED5[22];
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED7[5];
  __IOM uint32_t  PUBLISH_ACQUIRED;             /*!< Publish configuration for event ACQUIRED                                  */
  __IM  uint32_t  RESERVED8[21];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED9[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED10[61];
  __IM  uint32_t  SEMSTAT;                      /*!< Semaphore status register                                                 */
  __IM  uint32_t  RESERVED11[15];
  __IOM uint32_t  STATUS;                       /*!< Status from last transaction                                              */
  __IM  uint32_t  RESERVED12[47];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPI slave                                                          */
  __IM  uint32_t  RESERVED13;
  __IOM SPIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED14[7];
  __IOM SPIS_RXD_Type RXD;                      /*!< Unspecified                                                               */
  __IOM SPIS_TXD_Type TXD;                      /*!< Unspecified                                                               */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED15;
  __IOM uint32_t  DEF;                          /*!< Default character. Character clocked out in case of an ignored
                                                     transaction.                                                              */
  __IM  uint32_t  RESERVED16[24];
  __IOM uint32_t  ORC;                          /*!< Over-read character                                                       */
} NRF_SPIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         TWIM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Master Interface with EasyDMA (TWIM0_NS)
  */

typedef struct {                                /*!< TWIM0_NS Structure                                                        */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start TWI receive sequence                                                */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start TWI transmit sequence                                               */
  __IM  uint32_t  RESERVED1[2];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction. Must be issued while the TWI master is
                                                     not suspended.                                                            */
  __IM  uint32_t  RESERVED2;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  SUBSCRIBE_STARTRX;            /*!< Subscribe configuration for task STARTRX                                  */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED7[24];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED8[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED9[8];
  __IOM uint32_t  EVENTS_SUSPENDED;             /*!< SUSPEND task has been issued, TWI traffic is now suspended.               */
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  EVENTS_LASTRX;                /*!< Byte boundary, starting to receive the last byte                          */
  __IOM uint32_t  EVENTS_LASTTX;                /*!< Byte boundary, starting to transmit the last byte                         */
  __IM  uint32_t  RESERVED11[8];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED12[7];
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED13[8];
  __IOM uint32_t  PUBLISH_SUSPENDED;            /*!< Publish configuration for event SUSPENDED                                 */
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED14[2];
  __IOM uint32_t  PUBLISH_LASTRX;               /*!< Publish configuration for event LASTRX                                    */
  __IOM uint32_t  PUBLISH_LASTTX;               /*!< Publish configuration for event LASTTX                                    */
  __IM  uint32_t  RESERVED15[7];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED16[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED17[110];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED18[14];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIM                                                               */
  __IM  uint32_t  RESERVED19;
  __IOM TWIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20[5];
  __IOM uint32_t  FREQUENCY;                    /*!< TWI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED21[3];
  __IOM TWIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED22[13];
  __IOM uint32_t  ADDRESS;                      /*!< Address used in the TWI transfer                                          */
} NRF_TWIM_Type;                                /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                         TWIS0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Slave Interface with EasyDMA (TWIS0_NS)
  */

typedef struct {                                /*!< TWIS0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[5];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED2[3];
  __OM  uint32_t  TASKS_PREPARERX;              /*!< Prepare the TWI slave to respond to a write command                       */
  __OM  uint32_t  TASKS_PREPARETX;              /*!< Prepare the TWI slave to respond to a read command                        */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  SUBSCRIBE_PREPARERX;          /*!< Subscribe configuration for task PREPARERX                                */
  __IOM uint32_t  SUBSCRIBE_PREPARETX;          /*!< Subscribe configuration for task PREPARETX                                */
  __IM  uint32_t  RESERVED6[19];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED7[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED8[9];
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED9[4];
  __IOM uint32_t  EVENTS_WRITE;                 /*!< Write command received                                                    */
  __IOM uint32_t  EVENTS_READ;                  /*!< Read command received                                                     */
  __IM  uint32_t  RESERVED10[6];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED11[7];
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED12[9];
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED13[4];
  __IOM uint32_t  PUBLISH_WRITE;                /*!< Publish configuration for event WRITE                                     */
  __IOM uint32_t  PUBLISH_READ;                 /*!< Publish configuration for event READ                                      */
  __IM  uint32_t  RESERVED14[5];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED15[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED16[113];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  MATCH;                        /*!< Status register indicating which address had a match                      */
  __IM  uint32_t  RESERVED17[10];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIS                                                               */
  __IM  uint32_t  RESERVED18;
  __IOM TWIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED19[9];
  __IOM TWIS_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIS_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED20[13];
  __IOM uint32_t  ADDRESS[2];                   /*!< Description collection: TWI slave address n                               */
  __IM  uint32_t  RESERVED21;
  __IOM uint32_t  CONFIG;                       /*!< Configuration register for the address match mechanism                    */
  __IM  uint32_t  RESERVED22[10];
  __IOM uint32_t  ORC;                          /*!< Over-read character. Character sent out in case of an over-read
                                                     of the transmit buffer.                                                   */
} NRF_TWIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         UARTE0_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief UART with EasyDMA (UARTE0_NS)
  */

typedef struct {                                /*!< UARTE0_NS Structure                                                       */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start UART receiver                                                       */
  __OM  uint32_t  TASKS_STOPRX;                 /*!< Stop UART receiver                                                        */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start UART transmitter                                                    */
  __OM  uint32_t  TASKS_STOPTX;                 /*!< Stop UART transmitter                                                     */
  __IM  uint32_t  RESERVED[7];
  __OM  uint32_t  TASKS_FLUSHRX;                /*!< Flush RX FIFO into RX buffer                                              */
  __IM  uint32_t  RESERVED1[20];
  __IOM uint32_t  SUBSCRIBE_STARTRX;            /*!< Subscribe configuration for task STARTRX                                  */
  __IOM uint32_t  SUBSCRIBE_STOPRX;             /*!< Subscribe configuration for task STOPRX                                   */
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IOM uint32_t  SUBSCRIBE_STOPTX;             /*!< Subscribe configuration for task STOPTX                                   */
  __IM  uint32_t  RESERVED2[7];
  __IOM uint32_t  SUBSCRIBE_FLUSHRX;            /*!< Subscribe configuration for task FLUSHRX                                  */
  __IM  uint32_t  RESERVED3[20];
  __IOM uint32_t  EVENTS_CTS;                   /*!< CTS is activated (set low). Clear To Send.                                */
  __IOM uint32_t  EVENTS_NCTS;                  /*!< CTS is deactivated (set high). Not Clear To Send.                         */
  __IOM uint32_t  EVENTS_RXDRDY;                /*!< Data received in RXD (but potentially not yet transferred to
                                                     Data RAM)                                                                 */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< Receive buffer is filled up                                               */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  EVENTS_TXDRDY;                /*!< Data sent from TXD                                                        */
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< Last TX byte transmitted                                                  */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Error detected                                                            */
  __IM  uint32_t  RESERVED6[7];
  __IOM uint32_t  EVENTS_RXTO;                  /*!< Receiver timeout                                                          */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< UART receiver has started                                                 */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< UART transmitter has started                                              */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  EVENTS_TXSTOPPED;             /*!< Transmitter stopped                                                       */
  __IM  uint32_t  RESERVED9[9];
  __IOM uint32_t  PUBLISH_CTS;                  /*!< Publish configuration for event CTS                                       */
  __IOM uint32_t  PUBLISH_NCTS;                 /*!< Publish configuration for event NCTS                                      */
  __IOM uint32_t  PUBLISH_RXDRDY;               /*!< Publish configuration for event RXDRDY                                    */
  __IM  uint32_t  RESERVED10;
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED11[2];
  __IOM uint32_t  PUBLISH_TXDRDY;               /*!< Publish configuration for event TXDRDY                                    */
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED12[7];
  __IOM uint32_t  PUBLISH_RXTO;                 /*!< Publish configuration for event RXTO                                      */
  __IM  uint32_t  RESERVED13;
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED14;
  __IOM uint32_t  PUBLISH_TXSTOPPED;            /*!< Publish configuration for event TXSTOPPED                                 */
  __IM  uint32_t  RESERVED15[9];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED16[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED17[93];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED18[31];
  __IOM uint32_t  ENABLE;                       /*!< Enable UART                                                               */
  __IM  uint32_t  RESERVED19;
  __IOM UARTE_PSEL_Type PSEL;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20[3];
  __IOM uint32_t  BAUDRATE;                     /*!< Baud rate. Accuracy depends on the HFCLK source selected.                 */
  __IM  uint32_t  RESERVED21[3];
  __IOM UARTE_RXD_Type RXD;                     /*!< RXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED22;
  __IOM UARTE_TXD_Type TXD;                     /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED23[7];
  __IOM uint32_t  CONFIG;                       /*!< Configuration of parity and hardware flow control                         */
} NRF_UARTE_Type;                               /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                          EGU0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Event generator unit (EGU0_NS)
  */

typedef struct {                                /*!< EGU0_NS Structure                                                         */
  __OM  uint32_t  TASKS_TRIGGER[16];            /*!< Description collection: Trigger n for triggering the corresponding
                                                     TRIGGERED[n] event                                                        */
  __IM  uint32_t  RESERVED[16];
  __IOM uint32_t  SUBSCRIBE_TRIGGER[16];        /*!< Description collection: Subscribe configuration for task TRIGGER[n]       */
  __IM  uint32_t  RESERVED1[16];
  __IOM uint32_t  EVENTS_TRIGGERED[16];         /*!< Description collection: Event number n generated by triggering
                                                     the corresponding TRIGGER[n] task                                         */
  __IM  uint32_t  RESERVED2[16];
  __IOM uint32_t  PUBLISH_TRIGGERED[16];        /*!< Description collection: Publish configuration for event TRIGGERED[n]      */
  __IM  uint32_t  RESERVED3[80];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
} NRF_EGU_Type;                                 /*!< Size = 780 (0x30c)                                                        */



/* =========================================================================================================================== */
/* ================                                          SWI0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Software interrupt 0 (SWI0_NS)
  */

typedef struct {                                /*!< SWI0_NS Structure                                                         */
  __IM  uint32_t  UNUSED;                       /*!< Unused.                                                                   */
} NRF_SWI_Type;                                 /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                        APPMUTEX_NS                                        ================ */
/* =========================================================================================================================== */


/**
  * @brief MUTEX 0 (APPMUTEX_NS)
  */

typedef struct {                                /*!< APPMUTEX_NS Structure                                                     */
  __IM  uint32_t  RESERVED[256];
  __IOM uint32_t  MUTEX[16];                    /*!< Description collection: Mutex register                                    */
} NRF_MUTEX_Type;                               /*!< Size = 1088 (0x440)                                                       */



/* =========================================================================================================================== */
/* ================                                          ACL_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Access control lists (ACL_NS)
  */

typedef struct {                                /*!< ACL_NS Structure                                                          */
  __IM  uint32_t  RESERVED[512];
  __IOM ACL_ACL_Type ACL[8];                    /*!< Unspecified                                                               */
} NRF_ACL_Type;                                 /*!< Size = 2176 (0x880)                                                       */



/* =========================================================================================================================== */
/* ================                                          NVMC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Non-volatile memory controller (NVMC_NS)
  */

typedef struct {                                /*!< NVMC_NS Structure                                                         */
  __IM  uint32_t  RESERVED[256];
  __IM  uint32_t  READY;                        /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED1;
  __IM  uint32_t  READYNEXT;                    /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED2[62];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED3;
  __OM  uint32_t  ERASEALL;                     /*!< Register for erasing all non-volatile user memory                         */
  __IM  uint32_t  RESERVED4[3];
  __IOM uint32_t  ERASEPAGEPARTIALCFG;          /*!< Register for partial erase configuration                                  */
  __IM  uint32_t  RESERVED5[8];
  __IOM uint32_t  ICACHECNF;                    /*!< I-code cache configuration register                                       */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  IHIT;                         /*!< I-code cache hit counter                                                  */
  __IOM uint32_t  IMISS;                        /*!< I-code cache miss counter                                                 */
} NRF_NVMC_Type;                                /*!< Size = 1360 (0x550)                                                       */



/* =========================================================================================================================== */
/* ================                                          VMC_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Volatile Memory controller (VMC_NS)
  */

typedef struct {                                /*!< VMC_NS Structure                                                          */
  __IM  uint32_t  RESERVED[384];
  __IOM VMC_RAM_Type RAM[4];                    /*!< Unspecified                                                               */
} NRF_VMC_Type;                                 /*!< Size = 1600 (0x640)                                                       */



/* =========================================================================================================================== */
/* ================                                           P0_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Port 0 (P0_NS)
  */

typedef struct {                                /*!< P0_NS Structure                                                           */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  OUT;                          /*!< Write GPIO port                                                           */
  __IOM uint32_t  OUTSET;                       /*!< Set individual bits in GPIO port                                          */
  __IOM uint32_t  OUTCLR;                       /*!< Clear individual bits in GPIO port                                        */
  __IM  uint32_t  IN;                           /*!< Read GPIO port                                                            */
  __IOM uint32_t  DIR;                          /*!< Direction of GPIO pins                                                    */
  __IOM uint32_t  DIRSET;                       /*!< DIR set register                                                          */
  __IOM uint32_t  DIRCLR;                       /*!< DIR clear register                                                        */
  __IOM uint32_t  LATCH;                        /*!< Latch register indicating what GPIO pins that have met the criteria
                                                     set in the PIN_CNF[n].SENSE registers                                     */
  __IOM uint32_t  DETECTMODE;                   /*!< Select between default DETECT signal behavior and LDETECT mode
                                                     (For non-secure pin only)                                                 */
  __IOM uint32_t  DETECTMODE_SEC;               /*!< Select between default DETECT signal behavior and LDETECT mode
                                                     (For secure pin only)                                                     */
  __IM  uint32_t  RESERVED1[117];
  __IOM uint32_t  PIN_CNF[32];                  /*!< Description collection: Configuration of GPIO pins                        */
} NRF_GPIO_Type;                                /*!< Size = 640 (0x280)                                                        */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define NRF_FICR_NS_BASE            0x01FF0000UL
#define NRF_UICR_NS_BASE            0x01FF8000UL
#define NRF_CTI_NS_BASE             0xE0042000UL
#define NRF_DCNF_NS_BASE            0x41000000UL
#define NRF_VREQCTRL_NS_BASE        0x41004000UL
#define NRF_CLOCK_NS_BASE           0x41005000UL
#define NRF_POWER_NS_BASE           0x41005000UL
#define NRF_RESET_NS_BASE           0x41005000UL
#define NRF_CTRLAP_NS_BASE          0x41006000UL
#define NRF_RADIO_NS_BASE           0x41008000UL
#define NRF_RNG_NS_BASE             0x41009000UL
#define NRF_GPIOTE_NS_BASE          0x4100A000UL
#define NRF_WDT_NS_BASE             0x4100B000UL
#define NRF_TIMER0_NS_BASE          0x4100C000UL
#define NRF_ECB_NS_BASE             0x4100D000UL
#define NRF_AAR_NS_BASE             0x4100E000UL
#define NRF_CCM_NS_BASE             0x4100E000UL
#define NRF_DPPIC_NS_BASE           0x4100F000UL
#define NRF_TEMP_NS_BASE            0x41010000UL
#define NRF_RTC0_NS_BASE            0x41011000UL
#define NRF_IPC_NS_BASE             0x41012000UL
#define NRF_SPIM0_NS_BASE           0x41013000UL
#define NRF_SPIS0_NS_BASE           0x41013000UL
#define NRF_TWIM0_NS_BASE           0x41013000UL
#define NRF_TWIS0_NS_BASE           0x41013000UL
#define NRF_UARTE0_NS_BASE          0x41013000UL
#define NRF_EGU0_NS_BASE            0x41014000UL
#define NRF_RTC1_NS_BASE            0x41016000UL
#define NRF_TIMER1_NS_BASE          0x41018000UL
#define NRF_TIMER2_NS_BASE          0x41019000UL
#define NRF_SWI0_NS_BASE            0x4101A000UL
#define NRF_SWI1_NS_BASE            0x4101B000UL
#define NRF_SWI2_NS_BASE            0x4101C000UL
#define NRF_SWI3_NS_BASE            0x4101D000UL
#define NRF_APPMUTEX_NS_BASE        0x40030000UL
#define NRF_APPMUTEX_S_BASE         0x50030000UL
#define NRF_ACL_NS_BASE             0x41080000UL
#define NRF_NVMC_NS_BASE            0x41080000UL
#define NRF_VMC_NS_BASE             0x41081000UL
#define NRF_P0_NS_BASE              0x418C0500UL
#define NRF_P1_NS_BASE              0x418C0800UL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define NRF_FICR_NS                 ((NRF_FICR_Type*)          NRF_FICR_NS_BASE)
#define NRF_UICR_NS                 ((NRF_UICR_Type*)          NRF_UICR_NS_BASE)
#define NRF_CTI_NS                  ((NRF_CTI_Type*)           NRF_CTI_NS_BASE)
#define NRF_DCNF_NS                 ((NRF_DCNF_Type*)          NRF_DCNF_NS_BASE)
#define NRF_VREQCTRL_NS             ((NRF_VREQCTRL_Type*)      NRF_VREQCTRL_NS_BASE)
#define NRF_CLOCK_NS                ((NRF_CLOCK_Type*)         NRF_CLOCK_NS_BASE)
#define NRF_POWER_NS                ((NRF_POWER_Type*)         NRF_POWER_NS_BASE)
#define NRF_RESET_NS                ((NRF_RESET_Type*)         NRF_RESET_NS_BASE)
#define NRF_CTRLAP_NS               ((NRF_CTRLAPPERI_Type*)    NRF_CTRLAP_NS_BASE)
#define NRF_RADIO_NS                ((NRF_RADIO_Type*)         NRF_RADIO_NS_BASE)
#define NRF_RNG_NS                  ((NRF_RNG_Type*)           NRF_RNG_NS_BASE)
#define NRF_GPIOTE_NS               ((NRF_GPIOTE_Type*)        NRF_GPIOTE_NS_BASE)
#define NRF_WDT_NS                  ((NRF_WDT_Type*)           NRF_WDT_NS_BASE)
#define NRF_TIMER0_NS               ((NRF_TIMER_Type*)         NRF_TIMER0_NS_BASE)
#define NRF_ECB_NS                  ((NRF_ECB_Type*)           NRF_ECB_NS_BASE)
#define NRF_AAR_NS                  ((NRF_AAR_Type*)           NRF_AAR_NS_BASE)
#define NRF_CCM_NS                  ((NRF_CCM_Type*)           NRF_CCM_NS_BASE)
#define NRF_DPPIC_NS                ((NRF_DPPIC_Type*)         NRF_DPPIC_NS_BASE)
#define NRF_TEMP_NS                 ((NRF_TEMP_Type*)          NRF_TEMP_NS_BASE)
#define NRF_RTC0_NS                 ((NRF_RTC_Type*)           NRF_RTC0_NS_BASE)
#define NRF_IPC_NS                  ((NRF_IPC_Type*)           NRF_IPC_NS_BASE)
#define NRF_SPIM0_NS                ((NRF_SPIM_Type*)          NRF_SPIM0_NS_BASE)
#define NRF_SPIS0_NS                ((NRF_SPIS_Type*)          NRF_SPIS0_NS_BASE)
#define NRF_TWIM0_NS                ((NRF_TWIM_Type*)          NRF_TWIM0_NS_BASE)
#define NRF_TWIS0_NS                ((NRF_TWIS_Type*)          NRF_TWIS0_NS_BASE)
#define NRF_UARTE0_NS               ((NRF_UARTE_Type*)         NRF_UARTE0_NS_BASE)
#define NRF_EGU0_NS                 ((NRF_EGU_Type*)           NRF_EGU0_NS_BASE)
#define NRF_RTC1_NS                 ((NRF_RTC_Type*)           NRF_RTC1_NS_BASE)
#define NRF_TIMER1_NS               ((NRF_TIMER_Type*)         NRF_TIMER1_NS_BASE)
#define NRF_TIMER2_NS               ((NRF_TIMER_Type*)         NRF_TIMER2_NS_BASE)
#define NRF_SWI0_NS                 ((NRF_SWI_Type*)           NRF_SWI0_NS_BASE)
#define NRF_SWI1_NS                 ((NRF_SWI_Type*)           NRF_SWI1_NS_BASE)
#define NRF_SWI2_NS                 ((NRF_SWI_Type*)           NRF_SWI2_NS_BASE)
#define NRF_SWI3_NS                 ((NRF_SWI_Type*)           NRF_SWI3_NS_BASE)
#define NRF_APPMUTEX_NS             ((NRF_MUTEX_Type*)         NRF_APPMUTEX_NS_BASE)
#define NRF_APPMUTEX_S              ((NRF_MUTEX_Type*)         NRF_APPMUTEX_S_BASE)
#define NRF_ACL_NS                  ((NRF_ACL_Type*)           NRF_ACL_NS_BASE)
#define NRF_NVMC_NS                 ((NRF_NVMC_Type*)          NRF_NVMC_NS_BASE)
#define NRF_VMC_NS                  ((NRF_VMC_Type*)           NRF_VMC_NS_BASE)
#define NRF_P0_NS                   ((NRF_GPIO_Type*)          NRF_P0_NS_BASE)
#define NRF_P1_NS                   ((NRF_GPIO_Type*)          NRF_P1_NS_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


#ifdef __cplusplus
}
#endif

#endif /* NRF5340_NETWORK_H */


/** @} */ /* End of group nrf5340_network */

/** @} */ /* End of group Nordic Semiconductor */
