/*
Copyright (c) 2010 - 2023, Nordic Semiconductor ASA All rights reserved.

SPDX-License-Identifier: BSD-3-Clause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. Neither the name of Nordic Semiconductor ASA nor the names of its
   contributors may be used to endorse or promote products derived from this
   software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL NORDIC SEMICONDUCTOR ASA OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
 *
 * @file     /jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/_generated/Header/nrf5340_application.h
 * @brief    CMSIS HeaderFile
 * @version  1
 * @date     Thu Mar 23 14:54:55 2023
 * @note     Generated by SVDConv V3.3.44
 *           from File '/jenkins_workspace/workspace/SAG_Tools_nRFMDK_Build_master/source/files/svd/external/nrf5340_application.svd',
 *           last modified on Thu Mar 23 14:54:25 2023
 */


/** @addtogroup Nordic Semiconductor
  * @{
  */


/** @addtogroup nrf5340_application
  * @{
  */


#ifndef NRF5340_APPLICATION_H
#define NRF5340_APPLICATION_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M33 Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  MemoryManagement_IRQn     = -12,              /*!< -12  Memory Management, MPU mismatch, including Access Violation
                                                     and No Match                                                              */
  BusFault_IRQn             = -11,              /*!< -11  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                     related Fault                                                             */
  UsageFault_IRQn           = -10,              /*!< -10  Usage Fault, i.e. Undef Instruction, Illegal State Transition        */
  SecureFault_IRQn          =  -9,              /*!< -9 Secure Fault Handler                                                   */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  DebugMonitor_IRQn         =  -4,              /*!< -4 Debug Monitor                                                          */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* ====================================  nrf5340_application Specific Interrupt Numbers  ===================================== */
  FPU_IRQn                  =   0,              /*!< 0  FPU                                                                    */
  CACHE_IRQn                =   1,              /*!< 1  CACHE                                                                  */
  SPU_IRQn                  =   3,              /*!< 3  SPU                                                                    */
  CLOCK_POWER_IRQn          =   5,              /*!< 5  CLOCK_POWER                                                            */
  SERIAL0_IRQn              =   8,              /*!< 8  SERIAL0                                                                */
  SERIAL1_IRQn              =   9,              /*!< 9  SERIAL1                                                                */
  SPIM4_IRQn                =  10,              /*!< 10 SPIM4                                                                  */
  SERIAL2_IRQn              =  11,              /*!< 11 SERIAL2                                                                */
  SERIAL3_IRQn              =  12,              /*!< 12 SERIAL3                                                                */
  GPIOTE0_IRQn              =  13,              /*!< 13 GPIOTE0                                                                */
  SAADC_IRQn                =  14,              /*!< 14 SAADC                                                                  */
  TIMER0_IRQn               =  15,              /*!< 15 TIMER0                                                                 */
  TIMER1_IRQn               =  16,              /*!< 16 TIMER1                                                                 */
  TIMER2_IRQn               =  17,              /*!< 17 TIMER2                                                                 */
  RTC0_IRQn                 =  20,              /*!< 20 RTC0                                                                   */
  RTC1_IRQn                 =  21,              /*!< 21 RTC1                                                                   */
  WDT0_IRQn                 =  24,              /*!< 24 WDT0                                                                   */
  WDT1_IRQn                 =  25,              /*!< 25 WDT1                                                                   */
  COMP_LPCOMP_IRQn          =  26,              /*!< 26 COMP_LPCOMP                                                            */
  EGU0_IRQn                 =  27,              /*!< 27 EGU0                                                                   */
  EGU1_IRQn                 =  28,              /*!< 28 EGU1                                                                   */
  EGU2_IRQn                 =  29,              /*!< 29 EGU2                                                                   */
  EGU3_IRQn                 =  30,              /*!< 30 EGU3                                                                   */
  EGU4_IRQn                 =  31,              /*!< 31 EGU4                                                                   */
  EGU5_IRQn                 =  32,              /*!< 32 EGU5                                                                   */
  PWM0_IRQn                 =  33,              /*!< 33 PWM0                                                                   */
  PWM1_IRQn                 =  34,              /*!< 34 PWM1                                                                   */
  PWM2_IRQn                 =  35,              /*!< 35 PWM2                                                                   */
  PWM3_IRQn                 =  36,              /*!< 36 PWM3                                                                   */
  PDM0_IRQn                 =  38,              /*!< 38 PDM0                                                                   */
  I2S0_IRQn                 =  40,              /*!< 40 I2S0                                                                   */
  IPC_IRQn                  =  42,              /*!< 42 IPC                                                                    */
  QSPI_IRQn                 =  43,              /*!< 43 QSPI                                                                   */
  NFCT_IRQn                 =  45,              /*!< 45 NFCT                                                                   */
  GPIOTE1_IRQn              =  47,              /*!< 47 GPIOTE1                                                                */
  QDEC0_IRQn                =  51,              /*!< 51 QDEC0                                                                  */
  QDEC1_IRQn                =  52,              /*!< 52 QDEC1                                                                  */
  USBD_IRQn                 =  54,              /*!< 54 USBD                                                                   */
  USBREGULATOR_IRQn         =  55,              /*!< 55 USBREGULATOR                                                           */
  KMU_IRQn                  =  57,              /*!< 57 KMU                                                                    */
  CRYPTOCELL_IRQn           =  68               /*!< 68 CRYPTOCELL                                                             */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M33 Processor and Core Peripherals  =========================== */
#define __CM33_REV                 0x0004U      /*!< CM33 Core Revision                                                        */
#define __INTERRUPTS_MAX                   240        /*!< Top interrupt number                                                      */
#define __DSP_PRESENT                  1        /*!< DSP present or not                                                        */
#define __NVIC_PRIO_BITS               3        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __MPU_PRESENT                  1        /*!< MPU present                                                               */
#define __FPU_PRESENT                  1        /*!< FPU present                                                               */
#define __FPU_DP                       0        /*!< Double Precision FPU                                                      */
#define __SAUREGION_PRESENT            0        /*!< SAU region present                                                        */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm33.h"                          /*!< ARM Cortex-M33 processor and core peripherals                             */
#include "system_nrf5340_application.h"         /*!< nrf5340_application System                                                */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief CACHEDATA_SET_WAY [WAY] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DATA0;                        /*!< Description cluster: Cache data bits [31:0] of SET[n], WAY[o].            */
  __IOM uint32_t  DATA1;                        /*!< Description cluster: Cache data bits [63:32] of SET[n], WAY[o].           */
  __IOM uint32_t  DATA2;                        /*!< Description cluster: Cache data bits [95:64] of SET[n], WAY[o].           */
  __IOM uint32_t  DATA3;                        /*!< Description cluster: Cache data bits [127:96] of SET[n], WAY[o].          */
} CACHEDATA_SET_WAY_Type;                       /*!< Size = 16 (0x10)                                                          */


/**
  * @brief CACHEDATA_SET [SET] (Unspecified)
  */
typedef struct {
  __IOM CACHEDATA_SET_WAY_Type WAY[2];          /*!< Unspecified                                                               */
} CACHEDATA_SET_Type;                           /*!< Size = 32 (0x20)                                                          */


/**
  * @brief CACHEINFO_SET [SET] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  WAY[2];                       /*!< Description collection: Cache information for SET[n], WAY[o].             */
} CACHEINFO_SET_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief FICR_INFO [INFO] (Device info)
  */
typedef struct {
  __IM  uint32_t  CONFIGID;                     /*!< Configuration identifier                                                  */
  __IM  uint32_t  DEVICEID[2];                  /*!< Description collection: Device identifier                                 */
  __IM  uint32_t  PART;                         /*!< Part code                                                                 */
  __IM  uint32_t  VARIANT;                      /*!< Part Variant, Hardware version and Production configuration               */
  __IM  uint32_t  PACKAGE;                      /*!< Package option                                                            */
  __IM  uint32_t  RAM;                          /*!< RAM variant                                                               */
  __IM  uint32_t  FLASH;                        /*!< Flash variant                                                             */
  __IM  uint32_t  CODEPAGESIZE;                 /*!< Code memory page size in bytes                                            */
  __IM  uint32_t  CODESIZE;                     /*!< Code memory size                                                          */
  __IM  uint32_t  DEVICETYPE;                   /*!< Device type                                                               */
} FICR_INFO_Type;                               /*!< Size = 44 (0x2c)                                                          */


/**
  * @brief FICR_TRIMCNF [TRIMCNF] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  ADDR;                         /*!< Description cluster: Address of the PAR register which will
                                                     be written                                                                */
  __IM  uint32_t  DATA;                         /*!< Description cluster: Data                                                 */
} FICR_TRIMCNF_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief FICR_NFC [NFC] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  TAGHEADER0;                   /*!< Default header for NFC Tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST and NFCID1_LAST.                */
  __IM  uint32_t  TAGHEADER1;                   /*!< Default header for NFC Tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST and NFCID1_LAST.                */
  __IM  uint32_t  TAGHEADER2;                   /*!< Default header for NFC Tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST and NFCID1_LAST.                */
  __IM  uint32_t  TAGHEADER3;                   /*!< Default header for NFC Tag. Software can read these values to
                                                     populate NFCID1_3RD_LAST, NFCID1_2ND_LAST and NFCID1_LAST.                */
} FICR_NFC_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief FICR_TRNG90B [TRNG90B] (NIST800-90B RNG calibration data)
  */
typedef struct {
  __IM  uint32_t  BYTES;                        /*!< Amount of bytes for the required entropy bits                             */
  __IM  uint32_t  RCCUTOFF;                     /*!< Repetition counter cutoff                                                 */
  __IM  uint32_t  APCUTOFF;                     /*!< Adaptive proportion cutoff                                                */
  __IM  uint32_t  STARTUP;                      /*!< Amount of bytes for the startup tests                                     */
  __IM  uint32_t  ROSC1;                        /*!< Sample count for ring oscillator 1                                        */
  __IM  uint32_t  ROSC2;                        /*!< Sample count for ring oscillator 2                                        */
  __IM  uint32_t  ROSC3;                        /*!< Sample count for ring oscillator 3                                        */
  __IM  uint32_t  ROSC4;                        /*!< Sample count for ring oscillator 4                                        */
} FICR_TRNG90B_Type;                            /*!< Size = 32 (0x20)                                                          */


/**
  * @brief UICR_KEYSLOT_CONFIG [CONFIG] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DEST;                         /*!< Description cluster: Destination address where content of the
                                                     key value registers (KEYSLOT.KEYn.VALUE[0-3]) will be pushed
                                                     by KMU. Note that this address must match that of a peripherals
                                                     APB mapped write-only key registers, else the KMU can push
                                                     this key value into an address range which the CPU can
                                                     potentially read.                                                         */
  __IOM uint32_t  PERM;                         /*!< Description cluster: Define permissions for the key slot. Bits
                                                     0-15 and 16-31 can only be written when equal to 0xFFFF.                  */
} UICR_KEYSLOT_CONFIG_Type;                     /*!< Size = 8 (0x8)                                                            */


/**
  * @brief UICR_KEYSLOT_KEY [KEY] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  VALUE[4];                     /*!< Description collection: Define bits [31+o*32:0+o*32] of value
                                                     assigned to KMU key slot.                                                 */
} UICR_KEYSLOT_KEY_Type;                        /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UICR_KEYSLOT [KEYSLOT] (Unspecified)
  */
typedef struct {
  __IOM UICR_KEYSLOT_CONFIG_Type CONFIG[128];   /*!< Unspecified                                                               */
  __IOM UICR_KEYSLOT_KEY_Type KEY[128];         /*!< Unspecified                                                               */
} UICR_KEYSLOT_Type;                            /*!< Size = 3072 (0xc00)                                                       */


/**
  * @brief TAD_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  TRACECLK;                     /*!< Pin configuration for TRACECLK                                            */
  __IOM uint32_t  TRACEDATA0;                   /*!< Pin configuration for TRACEDATA[0]                                        */
  __IOM uint32_t  TRACEDATA1;                   /*!< Pin configuration for TRACEDATA[1]                                        */
  __IOM uint32_t  TRACEDATA2;                   /*!< Pin configuration for TRACEDATA[2]                                        */
  __IOM uint32_t  TRACEDATA3;                   /*!< Pin configuration for TRACEDATA[3]                                        */
} TAD_PSEL_Type;                                /*!< Size = 20 (0x14)                                                          */


/**
  * @brief DCNF_EXTPERI [EXTPERI] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PROTECT;                      /*!< Description cluster: Control access for master connected to
                                                     AMLI master port EXTPERI[n]                                               */
} DCNF_EXTPERI_Type;                            /*!< Size = 4 (0x4)                                                            */


/**
  * @brief DCNF_EXTRAM [EXTRAM] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PROTECT;                      /*!< Description cluster: Control access from master connected to
                                                     AMLI master port EXTRAM[n]                                                */
} DCNF_EXTRAM_Type;                             /*!< Size = 4 (0x4)                                                            */


/**
  * @brief DCNF_EXTCODE [EXTCODE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PROTECT;                      /*!< Description cluster: Control access from master connected to
                                                     AMLI master port EXTCODE[n]                                               */
} DCNF_EXTCODE_Type;                            /*!< Size = 4 (0x4)                                                            */


/**
  * @brief CACHE_PROFILING [PROFILING] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  IHIT;                         /*!< Description cluster: Instruction fetch cache hit counter for
                                                     cache region n, where n=0 means Flash and n=1 means XIP.                  */
  __IM  uint32_t  IMISS;                        /*!< Description cluster: Instruction fetch cache miss counter for
                                                     cache region n, where n=0 means Flash and n=1 means XIP.                  */
  __IM  uint32_t  DHIT;                         /*!< Description cluster: Data fetch cache hit counter for cache
                                                     region n, where n=0 means Flash and n=1 means XIP.                        */
  __IM  uint32_t  DMISS;                        /*!< Description cluster: Data fetch cache miss counter for cache
                                                     region n, where n=0 means Flash and n=1 means XIP.                        */
  __IM  uint32_t  RESERVED[4];
} CACHE_PROFILING_Type;                         /*!< Size = 32 (0x20)                                                          */


/**
  * @brief SPU_EXTDOMAIN [EXTDOMAIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access for bus access generated from the
                                                     external domain n List capabilities of the external domain
                                                     n                                                                         */
} SPU_EXTDOMAIN_Type;                           /*!< Size = 4 (0x4)                                                            */


/**
  * @brief SPU_DPPI [DPPI] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Select between secure and non-secure attribute
                                                     for the DPPI channels                                                     */
  __IOM uint32_t  LOCK;                         /*!< Description cluster: Prevent further modification of the corresponding
                                                     PERM register                                                             */
} SPU_DPPI_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_GPIOPORT [GPIOPORT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Select between secure and non-secure attribute
                                                     for pins 0 to 31 of port n                                                */
  __IOM uint32_t  LOCK;                         /*!< Description cluster: Prevent further modification of the corresponding
                                                     PERM register                                                             */
} SPU_GPIOPORT_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_FLASHNSC [FLASHNSC] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  REGION;                       /*!< Description cluster: Define which flash region can contain the
                                                     non-secure callable (NSC) region n                                        */
  __IOM uint32_t  SIZE;                         /*!< Description cluster: Define the size of the non-secure callable
                                                     (NSC) region n                                                            */
} SPU_FLASHNSC_Type;                            /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_RAMNSC [RAMNSC] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  REGION;                       /*!< Description cluster: Define which RAM region can contain the
                                                     non-secure callable (NSC) region n                                        */
  __IOM uint32_t  SIZE;                         /*!< Description cluster: Define the size of the non-secure callable
                                                     (NSC) region n                                                            */
} SPU_RAMNSC_Type;                              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPU_FLASHREGION [FLASHREGION] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access permissions for flash region n                */
} SPU_FLASHREGION_Type;                         /*!< Size = 4 (0x4)                                                            */


/**
  * @brief SPU_RAMREGION [RAMREGION] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: Access permissions for RAM region n                  */
} SPU_RAMREGION_Type;                           /*!< Size = 4 (0x4)                                                            */


/**
  * @brief SPU_PERIPHID [PERIPHID] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PERM;                         /*!< Description cluster: List capabilities and access permissions
                                                     for the peripheral with ID n                                              */
} SPU_PERIPHID_Type;                            /*!< Size = 4 (0x4)                                                            */


/**
  * @brief OSCILLATORS_XOSC32KI [XOSC32KI] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  BYPASS;                       /*!< Enable or disable bypass of LFCLK crystal oscillator with external
                                                     clock source                                                              */
  __IM  uint32_t  RESERVED[3];
  __IOM uint32_t  INTCAP;                       /*!< Control usage of internal load capacitors                                 */
} OSCILLATORS_XOSC32KI_Type;                    /*!< Size = 20 (0x14)                                                          */


/**
  * @brief REGULATORS_VREGMAIN [VREGMAIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DCDCEN;                       /*!< DC/DC enable register for VREGMAIN                                        */
} REGULATORS_VREGMAIN_Type;                     /*!< Size = 4 (0x4)                                                            */


/**
  * @brief REGULATORS_VREGRADIO [VREGRADIO] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  DCDCEN;                       /*!< DC/DC enable register for VREGRADIO                                       */
} REGULATORS_VREGRADIO_Type;                    /*!< Size = 8 (0x8)                                                            */


/**
  * @brief REGULATORS_VREGH [VREGH] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DCDCEN;                       /*!< DC/DC enable register for VREGH                                           */
} REGULATORS_VREGH_Type;                        /*!< Size = 4 (0x4)                                                            */


/**
  * @brief CLOCK_HFCLKAUDIO [HFCLKAUDIO] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  FREQUENCY;                    /*!< Audio PLL frequency in 11.176 MHz - 11.402 MHz or 12.165 MHz
                                                     - 12.411 MHz frequency bands                                              */
} CLOCK_HFCLKAUDIO_Type;                        /*!< Size = 4 (0x4)                                                            */


/**
  * @brief RESET_NETWORK [NETWORK] (ULP network core control)
  */
typedef struct {
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  FORCEOFF;                     /*!< Force network core off                                                    */
} RESET_NETWORK_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief CTRLAPPERI_MAILBOX [MAILBOX] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  RXDATA;                       /*!< Data sent from the debugger to the CPU.                                   */
  __IM  uint32_t  RXSTATUS;                     /*!< This register shows a status that indicates if data sent from
                                                     the debugger to the CPU has been read.                                    */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  TXDATA;                       /*!< Data sent from the CPU to the debugger.                                   */
  __IM  uint32_t  TXSTATUS;                     /*!< This register shows a status that indicates if the data sent
                                                     from the CPU to the debugger has been read.                               */
} CTRLAPPERI_MAILBOX_Type;                      /*!< Size = 136 (0x88)                                                         */


/**
  * @brief CTRLAPPERI_ERASEPROTECT [ERASEPROTECT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LOCK;                         /*!< This register locks the ERASEPROTECT.DISABLE register from being
                                                     written until next reset.                                                 */
  __IOM uint32_t  DISABLE;                      /*!< This register disables the ERASEPROTECT register and performs
                                                     an ERASEALL operation.                                                    */
} CTRLAPPERI_ERASEPROTECT_Type;                 /*!< Size = 8 (0x8)                                                            */


/**
  * @brief CTRLAPPERI_APPROTECT [APPROTECT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LOCK;                         /*!< This register locks the APPROTECT.DISABLE register from being
                                                     written to until next reset.                                              */
  __IOM uint32_t  DISABLE;                      /*!< This register disables the APPROTECT register and enables debug
                                                     access to non-secure mode.                                                */
} CTRLAPPERI_APPROTECT_Type;                    /*!< Size = 8 (0x8)                                                            */


/**
  * @brief CTRLAPPERI_SECUREAPPROTECT [SECUREAPPROTECT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LOCK;                         /*!< This register locks the SECUREAPPROTECT.DISABLE register from
                                                     being written until next reset.                                           */
  __IOM uint32_t  DISABLE;                      /*!< This register disables the SECUREAPPROTECT register and enables
                                                     debug access to secure mode.                                              */
} CTRLAPPERI_SECUREAPPROTECT_Type;              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN                                                        */
} SPIM_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Number of bytes in transmit buffer                                        */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIM_IFTIMING [IFTIMING] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RXDELAY;                      /*!< Sample delay for input serial data on MISO                                */
  __IOM uint32_t  CSNDUR;                       /*!< Minimum duration between edge of CSN and edge of SCK. When SHORTS.END_START
                                                     is used, this is also the minimum duration CSN must stay
                                                     high between transactions.                                                */
} SPIM_IFTIMING_Type;                           /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SPIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK                                                        */
  __IOM uint32_t  MISO;                         /*!< Pin select for MISO signal                                                */
  __IOM uint32_t  MOSI;                         /*!< Pin select for MOSI signal                                                */
  __IOM uint32_t  CSN;                          /*!< Pin select for CSN signal                                                 */
} SPIS_PSEL_Type;                               /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes received in last granted transaction                      */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SPIS_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transmitted in last granted transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} SPIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIM_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIM_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIM_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIM_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCL;                          /*!< Pin select for SCL signal                                                 */
  __IOM uint32_t  SDA;                          /*!< Pin select for SDA signal                                                 */
} TWIS_PSEL_Type;                               /*!< Size = 8 (0x8)                                                            */


/**
  * @brief TWIS_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in RXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last RXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_RXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief TWIS_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< TXD Data pointer                                                          */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in TXD buffer                                     */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last TXD transaction                   */
  __IOM uint32_t  LIST;                         /*!< EasyDMA list type                                                         */
} TWIS_TXD_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RTS;                          /*!< Pin select for RTS signal                                                 */
  __IOM uint32_t  TXD;                          /*!< Pin select for TXD signal                                                 */
  __IOM uint32_t  CTS;                          /*!< Pin select for CTS signal                                                 */
  __IOM uint32_t  RXD;                          /*!< Pin select for RXD signal                                                 */
} UARTE_PSEL_Type;                              /*!< Size = 16 (0x10)                                                          */


/**
  * @brief UARTE_RXD [RXD] (RXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in receive buffer                                 */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_RXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief UARTE_TXD [TXD] (TXD EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes in transmit buffer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} UARTE_TXD_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief SAADC_EVENTS_CH [EVENTS_CH] (Peripheral events.)
  */
typedef struct {
  __IOM uint32_t  LIMITH;                       /*!< Description cluster: Last results is equal or above CH[n].LIMIT.HIGH      */
  __IOM uint32_t  LIMITL;                       /*!< Description cluster: Last results is equal or below CH[n].LIMIT.LOW       */
} SAADC_EVENTS_CH_Type;                         /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SAADC_PUBLISH_CH [PUBLISH_CH] (Publish configuration for events)
  */
typedef struct {
  __IOM uint32_t  LIMITH;                       /*!< Description cluster: Publish configuration for event CH[n].LIMITH         */
  __IOM uint32_t  LIMITL;                       /*!< Description cluster: Publish configuration for event CH[n].LIMITL         */
} SAADC_PUBLISH_CH_Type;                        /*!< Size = 8 (0x8)                                                            */


/**
  * @brief SAADC_CH [CH] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PSELP;                        /*!< Description cluster: Input positive pin selection for CH[n]               */
  __IOM uint32_t  PSELN;                        /*!< Description cluster: Input negative pin selection for CH[n]               */
  __IOM uint32_t  CONFIG;                       /*!< Description cluster: Input configuration for CH[n]                        */
  __IOM uint32_t  LIMIT;                        /*!< Description cluster: High/low limits for event monitoring a
                                                     channel                                                                   */
} SAADC_CH_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief SAADC_RESULT [RESULT] (RESULT EasyDMA channel)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of buffer words to transfer                                */
  __IM  uint32_t  AMOUNT;                       /*!< Number of buffer words transferred since last START                       */
} SAADC_RESULT_Type;                            /*!< Size = 12 (0xc)                                                           */


/**
  * @brief DPPIC_TASKS_CHG [TASKS_CHG] (Channel group tasks)
  */
typedef struct {
  __OM  uint32_t  EN;                           /*!< Description cluster: Enable channel group n                               */
  __OM  uint32_t  DIS;                          /*!< Description cluster: Disable channel group n                              */
} DPPIC_TASKS_CHG_Type;                         /*!< Size = 8 (0x8)                                                            */


/**
  * @brief DPPIC_SUBSCRIBE_CHG [SUBSCRIBE_CHG] (Subscribe configuration for tasks)
  */
typedef struct {
  __IOM uint32_t  EN;                           /*!< Description cluster: Subscribe configuration for task CHG[n].EN           */
  __IOM uint32_t  DIS;                          /*!< Description cluster: Subscribe configuration for task CHG[n].DIS          */
} DPPIC_SUBSCRIBE_CHG_Type;                     /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PWM_SEQ [SEQ] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Beginning address in RAM of this sequence            */
  __IOM uint32_t  CNT;                          /*!< Description cluster: Number of values (duty cycles) in this
                                                     sequence                                                                  */
  __IOM uint32_t  REFRESH;                      /*!< Description cluster: Number of additional PWM periods between
                                                     samples loaded into compare register                                      */
  __IOM uint32_t  ENDDELAY;                     /*!< Description cluster: Time added after the sequence                        */
  __IM  uint32_t  RESERVED[4];
} PWM_SEQ_Type;                                 /*!< Size = 32 (0x20)                                                          */


/**
  * @brief PWM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  OUT[4];                       /*!< Description collection: Output pin select for PWM channel n               */
} PWM_PSEL_Type;                                /*!< Size = 16 (0x10)                                                          */


/**
  * @brief PDM_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  CLK;                          /*!< Pin number configuration for PDM CLK signal                               */
  __IOM uint32_t  DIN;                          /*!< Pin number configuration for PDM DIN signal                               */
} PDM_PSEL_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief PDM_SAMPLE [SAMPLE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< RAM address pointer to write samples to with EasyDMA                      */
  __IOM uint32_t  MAXCNT;                       /*!< Number of samples to allocate memory for in EasyDMA mode                  */
} PDM_SAMPLE_Type;                              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief I2S_CONFIG [CONFIG] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MODE;                         /*!< I2S mode                                                                  */
  __IOM uint32_t  RXEN;                         /*!< Reception (RX) enable                                                     */
  __IOM uint32_t  TXEN;                         /*!< Transmission (TX) enable                                                  */
  __IOM uint32_t  MCKEN;                        /*!< Master clock generator enable                                             */
  __IOM uint32_t  MCKFREQ;                      /*!< I2S clock generator control                                               */
  __IOM uint32_t  RATIO;                        /*!< MCK / LRCK ratio                                                          */
  __IOM uint32_t  SWIDTH;                       /*!< Sample width                                                              */
  __IOM uint32_t  ALIGN;                        /*!< Alignment of sample within a frame                                        */
  __IOM uint32_t  FORMAT;                       /*!< Frame format                                                              */
  __IOM uint32_t  CHANNELS;                     /*!< Enable channels                                                           */
  __IOM uint32_t  CLKCONFIG;                    /*!< Clock source selection for the I2S module                                 */
} I2S_CONFIG_Type;                              /*!< Size = 44 (0x2c)                                                          */


/**
  * @brief I2S_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Receive buffer RAM start address.                                         */
} I2S_RXD_Type;                                 /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Transmit buffer RAM start address                                         */
} I2S_TXD_Type;                                 /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_RXTXD [RXTXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MAXCNT;                       /*!< Size of RXD and TXD buffers                                               */
} I2S_RXTXD_Type;                               /*!< Size = 4 (0x4)                                                            */


/**
  * @brief I2S_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  MCK;                          /*!< Pin select for MCK signal                                                 */
  __IOM uint32_t  SCK;                          /*!< Pin select for SCK signal                                                 */
  __IOM uint32_t  LRCK;                         /*!< Pin select for LRCK signal                                                */
  __IOM uint32_t  SDIN;                         /*!< Pin select for SDIN signal                                                */
  __IOM uint32_t  SDOUT;                        /*!< Pin select for SDOUT signal                                               */
} I2S_PSEL_Type;                                /*!< Size = 20 (0x14)                                                          */


/**
  * @brief QSPI_READ [READ] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SRC;                          /*!< Flash memory source address                                               */
  __IOM uint32_t  DST;                          /*!< RAM destination address                                                   */
  __IOM uint32_t  CNT;                          /*!< Read transfer length                                                      */
} QSPI_READ_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief QSPI_WRITE [WRITE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  DST;                          /*!< Flash destination address                                                 */
  __IOM uint32_t  SRC;                          /*!< RAM source address                                                        */
  __IOM uint32_t  CNT;                          /*!< Write transfer length                                                     */
} QSPI_WRITE_Type;                              /*!< Size = 12 (0xc)                                                           */


/**
  * @brief QSPI_ERASE [ERASE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Start address of flash block to be erased                                 */
  __IOM uint32_t  LEN;                          /*!< Size of block to be erased.                                               */
} QSPI_ERASE_Type;                              /*!< Size = 8 (0x8)                                                            */


/**
  * @brief QSPI_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  SCK;                          /*!< Pin select for serial clock SCK                                           */
  __IOM uint32_t  CSN;                          /*!< Pin select for chip select signal CSN.                                    */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  IO0;                          /*!< Pin select for serial data MOSI/IO0.                                      */
  __IOM uint32_t  IO1;                          /*!< Pin select for serial data MISO/IO1.                                      */
  __IOM uint32_t  IO2;                          /*!< Pin select for serial data WP/IO2.                                        */
  __IOM uint32_t  IO3;                          /*!< Pin select for serial data HOLD/IO3.                                      */
} QSPI_PSEL_Type;                               /*!< Size = 28 (0x1c)                                                          */


/**
  * @brief QSPI_XIP_ENC [XIP_ENC] (Unspecified)
  */
typedef struct {
  __OM  uint32_t  KEY0;                         /*!< Bits 31:0 of XIP AES KEY                                                  */
  __OM  uint32_t  KEY1;                         /*!< Bits 63:32 of XIP AES KEY                                                 */
  __OM  uint32_t  KEY2;                         /*!< Bits 95:64 of XIP AES KEY                                                 */
  __OM  uint32_t  KEY3;                         /*!< Bits 127:96 of XIP AES KEY                                                */
  __OM  uint32_t  NONCE0;                       /*!< Bits 31:0 of XIP NONCE                                                    */
  __OM  uint32_t  NONCE1;                       /*!< Bits 63:32 of XIP NONCE                                                   */
  __OM  uint32_t  NONCE2;                       /*!< Bits 95:64 of XIP NONCE                                                   */
  __IOM uint32_t  ENABLE;                       /*!< Enable stream cipher for XIP                                              */
} QSPI_XIP_ENC_Type;                            /*!< Size = 32 (0x20)                                                          */


/**
  * @brief QSPI_DMA_ENC [DMA_ENC] (Unspecified)
  */
typedef struct {
  __OM  uint32_t  KEY0;                         /*!< Bits 31:0 of DMA AES KEY                                                  */
  __OM  uint32_t  KEY1;                         /*!< Bits 63:32 of DMA AES KEY                                                 */
  __OM  uint32_t  KEY2;                         /*!< Bits 95:64 of DMA AES KEY                                                 */
  __OM  uint32_t  KEY3;                         /*!< Bits 127:96 of DMA AES KEY                                                */
  __OM  uint32_t  NONCE0;                       /*!< Bits 31:0 of DMA NONCE                                                    */
  __OM  uint32_t  NONCE1;                       /*!< Bits 63:32 of DMA NONCE                                                   */
  __OM  uint32_t  NONCE2;                       /*!< Bits 95:64 of DMA NONCE                                                   */
  __IOM uint32_t  ENABLE;                       /*!< Enable stream cipher for EasyDMA                                          */
} QSPI_DMA_ENC_Type;                            /*!< Size = 32 (0x20)                                                          */


/**
  * @brief NFCT_FRAMESTATUS [FRAMESTATUS] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  RX;                           /*!< Result of last incoming frame                                             */
} NFCT_FRAMESTATUS_Type;                        /*!< Size = 4 (0x4)                                                            */


/**
  * @brief NFCT_TXD [TXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  FRAMECONFIG;                  /*!< Configuration of outgoing frames                                          */
  __IOM uint32_t  AMOUNT;                       /*!< Size of outgoing frame                                                    */
} NFCT_TXD_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief NFCT_RXD [RXD] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  FRAMECONFIG;                  /*!< Configuration of incoming frames                                          */
  __IM  uint32_t  AMOUNT;                       /*!< Size of last incoming frame                                               */
} NFCT_RXD_Type;                                /*!< Size = 8 (0x8)                                                            */


/**
  * @brief QDEC_PSEL [PSEL] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  LED;                          /*!< Pin select for LED signal                                                 */
  __IOM uint32_t  A;                            /*!< Pin select for A signal                                                   */
  __IOM uint32_t  B;                            /*!< Pin select for B signal                                                   */
} QDEC_PSEL_Type;                               /*!< Size = 12 (0xc)                                                           */


/**
  * @brief USBD_HALTED [HALTED] (Unspecified)
  */
typedef struct {
  __IM  uint32_t  EPIN[8];                      /*!< Description collection: IN endpoint halted status. Can be used
                                                     as is as response to a GetStatus() request to endpoint.                   */
  __IM  uint32_t  RESERVED;
  __IM  uint32_t  EPOUT[8];                     /*!< Description collection: OUT endpoint halted status. Can be used
                                                     as is as response to a GetStatus() request to endpoint.                   */
} USBD_HALTED_Type;                             /*!< Size = 68 (0x44)                                                          */


/**
  * @brief USBD_SIZE [SIZE] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  EPOUT[8];                     /*!< Description collection: Number of bytes received last in the
                                                     data stage of this OUT endpoint                                           */
  __IM  uint32_t  ISOOUT;                       /*!< Number of bytes received last on this ISO OUT data endpoint               */
} USBD_SIZE_Type;                               /*!< Size = 36 (0x24)                                                          */


/**
  * @brief USBD_EPIN [EPIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Data pointer                                         */
  __IOM uint32_t  MAXCNT;                       /*!< Description cluster: Maximum number of bytes to transfer                  */
  __IM  uint32_t  AMOUNT;                       /*!< Description cluster: Number of bytes transferred in the last
                                                     transaction                                                               */
  __IM  uint32_t  RESERVED[2];
} USBD_EPIN_Type;                               /*!< Size = 20 (0x14)                                                          */


/**
  * @brief USBD_ISOIN [ISOIN] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes to transfer                                       */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} USBD_ISOIN_Type;                              /*!< Size = 12 (0xc)                                                           */


/**
  * @brief USBD_EPOUT [EPOUT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Description cluster: Data pointer                                         */
  __IOM uint32_t  MAXCNT;                       /*!< Description cluster: Maximum number of bytes to transfer                  */
  __IM  uint32_t  AMOUNT;                       /*!< Description cluster: Number of bytes transferred in the last
                                                     transaction                                                               */
  __IM  uint32_t  RESERVED[2];
} USBD_EPOUT_Type;                              /*!< Size = 20 (0x14)                                                          */


/**
  * @brief USBD_ISOOUT [ISOOUT] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  PTR;                          /*!< Data pointer                                                              */
  __IOM uint32_t  MAXCNT;                       /*!< Maximum number of bytes to transfer                                       */
  __IM  uint32_t  AMOUNT;                       /*!< Number of bytes transferred in the last transaction                       */
} USBD_ISOOUT_Type;                             /*!< Size = 12 (0xc)                                                           */


/**
  * @brief VMC_RAM [RAM] (Unspecified)
  */
typedef struct {
  __IOM uint32_t  POWER;                        /*!< Description cluster: RAM[n] power control register                        */
  __IOM uint32_t  POWERSET;                     /*!< Description cluster: RAM[n] power control set register                    */
  __IOM uint32_t  POWERCLR;                     /*!< Description cluster: RAM[n] power control clear register                  */
  __IM  uint32_t  RESERVED;
} VMC_RAM_Type;                                 /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                        CACHEDATA_S                                        ================ */
/* =========================================================================================================================== */


/**
  * @brief CACHEDATA (CACHEDATA_S)
  */

typedef struct {                                /*!< CACHEDATA_S Structure                                                     */
  __IOM CACHEDATA_SET_Type SET[256];            /*!< Unspecified                                                               */
} NRF_CACHEDATA_Type;                           /*!< Size = 8192 (0x2000)                                                      */



/* =========================================================================================================================== */
/* ================                                        CACHEINFO_S                                        ================ */
/* =========================================================================================================================== */


/**
  * @brief CACHEINFO (CACHEINFO_S)
  */

typedef struct {                                /*!< CACHEINFO_S Structure                                                     */
  __IOM CACHEINFO_SET_Type SET[256];            /*!< Unspecified                                                               */
} NRF_CACHEINFO_Type;                           /*!< Size = 2048 (0x800)                                                       */



/* =========================================================================================================================== */
/* ================                                          FICR_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Factory Information Configuration Registers (FICR_S)
  */

typedef struct {                                /*!< FICR_S Structure                                                          */
  __IM  uint32_t  RESERVED[128];
  __IOM FICR_INFO_Type INFO;                    /*!< Device info                                                               */
  __IM  uint32_t  RESERVED1[53];
  __IOM FICR_TRIMCNF_Type TRIMCNF[32];          /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED2[20];
  __IOM FICR_NFC_Type NFC;                      /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED3[488];
  __IOM FICR_TRNG90B_Type TRNG90B;              /*!< NIST800-90B RNG calibration data                                          */
  __IM  uint32_t  XOSC32MTRIM;                  /*!< XOSC32M capacitor selection trim values                                   */
} NRF_FICR_Type;                                /*!< Size = 3108 (0xc24)                                                       */



/* =========================================================================================================================== */
/* ================                                          UICR_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief User Information Configuration Registers User information configuration registers (UICR_S)
  */

typedef struct {                                /*!< UICR_S Structure                                                          */
  __IOM uint32_t  APPROTECT;                    /*!< Access port protection                                                    */
  __IM  uint32_t  RESERVED[3];
  __IOM uint32_t  VREGHVOUT;                    /*!< Output voltage from the high voltage (VREGH) regulator stage.
                                                     The maximum output voltage from this stage is given as
                                                     VDDH - VREGHDROP.                                                         */
  __IOM uint32_t  HFXOCNT;                      /*!< HFXO startup counter                                                      */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  SECUREAPPROTECT;              /*!< Secure access port protection                                             */
  __IOM uint32_t  ERASEPROTECT;                 /*!< Erase protection                                                          */
  __IOM uint32_t  TINSTANCE;                    /*!< SW-DP Target instance                                                     */
  __IOM uint32_t  NFCPINS;                      /*!< Setting of pins dedicated to NFC functionality: NFC antenna
                                                     or GPIO                                                                   */
  __IM  uint32_t  RESERVED2[53];
  __IOM uint32_t  OTP[192];                     /*!< Description collection: One time programmable memory                      */
  __IOM UICR_KEYSLOT_Type KEYSLOT;              /*!< Unspecified                                                               */
} NRF_UICR_Type;                                /*!< Size = 4096 (0x1000)                                                      */



/* =========================================================================================================================== */
/* ================                                           CTI_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Cross-Trigger Interface control. NOTE: this is not a separate peripheral, but describes CM33 functionality. (CTI_S)
  */

typedef struct {                                /*!< CTI_S Structure                                                           */
  __IOM uint32_t  CTICONTROL;                   /*!< CTI Control register                                                      */
  __IM  uint32_t  RESERVED[3];
  __OM  uint32_t  CTIINTACK;                    /*!< CTI Interrupt Acknowledge register                                        */
  __IOM uint32_t  CTIAPPSET;                    /*!< CTI Application Trigger Set register                                      */
  __OM  uint32_t  CTIAPPCLEAR;                  /*!< CTI Application Trigger Clear register                                    */
  __OM  uint32_t  CTIAPPPULSE;                  /*!< CTI Application Pulse register                                            */
  __IOM uint32_t  CTIINEN[8];                   /*!< Description collection: CTI Trigger input                                 */
  __IM  uint32_t  RESERVED1[24];
  __IOM uint32_t  CTIOUTEN[8];                  /*!< Description collection: CTI Trigger output                                */
  __IM  uint32_t  RESERVED2[28];
  __IM  uint32_t  CTITRIGINSTATUS;              /*!< CTI Trigger In Status register                                            */
  __IM  uint32_t  CTITRIGOUTSTATUS;             /*!< CTI Trigger Out Status register                                           */
  __IM  uint32_t  CTICHINSTATUS;                /*!< CTI Channel In Status register                                            */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  CTIGATE;                      /*!< Enable CTI Channel Gate register                                          */
  __IM  uint32_t  RESERVED4[926];
  __IM  uint32_t  DEVARCH;                      /*!< Device Architecture register                                              */
  __IM  uint32_t  RESERVED5[2];
  __IM  uint32_t  DEVID;                        /*!< Device Configuration register                                             */
  __IM  uint32_t  DEVTYPE;                      /*!< Device Type Identifier register                                           */
  __IM  uint32_t  PIDR4;                        /*!< Peripheral ID4 Register                                                   */
  __IM  uint32_t  PIDR5;                        /*!< Peripheral ID5 register                                                   */
  __IM  uint32_t  PIDR6;                        /*!< Peripheral ID6 register                                                   */
  __IM  uint32_t  PIDR7;                        /*!< Peripheral ID7 register                                                   */
  __IM  uint32_t  PIDR0;                        /*!< Peripheral ID0 Register                                                   */
  __IM  uint32_t  PIDR1;                        /*!< Peripheral ID1 Register                                                   */
  __IM  uint32_t  PIDR2;                        /*!< Peripheral ID2 Register                                                   */
  __IM  uint32_t  PIDR3;                        /*!< Peripheral ID3 Register                                                   */
  __IM  uint32_t  CIDR0;                        /*!< Component ID0 Register                                                    */
  __IM  uint32_t  CIDR1;                        /*!< Component ID1 Register                                                    */
  __IM  uint32_t  CIDR2;                        /*!< Component ID2 Register                                                    */
  __IM  uint32_t  CIDR3;                        /*!< Component ID3 Register                                                    */
} NRF_CTI_Type;                                 /*!< Size = 4096 (0x1000)                                                      */



/* =========================================================================================================================== */
/* ================                                           TAD_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Trace and debug control (TAD_S)
  */

typedef struct {                                /*!< TAD_S Structure                                                           */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  CLOCKSTART;                   /*!< Start all trace and debug clocks.                                         */
  __OM  uint32_t  CLOCKSTOP;                    /*!< Stop all trace and debug clocks.                                          */
  __IM  uint32_t  RESERVED1[317];
  __IOM uint32_t  ENABLE;                       /*!< Enable debug domain and aquire selected GPIOs                             */
  __IOM TAD_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IOM uint32_t  TRACEPORTSPEED;               /*!< Clocking options for the Trace Port debug interface Reset behavior
                                                     is the same as debug components                                           */
} NRF_TAD_Type;                                 /*!< Size = 1308 (0x51c)                                                       */



/* =========================================================================================================================== */
/* ================                                          DCNF_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Domain configuration management 0 (DCNF_NS)
  */

typedef struct {                                /*!< DCNF_NS Structure                                                         */
  __IM  uint32_t  RESERVED[264];
  __IM  uint32_t  CPUID;                        /*!< CPU ID of this subsystem                                                  */
  __IM  uint32_t  RESERVED1[7];
  __IOM DCNF_EXTPERI_Type EXTPERI[1];           /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED2[7];
  __IOM DCNF_EXTRAM_Type EXTRAM[1];             /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED3[7];
  __IOM DCNF_EXTCODE_Type EXTCODE[1];           /*!< Unspecified                                                               */
} NRF_DCNF_Type;                                /*!< Size = 1156 (0x484)                                                       */



/* =========================================================================================================================== */
/* ================                                          FPU_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief FPU control peripheral 0 (FPU_NS)
  */

typedef struct {                                /*!< FPU_NS Structure                                                          */
  __IM  uint32_t  RESERVED[64];
  __IOM uint32_t  EVENTS_INVALIDOPERATION;      /*!< An FPUIOC exception triggered by an invalid operation has occurred
                                                     in the FPU                                                                */
  __IOM uint32_t  EVENTS_DIVIDEBYZERO;          /*!< An FPUDZC exception triggered by a floating-point divide-by-zero
                                                     operation has occurred in the FPU                                         */
  __IOM uint32_t  EVENTS_OVERFLOW;              /*!< An FPUOFC exception triggered by a floating-point overflow has
                                                     occurred in the FPU                                                       */
  __IOM uint32_t  EVENTS_UNDERFLOW;             /*!< An FPUUFC exception triggered by a floating-point underflow
                                                     has occurred in the FPU                                                   */
  __IOM uint32_t  EVENTS_INEXACT;               /*!< An FPUIXC exception triggered by an inexact floating-point operation
                                                     has occurred in the FPU                                                   */
  __IOM uint32_t  EVENTS_DENORMALINPUT;         /*!< An FPUIDC exception triggered by a denormal floating-point input
                                                     has occurred in the FPU                                                   */
  __IM  uint32_t  RESERVED1[122];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
} NRF_FPU_Type;                                 /*!< Size = 780 (0x30c)                                                        */



/* =========================================================================================================================== */
/* ================                                          CACHE_S                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Cache (CACHE_S)
  */

typedef struct {                                /*!< CACHE_S Structure                                                         */
  __IM  uint32_t  RESERVED[256];
  __IOM CACHE_PROFILING_Type PROFILING[2];      /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED1[48];
  __IOM uint32_t  ENABLE;                       /*!< Enable cache.                                                             */
  __OM  uint32_t  INVALIDATE;                   /*!< Invalidate the cache.                                                     */
  __OM  uint32_t  ERASE;                        /*!< Erase the cache.                                                          */
  __IOM uint32_t  PROFILINGENABLE;              /*!< Enable the profiling counters.                                            */
  __OM  uint32_t  PROFILINGCLEAR;               /*!< Clear the profiling counters.                                             */
  __IOM uint32_t  MODE;                         /*!< Cache mode. Switching from Cache to Ram mode causes the RAM
                                                     to be cleared. Switching from RAM to Cache mode causes
                                                     the cache to be invalidated.                                              */
  __IOM uint32_t  DEBUGLOCK;                    /*!< Lock debug mode.                                                          */
  __IOM uint32_t  ERASESTATUS;                  /*!< Cache erase status.                                                       */
  __IOM uint32_t  WRITELOCK;                    /*!< Lock cache updates. Prevents updating of cache content on cache
                                                     misses, but will continue to lookup instruction/data fetches
                                                     in content already present in the cache. Ignored in RAM
                                                     mode.                                                                     */
} NRF_CACHE_Type;                               /*!< Size = 1316 (0x524)                                                       */



/* =========================================================================================================================== */
/* ================                                           SPU_S                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief System protection unit (SPU_S)
  */

typedef struct {                                /*!< SPU_S Structure                                                           */
  __IM  uint32_t  RESERVED[64];
  __IOM uint32_t  EVENTS_RAMACCERR;             /*!< A security violation has been detected for the RAM memory space           */
  __IOM uint32_t  EVENTS_FLASHACCERR;           /*!< A security violation has been detected for the flash memory
                                                     space                                                                     */
  __IOM uint32_t  EVENTS_PERIPHACCERR;          /*!< A security violation has been detected on one or several peripherals      */
  __IM  uint32_t  RESERVED1[29];
  __IOM uint32_t  PUBLISH_RAMACCERR;            /*!< Publish configuration for event RAMACCERR                                 */
  __IOM uint32_t  PUBLISH_FLASHACCERR;          /*!< Publish configuration for event FLASHACCERR                               */
  __IOM uint32_t  PUBLISH_PERIPHACCERR;         /*!< Publish configuration for event PERIPHACCERR                              */
  __IM  uint32_t  RESERVED2[93];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  CAP;                          /*!< Show implemented features for the current device                          */
  __IOM uint32_t  CPULOCK;                      /*!< Configure bits to lock down CPU features at runtime                       */
  __IM  uint32_t  RESERVED4[14];
  __IOM SPU_EXTDOMAIN_Type EXTDOMAIN[1];        /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5[15];
  __IOM SPU_DPPI_Type DPPI[1];                  /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED6[14];
  __IOM SPU_GPIOPORT_Type GPIOPORT[2];          /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[12];
  __IOM SPU_FLASHNSC_Type FLASHNSC[2];          /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED8[12];
  __IOM SPU_RAMNSC_Type RAMNSC[2];              /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED9[44];
  __IOM SPU_FLASHREGION_Type FLASHREGION[64];   /*!< Unspecified                                                               */
  __IOM SPU_RAMREGION_Type RAMREGION[64];       /*!< Unspecified                                                               */
  __IOM SPU_PERIPHID_Type PERIPHID[256];        /*!< Unspecified                                                               */
} NRF_SPU_Type;                                 /*!< Size = 3072 (0xc00)                                                       */



/* =========================================================================================================================== */
/* ================                                      OSCILLATORS_NS                                       ================ */
/* =========================================================================================================================== */


/**
  * @brief Oscillator control 0 (OSCILLATORS_NS)
  */

typedef struct {                                /*!< OSCILLATORS_NS Structure                                                  */
  __IM  uint32_t  RESERVED[369];
  __IOM uint32_t  XOSC32MCAPS;                  /*!< Programmable capacitance of XC1 and XC2                                   */
  __IM  uint32_t  RESERVED1[62];
  __IOM OSCILLATORS_XOSC32KI_Type XOSC32KI;     /*!< Unspecified                                                               */
} NRF_OSCILLATORS_Type;                         /*!< Size = 1748 (0x6d4)                                                       */



/* =========================================================================================================================== */
/* ================                                       REGULATORS_NS                                       ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage regulators 0 (REGULATORS_NS)
  */

typedef struct {                                /*!< REGULATORS_NS Structure                                                   */
  __IM  uint32_t  RESERVED[266];
  __IM  uint32_t  MAINREGSTATUS;                /*!< Main supply status                                                        */
  __IM  uint32_t  RESERVED1[53];
  __OM  uint32_t  SYSTEMOFF;                    /*!< System OFF register                                                       */
  __IM  uint32_t  RESERVED2[3];
  __IOM uint32_t  POFCON;                       /*!< Power-fail comparator configuration                                       */
  __IM  uint32_t  RESERVED3[124];
  __IOM REGULATORS_VREGMAIN_Type VREGMAIN;      /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED4[126];
  __IOM REGULATORS_VREGRADIO_Type VREGRADIO;    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED5[126];
  __IOM REGULATORS_VREGH_Type VREGH;            /*!< Unspecified                                                               */
} NRF_REGULATORS_Type;                          /*!< Size = 2820 (0xb04)                                                       */



/* =========================================================================================================================== */
/* ================                                         CLOCK_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock management 0 (CLOCK_NS)
  */

typedef struct {                                /*!< CLOCK_NS Structure                                                        */
  __OM  uint32_t  TASKS_HFCLKSTART;             /*!< Start HFCLK128M/HFCLK64M source as selected in HFCLKSRC                   */
  __OM  uint32_t  TASKS_HFCLKSTOP;              /*!< Stop HFCLK128M/HFCLK64M source                                            */
  __OM  uint32_t  TASKS_LFCLKSTART;             /*!< Start LFCLK source as selected in LFCLKSRC                                */
  __OM  uint32_t  TASKS_LFCLKSTOP;              /*!< Stop LFCLK source                                                         */
  __OM  uint32_t  TASKS_CAL;                    /*!< Start calibration of LFRC oscillator                                      */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_HFCLKAUDIOSTART;        /*!< Start HFCLKAUDIO source                                                   */
  __OM  uint32_t  TASKS_HFCLKAUDIOSTOP;         /*!< Stop HFCLKAUDIO source                                                    */
  __OM  uint32_t  TASKS_HFCLK192MSTART;         /*!< Start HFCLK192M source as selected in HFCLK192MSRC                        */
  __OM  uint32_t  TASKS_HFCLK192MSTOP;          /*!< Stop HFCLK192M source                                                     */
  __IM  uint32_t  RESERVED1[22];
  __IOM uint32_t  SUBSCRIBE_HFCLKSTART;         /*!< Subscribe configuration for task HFCLKSTART                               */
  __IOM uint32_t  SUBSCRIBE_HFCLKSTOP;          /*!< Subscribe configuration for task HFCLKSTOP                                */
  __IOM uint32_t  SUBSCRIBE_LFCLKSTART;         /*!< Subscribe configuration for task LFCLKSTART                               */
  __IOM uint32_t  SUBSCRIBE_LFCLKSTOP;          /*!< Subscribe configuration for task LFCLKSTOP                                */
  __IOM uint32_t  SUBSCRIBE_CAL;                /*!< Subscribe configuration for task CAL                                      */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  SUBSCRIBE_HFCLKAUDIOSTART;    /*!< Subscribe configuration for task HFCLKAUDIOSTART                          */
  __IOM uint32_t  SUBSCRIBE_HFCLKAUDIOSTOP;     /*!< Subscribe configuration for task HFCLKAUDIOSTOP                           */
  __IOM uint32_t  SUBSCRIBE_HFCLK192MSTART;     /*!< Subscribe configuration for task HFCLK192MSTART                           */
  __IOM uint32_t  SUBSCRIBE_HFCLK192MSTOP;      /*!< Subscribe configuration for task HFCLK192MSTOP                            */
  __IM  uint32_t  RESERVED3[22];
  __IOM uint32_t  EVENTS_HFCLKSTARTED;          /*!< HFCLK128M/HFCLK64M source started                                         */
  __IOM uint32_t  EVENTS_LFCLKSTARTED;          /*!< LFCLK source started                                                      */
  __IM  uint32_t  RESERVED4[5];
  __IOM uint32_t  EVENTS_DONE;                  /*!< Calibration of LFRC oscillator complete event                             */
  __IOM uint32_t  EVENTS_HFCLKAUDIOSTARTED;     /*!< HFCLKAUDIO source started                                                 */
  __IOM uint32_t  EVENTS_HFCLK192MSTARTED;      /*!< HFCLK192M source started                                                  */
  __IM  uint32_t  RESERVED5[22];
  __IOM uint32_t  PUBLISH_HFCLKSTARTED;         /*!< Publish configuration for event HFCLKSTARTED                              */
  __IOM uint32_t  PUBLISH_LFCLKSTARTED;         /*!< Publish configuration for event LFCLKSTARTED                              */
  __IM  uint32_t  RESERVED6[5];
  __IOM uint32_t  PUBLISH_DONE;                 /*!< Publish configuration for event DONE                                      */
  __IOM uint32_t  PUBLISH_HFCLKAUDIOSTARTED;    /*!< Publish configuration for event HFCLKAUDIOSTARTED                         */
  __IOM uint32_t  PUBLISH_HFCLK192MSTARTED;     /*!< Publish configuration for event HFCLK192MSTARTED                          */
  __IM  uint32_t  RESERVED7[86];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED8[62];
  __IM  uint32_t  HFCLKRUN;                     /*!< Status indicating that HFCLKSTART task has been triggered                 */
  __IM  uint32_t  HFCLKSTAT;                    /*!< Status indicating which HFCLK128M/HFCLK64M source is running
                                                     This register value in any CLOCK instance reflects status
                                                     only due to configurations/actions in that CLOCK instance.                */
  __IM  uint32_t  RESERVED9;
  __IM  uint32_t  LFCLKRUN;                     /*!< Status indicating that LFCLKSTART task has been triggered                 */
  __IM  uint32_t  LFCLKSTAT;                    /*!< Status indicating which LFCLK source is running This register
                                                     value in any CLOCK instance reflects status only due to
                                                     configurations/actions in that CLOCK instance.                            */
  __IM  uint32_t  LFCLKSRCCOPY;                 /*!< Copy of LFCLKSRC register, set when LFCLKSTART task was triggered         */
  __IM  uint32_t  RESERVED10[12];
  __IM  uint32_t  HFCLKAUDIORUN;                /*!< Status indicating that HFCLKAUDIOSTART task has been triggered            */
  __IM  uint32_t  HFCLKAUDIOSTAT;               /*!< Status indicating which HFCLKAUDIO source is running                      */
  __IM  uint32_t  HFCLK192MRUN;                 /*!< Status indicating that HFCLK192MSTART task has been triggered             */
  __IM  uint32_t  HFCLK192MSTAT;                /*!< Status indicating which HFCLK192M source is running                       */
  __IM  uint32_t  RESERVED11[45];
  __IOM uint32_t  HFCLKSRC;                     /*!< Clock source for HFCLK128M/HFCLK64M                                       */
  __IOM uint32_t  LFCLKSRC;                     /*!< Clock source for LFCLK                                                    */
  __IM  uint32_t  RESERVED12[15];
  __IOM uint32_t  HFCLKCTRL;                    /*!< HFCLK128M frequency configuration                                         */
  __IOM CLOCK_HFCLKAUDIO_Type HFCLKAUDIO;       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED13[4];
  __IOM uint32_t  HFCLKALWAYSRUN;               /*!< Automatic or manual control of HFCLK128M/HFCLK64M                         */
  __IOM uint32_t  LFCLKALWAYSRUN;               /*!< Automatic or manual control of LFCLK                                      */
  __IM  uint32_t  RESERVED14;
  __IOM uint32_t  HFCLKAUDIOALWAYSRUN;          /*!< Automatic or manual control of HFCLKAUDIO                                 */
  __IOM uint32_t  HFCLK192MSRC;                 /*!< Clock source for HFCLK192M                                                */
  __IOM uint32_t  HFCLK192MALWAYSRUN;           /*!< Automatic or manual control of HFCLK192M                                  */
  __IM  uint32_t  RESERVED15[12];
  __IOM uint32_t  HFCLK192MCTRL;                /*!< HFCLK192M frequency configuration                                         */
} NRF_CLOCK_Type;                               /*!< Size = 1468 (0x5bc)                                                       */



/* =========================================================================================================================== */
/* ================                                         POWER_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Power control 0 (POWER_NS)
  */

typedef struct {                                /*!< POWER_NS Structure                                                        */
  __IM  uint32_t  RESERVED[30];
  __OM  uint32_t  TASKS_CONSTLAT;               /*!< Enable Constant Latency mode                                              */
  __OM  uint32_t  TASKS_LOWPWR;                 /*!< Enable Low-Power mode (variable latency)                                  */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  SUBSCRIBE_CONSTLAT;           /*!< Subscribe configuration for task CONSTLAT                                 */
  __IOM uint32_t  SUBSCRIBE_LOWPWR;             /*!< Subscribe configuration for task LOWPWR                                   */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_POFWARN;               /*!< Power failure warning                                                     */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_SLEEPENTER;            /*!< CPU entered WFI/WFE sleep                                                 */
  __IOM uint32_t  EVENTS_SLEEPEXIT;             /*!< CPU exited WFI/WFE sleep                                                  */
  __IM  uint32_t  RESERVED4[27];
  __IOM uint32_t  PUBLISH_POFWARN;              /*!< Publish configuration for event POFWARN                                   */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  PUBLISH_SLEEPENTER;           /*!< Publish configuration for event SLEEPENTER                                */
  __IOM uint32_t  PUBLISH_SLEEPEXIT;            /*!< Publish configuration for event SLEEPEXIT                                 */
  __IM  uint32_t  RESERVED6[89];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[132];
  __IOM uint32_t  GPREGRET[2];                  /*!< Description collection: General purpose retention register                */
} NRF_POWER_Type;                               /*!< Size = 1316 (0x524)                                                       */



/* =========================================================================================================================== */
/* ================                                         RESET_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Reset control 0 (RESET_NS)
  */

typedef struct {                                /*!< RESET_NS Structure                                                        */
  __IM  uint32_t  RESERVED[256];
  __IOM uint32_t  RESETREAS;                    /*!< Reset reason                                                              */
  __IM  uint32_t  RESERVED1[131];
  __IOM RESET_NETWORK_Type NETWORK;             /*!< ULP network core control                                                  */
} NRF_RESET_Type;                               /*!< Size = 1560 (0x618)                                                       */



/* =========================================================================================================================== */
/* ================                                         CTRLAP_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Control access port 0 (CTRLAP_NS)
  */

typedef struct {                                /*!< CTRLAP_NS Structure                                                       */
  __IM  uint32_t  RESERVED[256];
  __IOM CTRLAPPERI_MAILBOX_Type MAILBOX;        /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED1[30];
  __IOM CTRLAPPERI_ERASEPROTECT_Type ERASEPROTECT;/*!< Unspecified                                                             */
  __IM  uint32_t  RESERVED2[14];
  __IOM CTRLAPPERI_APPROTECT_Type APPROTECT;    /*!< Unspecified                                                               */
  __IOM CTRLAPPERI_SECUREAPPROTECT_Type SECUREAPPROTECT;/*!< Unspecified                                                       */
  __IM  uint32_t  RESERVED3[44];
  __IM  uint32_t  STATUS;                       /*!< Status bits for CTRL-AP peripheral.                                       */
} NRF_CTRLAPPERI_Type;                          /*!< Size = 1540 (0x604)                                                       */



/* =========================================================================================================================== */
/* ================                                         SPIM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Peripheral Interface Master with EasyDMA 0 (SPIM0_NS)
  */

typedef struct {                                /*!< SPIM0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_START;                  /*!< Start SPI transaction                                                     */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop SPI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend SPI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume SPI transaction                                                    */
  __IM  uint32_t  RESERVED2[27];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED4[24];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< SPI transaction has stopped                                               */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  EVENTS_END;                   /*!< End of RXD buffer and TXD buffer reached                                  */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< End of TXD buffer reached                                                 */
  __IM  uint32_t  RESERVED8[10];
  __IOM uint32_t  EVENTS_STARTED;               /*!< Transaction started                                                       */
  __IM  uint32_t  RESERVED9[13];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED11;
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED12;
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IM  uint32_t  RESERVED13[10];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IM  uint32_t  RESERVED14[12];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED15[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED16[61];
  __IOM uint32_t  STALLSTAT;                    /*!< Stall status for EasyDMA RAM accesses. The fields in this register
                                                     are set to STALL by hardware whenever a stall occurres
                                                     and can be cleared (set to NOSTALL) by the CPU.                           */
  __IM  uint32_t  RESERVED17[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPIM                                                               */
  __IM  uint32_t  RESERVED18;
  __IOM SPIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED19[3];
  __IOM uint32_t  FREQUENCY;                    /*!< SPI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED20[3];
  __IOM SPIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM SPIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED21[2];
  __IOM SPIM_IFTIMING_Type IFTIMING;            /*!< Unspecified                                                               */
  __IOM uint32_t  CSNPOL;                       /*!< Polarity of CSN output                                                    */
  __IOM uint32_t  PSELDCX;                      /*!< Pin select for DCX signal                                                 */
  __IOM uint32_t  DCXCNT;                       /*!< DCX configuration                                                         */
  __IM  uint32_t  RESERVED22[19];
  __IOM uint32_t  ORC;                          /*!< Byte transmitted after TXD.MAXCNT bytes have been transmitted
                                                     in the case when RXD.MAXCNT is greater than TXD.MAXCNT                    */
} NRF_SPIM_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         SPIS0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief SPI Slave 0 (SPIS0_NS)
  */

typedef struct {                                /*!< SPIS0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[9];
  __OM  uint32_t  TASKS_ACQUIRE;                /*!< Acquire SPI semaphore                                                     */
  __OM  uint32_t  TASKS_RELEASE;                /*!< Release SPI semaphore, enabling the SPI slave to acquire it               */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  SUBSCRIBE_ACQUIRE;            /*!< Subscribe configuration for task ACQUIRE                                  */
  __IOM uint32_t  SUBSCRIBE_RELEASE;            /*!< Subscribe configuration for task RELEASE                                  */
  __IM  uint32_t  RESERVED2[22];
  __IOM uint32_t  EVENTS_END;                   /*!< Granted transaction completed                                             */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< End of RXD buffer reached                                                 */
  __IM  uint32_t  RESERVED4[5];
  __IOM uint32_t  EVENTS_ACQUIRED;              /*!< Semaphore acquired                                                        */
  __IM  uint32_t  RESERVED5[22];
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED7[5];
  __IOM uint32_t  PUBLISH_ACQUIRED;             /*!< Publish configuration for event ACQUIRED                                  */
  __IM  uint32_t  RESERVED8[21];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED9[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED10[61];
  __IM  uint32_t  SEMSTAT;                      /*!< Semaphore status register                                                 */
  __IM  uint32_t  RESERVED11[15];
  __IOM uint32_t  STATUS;                       /*!< Status from last transaction                                              */
  __IM  uint32_t  RESERVED12[47];
  __IOM uint32_t  ENABLE;                       /*!< Enable SPI slave                                                          */
  __IM  uint32_t  RESERVED13;
  __IOM SPIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED14[7];
  __IOM SPIS_RXD_Type RXD;                      /*!< Unspecified                                                               */
  __IOM SPIS_TXD_Type TXD;                      /*!< Unspecified                                                               */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED15;
  __IOM uint32_t  DEF;                          /*!< Default character. Character clocked out in case of an ignored
                                                     transaction.                                                              */
  __IM  uint32_t  RESERVED16[24];
  __IOM uint32_t  ORC;                          /*!< Over-read character                                                       */
} NRF_SPIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         TWIM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Master Interface with EasyDMA 0 (TWIM0_NS)
  */

typedef struct {                                /*!< TWIM0_NS Structure                                                        */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start TWI receive sequence                                                */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start TWI transmit sequence                                               */
  __IM  uint32_t  RESERVED1[2];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction. Must be issued while the TWI master is
                                                     not suspended.                                                            */
  __IM  uint32_t  RESERVED2;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  SUBSCRIBE_STARTRX;            /*!< Subscribe configuration for task STARTRX                                  */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED7[24];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED8[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED9[8];
  __IOM uint32_t  EVENTS_SUSPENDED;             /*!< SUSPEND task has been issued, TWI traffic is now suspended.               */
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  EVENTS_LASTRX;                /*!< Byte boundary, starting to receive the last byte                          */
  __IOM uint32_t  EVENTS_LASTTX;                /*!< Byte boundary, starting to transmit the last byte                         */
  __IM  uint32_t  RESERVED11[8];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED12[7];
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED13[8];
  __IOM uint32_t  PUBLISH_SUSPENDED;            /*!< Publish configuration for event SUSPENDED                                 */
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED14[2];
  __IOM uint32_t  PUBLISH_LASTRX;               /*!< Publish configuration for event LASTRX                                    */
  __IOM uint32_t  PUBLISH_LASTTX;               /*!< Publish configuration for event LASTTX                                    */
  __IM  uint32_t  RESERVED15[7];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED16[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED17[110];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED18[14];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIM                                                               */
  __IM  uint32_t  RESERVED19;
  __IOM TWIM_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20[5];
  __IOM uint32_t  FREQUENCY;                    /*!< TWI frequency. Accuracy depends on the HFCLK source selected.             */
  __IM  uint32_t  RESERVED21[3];
  __IOM TWIM_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIM_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED22[13];
  __IOM uint32_t  ADDRESS;                      /*!< Address used in the TWI transfer                                          */
} NRF_TWIM_Type;                                /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                         TWIS0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief I2C compatible Two-Wire Slave Interface with EasyDMA 0 (TWIS0_NS)
  */

typedef struct {                                /*!< TWIS0_NS Structure                                                        */
  __IM  uint32_t  RESERVED[5];
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop TWI transaction                                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_SUSPEND;                /*!< Suspend TWI transaction                                                   */
  __OM  uint32_t  TASKS_RESUME;                 /*!< Resume TWI transaction                                                    */
  __IM  uint32_t  RESERVED2[3];
  __OM  uint32_t  TASKS_PREPARERX;              /*!< Prepare the TWI slave to respond to a write command                       */
  __OM  uint32_t  TASKS_PREPARETX;              /*!< Prepare the TWI slave to respond to a read command                        */
  __IM  uint32_t  RESERVED3[23];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_SUSPEND;            /*!< Subscribe configuration for task SUSPEND                                  */
  __IOM uint32_t  SUBSCRIBE_RESUME;             /*!< Subscribe configuration for task RESUME                                   */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  SUBSCRIBE_PREPARERX;          /*!< Subscribe configuration for task PREPARERX                                */
  __IOM uint32_t  SUBSCRIBE_PREPARETX;          /*!< Subscribe configuration for task PREPARETX                                */
  __IM  uint32_t  RESERVED6[19];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< TWI stopped                                                               */
  __IM  uint32_t  RESERVED7[7];
  __IOM uint32_t  EVENTS_ERROR;                 /*!< TWI error                                                                 */
  __IM  uint32_t  RESERVED8[9];
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< Receive sequence started                                                  */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< Transmit sequence started                                                 */
  __IM  uint32_t  RESERVED9[4];
  __IOM uint32_t  EVENTS_WRITE;                 /*!< Write command received                                                    */
  __IOM uint32_t  EVENTS_READ;                  /*!< Read command received                                                     */
  __IM  uint32_t  RESERVED10[6];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED11[7];
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED12[9];
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED13[4];
  __IOM uint32_t  PUBLISH_WRITE;                /*!< Publish configuration for event WRITE                                     */
  __IOM uint32_t  PUBLISH_READ;                 /*!< Publish configuration for event READ                                      */
  __IM  uint32_t  RESERVED14[5];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED15[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED16[113];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  MATCH;                        /*!< Status register indicating which address had a match                      */
  __IM  uint32_t  RESERVED17[10];
  __IOM uint32_t  ENABLE;                       /*!< Enable TWIS                                                               */
  __IM  uint32_t  RESERVED18;
  __IOM TWIS_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED19[9];
  __IOM TWIS_RXD_Type RXD;                      /*!< RXD EasyDMA channel                                                       */
  __IOM TWIS_TXD_Type TXD;                      /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED20[13];
  __IOM uint32_t  ADDRESS[2];                   /*!< Description collection: TWI slave address n                               */
  __IM  uint32_t  RESERVED21;
  __IOM uint32_t  CONFIG;                       /*!< Configuration register for the address match mechanism                    */
  __IM  uint32_t  RESERVED22[10];
  __IOM uint32_t  ORC;                          /*!< Over-read character. Character sent out in case of an over-read
                                                     of the transmit buffer.                                                   */
} NRF_TWIS_Type;                                /*!< Size = 1476 (0x5c4)                                                       */



/* =========================================================================================================================== */
/* ================                                         UARTE0_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief UART with EasyDMA 0 (UARTE0_NS)
  */

typedef struct {                                /*!< UARTE0_NS Structure                                                       */
  __OM  uint32_t  TASKS_STARTRX;                /*!< Start UART receiver                                                       */
  __OM  uint32_t  TASKS_STOPRX;                 /*!< Stop UART receiver                                                        */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start UART transmitter                                                    */
  __OM  uint32_t  TASKS_STOPTX;                 /*!< Stop UART transmitter                                                     */
  __IM  uint32_t  RESERVED[7];
  __OM  uint32_t  TASKS_FLUSHRX;                /*!< Flush RX FIFO into RX buffer                                              */
  __IM  uint32_t  RESERVED1[20];
  __IOM uint32_t  SUBSCRIBE_STARTRX;            /*!< Subscribe configuration for task STARTRX                                  */
  __IOM uint32_t  SUBSCRIBE_STOPRX;             /*!< Subscribe configuration for task STOPRX                                   */
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IOM uint32_t  SUBSCRIBE_STOPTX;             /*!< Subscribe configuration for task STOPTX                                   */
  __IM  uint32_t  RESERVED2[7];
  __IOM uint32_t  SUBSCRIBE_FLUSHRX;            /*!< Subscribe configuration for task FLUSHRX                                  */
  __IM  uint32_t  RESERVED3[20];
  __IOM uint32_t  EVENTS_CTS;                   /*!< CTS is activated (set low). Clear To Send.                                */
  __IOM uint32_t  EVENTS_NCTS;                  /*!< CTS is deactivated (set high). Not Clear To Send.                         */
  __IOM uint32_t  EVENTS_RXDRDY;                /*!< Data received in RXD (but potentially not yet transferred to
                                                     Data RAM)                                                                 */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< Receive buffer is filled up                                               */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  EVENTS_TXDRDY;                /*!< Data sent from TXD                                                        */
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< Last TX byte transmitted                                                  */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< Error detected                                                            */
  __IM  uint32_t  RESERVED6[7];
  __IOM uint32_t  EVENTS_RXTO;                  /*!< Receiver timeout                                                          */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_RXSTARTED;             /*!< UART receiver has started                                                 */
  __IOM uint32_t  EVENTS_TXSTARTED;             /*!< UART transmitter has started                                              */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  EVENTS_TXSTOPPED;             /*!< Transmitter stopped                                                       */
  __IM  uint32_t  RESERVED9[9];
  __IOM uint32_t  PUBLISH_CTS;                  /*!< Publish configuration for event CTS                                       */
  __IOM uint32_t  PUBLISH_NCTS;                 /*!< Publish configuration for event NCTS                                      */
  __IOM uint32_t  PUBLISH_RXDRDY;               /*!< Publish configuration for event RXDRDY                                    */
  __IM  uint32_t  RESERVED10;
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IM  uint32_t  RESERVED11[2];
  __IOM uint32_t  PUBLISH_TXDRDY;               /*!< Publish configuration for event TXDRDY                                    */
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED12[7];
  __IOM uint32_t  PUBLISH_RXTO;                 /*!< Publish configuration for event RXTO                                      */
  __IM  uint32_t  RESERVED13;
  __IOM uint32_t  PUBLISH_RXSTARTED;            /*!< Publish configuration for event RXSTARTED                                 */
  __IOM uint32_t  PUBLISH_TXSTARTED;            /*!< Publish configuration for event TXSTARTED                                 */
  __IM  uint32_t  RESERVED14;
  __IOM uint32_t  PUBLISH_TXSTOPPED;            /*!< Publish configuration for event TXSTOPPED                                 */
  __IM  uint32_t  RESERVED15[9];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED16[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED17[93];
  __IOM uint32_t  ERRORSRC;                     /*!< Error source                                                              */
  __IM  uint32_t  RESERVED18[31];
  __IOM uint32_t  ENABLE;                       /*!< Enable UART                                                               */
  __IM  uint32_t  RESERVED19;
  __IOM UARTE_PSEL_Type PSEL;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20[3];
  __IOM uint32_t  BAUDRATE;                     /*!< Baud rate. Accuracy depends on the HFCLK source selected.                 */
  __IM  uint32_t  RESERVED21[3];
  __IOM UARTE_RXD_Type RXD;                     /*!< RXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED22;
  __IOM UARTE_TXD_Type TXD;                     /*!< TXD EasyDMA channel                                                       */
  __IM  uint32_t  RESERVED23[7];
  __IOM uint32_t  CONFIG;                       /*!< Configuration of parity and hardware flow control                         */
} NRF_UARTE_Type;                               /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                         GPIOTE0_S                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Tasks and Events 0 (GPIOTE0_S)
  */

typedef struct {                                /*!< GPIOTE0_S Structure                                                       */
  __OM  uint32_t  TASKS_OUT[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is configured in CONFIG[n].POLARITY.        */
  __IM  uint32_t  RESERVED[4];
  __OM  uint32_t  TASKS_SET[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it high.                          */
  __IM  uint32_t  RESERVED1[4];
  __OM  uint32_t  TASKS_CLR[8];                 /*!< Description collection: Task for writing to pin specified in
                                                     CONFIG[n].PSEL. Action on pin is to set it low.                           */
  __IOM uint32_t  SUBSCRIBE_OUT[8];             /*!< Description collection: Subscribe configuration for task OUT[n]           */
  __IM  uint32_t  RESERVED2[4];
  __IOM uint32_t  SUBSCRIBE_SET[8];             /*!< Description collection: Subscribe configuration for task SET[n]           */
  __IM  uint32_t  RESERVED3[4];
  __IOM uint32_t  SUBSCRIBE_CLR[8];             /*!< Description collection: Subscribe configuration for task CLR[n]           */
  __IOM uint32_t  EVENTS_IN[8];                 /*!< Description collection: Event generated from pin specified in
                                                     CONFIG[n].PSEL                                                            */
  __IM  uint32_t  RESERVED4[23];
  __IOM uint32_t  EVENTS_PORT;                  /*!< Event generated from multiple input GPIO pins with SENSE mechanism
                                                     enabled                                                                   */
  __IOM uint32_t  PUBLISH_IN[8];                /*!< Description collection: Publish configuration for event IN[n]             */
  __IM  uint32_t  RESERVED5[23];
  __IOM uint32_t  PUBLISH_PORT;                 /*!< Publish configuration for event PORT                                      */
  __IM  uint32_t  RESERVED6[65];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[126];
  __IOM uint32_t  LATENCY;                      /*!< Latency selection for Event mode (MODE=Event) with rising or
                                                     falling edge detection on the pin.                                        */
  __IM  uint32_t  RESERVED8[2];
  __IOM uint32_t  CONFIG[8];                    /*!< Description collection: Configuration for OUT[n], SET[n], and
                                                     CLR[n] tasks and IN[n] event                                              */
} NRF_GPIOTE_Type;                              /*!< Size = 1328 (0x530)                                                       */



/* =========================================================================================================================== */
/* ================                                         SAADC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Analog to Digital Converter 0 (SAADC_NS)
  */

typedef struct {                                /*!< SAADC_NS Structure                                                        */
  __OM  uint32_t  TASKS_START;                  /*!< Start the ADC and prepare the result buffer in RAM                        */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Take one ADC sample, if scan is enabled all channels are sampled          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop the ADC and terminate any ongoing conversion                         */
  __OM  uint32_t  TASKS_CALIBRATEOFFSET;        /*!< Starts offset auto-calibration                                            */
  __IM  uint32_t  RESERVED[28];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_SAMPLE;             /*!< Subscribe configuration for task SAMPLE                                   */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_CALIBRATEOFFSET;    /*!< Subscribe configuration for task CALIBRATEOFFSET                          */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  EVENTS_STARTED;               /*!< The ADC has started                                                       */
  __IOM uint32_t  EVENTS_END;                   /*!< The ADC has filled up the Result buffer                                   */
  __IOM uint32_t  EVENTS_DONE;                  /*!< A conversion task has been completed. Depending on the mode,
                                                     multiple conversions might be needed for a result to be
                                                     transferred to RAM.                                                       */
  __IOM uint32_t  EVENTS_RESULTDONE;            /*!< A result is ready to get transferred to RAM                               */
  __IOM uint32_t  EVENTS_CALIBRATEDONE;         /*!< Calibration is complete                                                   */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< The ADC has stopped                                                       */
  __IOM SAADC_EVENTS_CH_Type EVENTS_CH[8];      /*!< Peripheral events.                                                        */
  __IM  uint32_t  RESERVED2[10];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IOM uint32_t  PUBLISH_DONE;                 /*!< Publish configuration for event DONE                                      */
  __IOM uint32_t  PUBLISH_RESULTDONE;           /*!< Publish configuration for event RESULTDONE                                */
  __IOM uint32_t  PUBLISH_CALIBRATEDONE;        /*!< Publish configuration for event CALIBRATEDONE                             */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IOM SAADC_PUBLISH_CH_Type PUBLISH_CH[8];    /*!< Publish configuration for events                                          */
  __IM  uint32_t  RESERVED3[74];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[61];
  __IM  uint32_t  STATUS;                       /*!< Status                                                                    */
  __IM  uint32_t  RESERVED5[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable or disable ADC                                                     */
  __IM  uint32_t  RESERVED6[3];
  __IOM SAADC_CH_Type CH[8];                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[24];
  __IOM uint32_t  RESOLUTION;                   /*!< Resolution configuration                                                  */
  __IOM uint32_t  OVERSAMPLE;                   /*!< Oversampling configuration. OVERSAMPLE should not be combined
                                                     with SCAN. The RESOLUTION is applied before averaging,
                                                     thus for high OVERSAMPLE a higher RESOLUTION should be
                                                     used.                                                                     */
  __IOM uint32_t  SAMPLERATE;                   /*!< Controls normal or continuous sample rate                                 */
  __IM  uint32_t  RESERVED8[12];
  __IOM SAADC_RESULT_Type RESULT;               /*!< RESULT EasyDMA channel                                                    */
} NRF_SAADC_Type;                               /*!< Size = 1592 (0x638)                                                       */



/* =========================================================================================================================== */
/* ================                                         TIMER0_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Timer/Counter 0 (TIMER0_NS)
  */

typedef struct {                                /*!< TIMER0_NS Structure                                                       */
  __OM  uint32_t  TASKS_START;                  /*!< Start Timer                                                               */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop Timer                                                                */
  __OM  uint32_t  TASKS_COUNT;                  /*!< Increment Timer (Counter mode only)                                       */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear time                                                                */
  __OM  uint32_t  TASKS_SHUTDOWN;               /*!< Deprecated register - Shut down timer                                     */
  __IM  uint32_t  RESERVED[11];
  __OM  uint32_t  TASKS_CAPTURE[6];             /*!< Description collection: Capture Timer value to CC[n] register             */
  __IM  uint32_t  RESERVED1[10];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_COUNT;              /*!< Subscribe configuration for task COUNT                                    */
  __IOM uint32_t  SUBSCRIBE_CLEAR;              /*!< Subscribe configuration for task CLEAR                                    */
  __IOM uint32_t  SUBSCRIBE_SHUTDOWN;           /*!< Deprecated register - Subscribe configuration for task SHUTDOWN           */
  __IM  uint32_t  RESERVED2[11];
  __IOM uint32_t  SUBSCRIBE_CAPTURE[6];         /*!< Description collection: Subscribe configuration for task CAPTURE[n]       */
  __IM  uint32_t  RESERVED3[26];
  __IOM uint32_t  EVENTS_COMPARE[6];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED4[26];
  __IOM uint32_t  PUBLISH_COMPARE[6];           /*!< Description collection: Publish configuration for event COMPARE[n]        */
  __IM  uint32_t  RESERVED5[10];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED7[126];
  __IOM uint32_t  MODE;                         /*!< Timer mode selection                                                      */
  __IOM uint32_t  BITMODE;                      /*!< Configure the number of bits used by the TIMER                            */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  PRESCALER;                    /*!< Timer prescaler register                                                  */
  __IM  uint32_t  RESERVED9[11];
  __IOM uint32_t  CC[6];                        /*!< Description collection: Capture/Compare register n                        */
  __IM  uint32_t  RESERVED10[10];
  __IOM uint32_t  ONESHOTEN[6];                 /*!< Description collection: Enable one-shot operation for Capture/Compare
                                                     channel n                                                                 */
} NRF_TIMER_Type;                               /*!< Size = 1432 (0x598)                                                       */



/* =========================================================================================================================== */
/* ================                                          RTC0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-time counter 0 (RTC0_NS)
  */

typedef struct {                                /*!< RTC0_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Start RTC counter                                                         */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop RTC counter                                                          */
  __OM  uint32_t  TASKS_CLEAR;                  /*!< Clear RTC counter                                                         */
  __OM  uint32_t  TASKS_TRIGOVRFLW;             /*!< Set counter to 0xFFFFF0                                                   */
  __IM  uint32_t  RESERVED[12];
  __OM  uint32_t  TASKS_CAPTURE[4];             /*!< Description collection: Capture RTC counter to CC[n] register             */
  __IM  uint32_t  RESERVED1[12];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_CLEAR;              /*!< Subscribe configuration for task CLEAR                                    */
  __IOM uint32_t  SUBSCRIBE_TRIGOVRFLW;         /*!< Subscribe configuration for task TRIGOVRFLW                               */
  __IM  uint32_t  RESERVED2[12];
  __IOM uint32_t  SUBSCRIBE_CAPTURE[4];         /*!< Description collection: Subscribe configuration for task CAPTURE[n]       */
  __IM  uint32_t  RESERVED3[12];
  __IOM uint32_t  EVENTS_TICK;                  /*!< Event on counter increment                                                */
  __IOM uint32_t  EVENTS_OVRFLW;                /*!< Event on counter overflow                                                 */
  __IM  uint32_t  RESERVED4[14];
  __IOM uint32_t  EVENTS_COMPARE[4];            /*!< Description collection: Compare event on CC[n] match                      */
  __IM  uint32_t  RESERVED5[12];
  __IOM uint32_t  PUBLISH_TICK;                 /*!< Publish configuration for event TICK                                      */
  __IOM uint32_t  PUBLISH_OVRFLW;               /*!< Publish configuration for event OVRFLW                                    */
  __IM  uint32_t  RESERVED6[14];
  __IOM uint32_t  PUBLISH_COMPARE[4];           /*!< Description collection: Publish configuration for event COMPARE[n]        */
  __IM  uint32_t  RESERVED7[12];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED8[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED9[13];
  __IOM uint32_t  EVTEN;                        /*!< Enable or disable event routing                                           */
  __IOM uint32_t  EVTENSET;                     /*!< Enable event routing                                                      */
  __IOM uint32_t  EVTENCLR;                     /*!< Disable event routing                                                     */
  __IM  uint32_t  RESERVED10[110];
  __IM  uint32_t  COUNTER;                      /*!< Current counter value                                                     */
  __IOM uint32_t  PRESCALER;                    /*!< 12-bit prescaler for counter frequency (32768 / (PRESCALER +
                                                     1)). Must be written when RTC is stopped.                                 */
  __IM  uint32_t  RESERVED11[13];
  __IOM uint32_t  CC[4];                        /*!< Description collection: Compare register n                                */
} NRF_RTC_Type;                                 /*!< Size = 1360 (0x550)                                                       */



/* =========================================================================================================================== */
/* ================                                         DPPIC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Distributed programmable peripheral interconnect controller 0 (DPPIC_NS)
  */

typedef struct {                                /*!< DPPIC_NS Structure                                                        */
  __OM  DPPIC_TASKS_CHG_Type TASKS_CHG[6];      /*!< Channel group tasks                                                       */
  __IM  uint32_t  RESERVED[20];
  __IOM DPPIC_SUBSCRIBE_CHG_Type SUBSCRIBE_CHG[6];/*!< Subscribe configuration for tasks                                       */
  __IM  uint32_t  RESERVED1[276];
  __IOM uint32_t  CHEN;                         /*!< Channel enable register                                                   */
  __IOM uint32_t  CHENSET;                      /*!< Channel enable set register                                               */
  __IOM uint32_t  CHENCLR;                      /*!< Channel enable clear register                                             */
  __IM  uint32_t  RESERVED2[189];
  __IOM uint32_t  CHG[6];                       /*!< Description collection: Channel group n Note: Writes to this
                                                     register are ignored if either SUBSCRIBE_CHG[n].EN or SUBSCRIBE_CHG[n].DI
                                                     is enabled                                                                */
} NRF_DPPIC_Type;                               /*!< Size = 2072 (0x818)                                                       */



/* =========================================================================================================================== */
/* ================                                          WDT0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer 0 (WDT0_NS)
  */

typedef struct {                                /*!< WDT0_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Start WDT                                                                 */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop WDT                                                                  */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_TIMEOUT;               /*!< Watchdog timeout                                                          */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< Watchdog stopped                                                          */
  __IM  uint32_t  RESERVED2[30];
  __IOM uint32_t  PUBLISH_TIMEOUT;              /*!< Publish configuration for event TIMEOUT                                   */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED3[95];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[6];
  __IOM uint32_t  NMIENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  NMIENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[53];
  __IM  uint32_t  RUNSTATUS;                    /*!< Run status                                                                */
  __IM  uint32_t  REQSTATUS;                    /*!< Request status                                                            */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  CRV;                          /*!< Counter reload value                                                      */
  __IOM uint32_t  RREN;                         /*!< Enable register for reload request registers                              */
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED7[4];
  __OM  uint32_t  TSEN;                         /*!< Task stop enable                                                          */
  __IM  uint32_t  RESERVED8[55];
  __OM  uint32_t  RR[8];                        /*!< Description collection: Reload request n                                  */
} NRF_WDT_Type;                                 /*!< Size = 1568 (0x620)                                                       */



/* =========================================================================================================================== */
/* ================                                          COMP_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator 0 (COMP_NS)
  */

typedef struct {                                /*!< COMP_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Start comparator                                                          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop comparator                                                           */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Sample comparator value                                                   */
  __IM  uint32_t  RESERVED[29];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_SAMPLE;             /*!< Subscribe configuration for task SAMPLE                                   */
  __IM  uint32_t  RESERVED1[29];
  __IOM uint32_t  EVENTS_READY;                 /*!< COMP is ready and output is valid                                         */
  __IOM uint32_t  EVENTS_DOWN;                  /*!< Downward crossing                                                         */
  __IOM uint32_t  EVENTS_UP;                    /*!< Upward crossing                                                           */
  __IOM uint32_t  EVENTS_CROSS;                 /*!< Downward or upward crossing                                               */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  PUBLISH_READY;                /*!< Publish configuration for event READY                                     */
  __IOM uint32_t  PUBLISH_DOWN;                 /*!< Publish configuration for event DOWN                                      */
  __IOM uint32_t  PUBLISH_UP;                   /*!< Publish configuration for event UP                                        */
  __IOM uint32_t  PUBLISH_CROSS;                /*!< Publish configuration for event CROSS                                     */
  __IM  uint32_t  RESERVED3[28];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED4[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[61];
  __IM  uint32_t  RESULT;                       /*!< Compare result                                                            */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  ENABLE;                       /*!< COMP enable                                                               */
  __IOM uint32_t  PSEL;                         /*!< Pin select                                                                */
  __IOM uint32_t  REFSEL;                       /*!< Reference source select for single-ended mode                             */
  __IOM uint32_t  EXTREFSEL;                    /*!< External reference select                                                 */
  __IM  uint32_t  RESERVED7[8];
  __IOM uint32_t  TH;                           /*!< Threshold configuration for hysteresis unit                               */
  __IOM uint32_t  MODE;                         /*!< Mode configuration                                                        */
  __IOM uint32_t  HYST;                         /*!< Comparator hysteresis enable                                              */
  __IOM uint32_t  ISOURCE;                      /*!< Current source select on analog input                                     */
} NRF_COMP_Type;                                /*!< Size = 1344 (0x540)                                                       */



/* =========================================================================================================================== */
/* ================                                         LPCOMP_NS                                         ================ */
/* =========================================================================================================================== */


/**
  * @brief Low-power comparator 0 (LPCOMP_NS)
  */

typedef struct {                                /*!< LPCOMP_NS Structure                                                       */
  __OM  uint32_t  TASKS_START;                  /*!< Start comparator                                                          */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stop comparator                                                           */
  __OM  uint32_t  TASKS_SAMPLE;                 /*!< Sample comparator value                                                   */
  __IM  uint32_t  RESERVED[29];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_SAMPLE;             /*!< Subscribe configuration for task SAMPLE                                   */
  __IM  uint32_t  RESERVED1[29];
  __IOM uint32_t  EVENTS_READY;                 /*!< LPCOMP is ready and output is valid                                       */
  __IOM uint32_t  EVENTS_DOWN;                  /*!< Downward crossing                                                         */
  __IOM uint32_t  EVENTS_UP;                    /*!< Upward crossing                                                           */
  __IOM uint32_t  EVENTS_CROSS;                 /*!< Downward or upward crossing                                               */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  PUBLISH_READY;                /*!< Publish configuration for event READY                                     */
  __IOM uint32_t  PUBLISH_DOWN;                 /*!< Publish configuration for event DOWN                                      */
  __IOM uint32_t  PUBLISH_UP;                   /*!< Publish configuration for event UP                                        */
  __IOM uint32_t  PUBLISH_CROSS;                /*!< Publish configuration for event CROSS                                     */
  __IM  uint32_t  RESERVED3[28];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED4[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[61];
  __IM  uint32_t  RESULT;                       /*!< Compare result                                                            */
  __IM  uint32_t  RESERVED6[63];
  __IOM uint32_t  ENABLE;                       /*!< Enable LPCOMP                                                             */
  __IOM uint32_t  PSEL;                         /*!< Input pin select                                                          */
  __IOM uint32_t  REFSEL;                       /*!< Reference select                                                          */
  __IOM uint32_t  EXTREFSEL;                    /*!< External reference select                                                 */
  __IM  uint32_t  RESERVED7[4];
  __IOM uint32_t  ANADETECT;                    /*!< Analog detect configuration                                               */
  __IM  uint32_t  RESERVED8[5];
  __IOM uint32_t  HYST;                         /*!< Comparator hysteresis enable                                              */
} NRF_LPCOMP_Type;                              /*!< Size = 1340 (0x53c)                                                       */



/* =========================================================================================================================== */
/* ================                                          EGU0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Event generator unit 0 (EGU0_NS)
  */

typedef struct {                                /*!< EGU0_NS Structure                                                         */
  __OM  uint32_t  TASKS_TRIGGER[16];            /*!< Description collection: Trigger n for triggering the corresponding
                                                     TRIGGERED[n] event                                                        */
  __IM  uint32_t  RESERVED[16];
  __IOM uint32_t  SUBSCRIBE_TRIGGER[16];        /*!< Description collection: Subscribe configuration for task TRIGGER[n]       */
  __IM  uint32_t  RESERVED1[16];
  __IOM uint32_t  EVENTS_TRIGGERED[16];         /*!< Description collection: Event number n generated by triggering
                                                     the corresponding TRIGGER[n] task                                         */
  __IM  uint32_t  RESERVED2[16];
  __IOM uint32_t  PUBLISH_TRIGGERED[16];        /*!< Description collection: Publish configuration for event TRIGGERED[n]      */
  __IM  uint32_t  RESERVED3[80];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
} NRF_EGU_Type;                                 /*!< Size = 780 (0x30c)                                                        */



/* =========================================================================================================================== */
/* ================                                          PWM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Pulse width modulation unit 0 (PWM0_NS)
  */

typedef struct {                                /*!< PWM0_NS Structure                                                         */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops PWM pulse generation on all channels at the end of current
                                                     PWM period, and stops sequence playback                                   */
  __OM  uint32_t  TASKS_SEQSTART[2];            /*!< Description collection: Loads the first PWM value on all enabled
                                                     channels from sequence n, and starts playing that sequence
                                                     at the rate defined in SEQ[n]REFRESH and/or DECODER.MODE.
                                                     Causes PWM generation to start if not running.                            */
  __OM  uint32_t  TASKS_NEXTSTEP;               /*!< Steps by one value in the current sequence on all enabled channels
                                                     if DECODER.MODE=NextStep. Does not cause PWM generation
                                                     to start if not running.                                                  */
  __IM  uint32_t  RESERVED1[28];
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_SEQSTART[2];        /*!< Description collection: Subscribe configuration for task SEQSTART[n]      */
  __IOM uint32_t  SUBSCRIBE_NEXTSTEP;           /*!< Subscribe configuration for task NEXTSTEP                                 */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  EVENTS_STOPPED;               /*!< Response to STOP task, emitted when PWM pulses are no longer
                                                     generated                                                                 */
  __IOM uint32_t  EVENTS_SEQSTARTED[2];         /*!< Description collection: First PWM period started on sequence
                                                     n                                                                         */
  __IOM uint32_t  EVENTS_SEQEND[2];             /*!< Description collection: Emitted at end of every sequence n,
                                                     when last value from RAM has been applied to wave counter                 */
  __IOM uint32_t  EVENTS_PWMPERIODEND;          /*!< Emitted at the end of each PWM period                                     */
  __IOM uint32_t  EVENTS_LOOPSDONE;             /*!< Concatenated sequences have been played the amount of times
                                                     defined in LOOP.CNT                                                       */
  __IM  uint32_t  RESERVED3[25];
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IOM uint32_t  PUBLISH_SEQSTARTED[2];        /*!< Description collection: Publish configuration for event SEQSTARTED[n]     */
  __IOM uint32_t  PUBLISH_SEQEND[2];            /*!< Description collection: Publish configuration for event SEQEND[n]         */
  __IOM uint32_t  PUBLISH_PWMPERIODEND;         /*!< Publish configuration for event PWMPERIODEND                              */
  __IOM uint32_t  PUBLISH_LOOPSDONE;            /*!< Publish configuration for event LOOPSDONE                                 */
  __IM  uint32_t  RESERVED4[24];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED5[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[125];
  __IOM uint32_t  ENABLE;                       /*!< PWM module enable register                                                */
  __IOM uint32_t  MODE;                         /*!< Selects operating mode of the wave counter                                */
  __IOM uint32_t  COUNTERTOP;                   /*!< Value up to which the pulse generator counter counts                      */
  __IOM uint32_t  PRESCALER;                    /*!< Configuration for PWM_CLK                                                 */
  __IOM uint32_t  DECODER;                      /*!< Configuration of the decoder                                              */
  __IOM uint32_t  LOOP;                         /*!< Number of playbacks of a loop                                             */
  __IM  uint32_t  RESERVED7[2];
  __IOM PWM_SEQ_Type SEQ[2];                    /*!< Unspecified                                                               */
  __IOM PWM_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
} NRF_PWM_Type;                                 /*!< Size = 1392 (0x570)                                                       */



/* =========================================================================================================================== */
/* ================                                          PDM0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Pulse Density Modulation (Digital Microphone) Interface 0 (PDM0_NS)
  */

typedef struct {                                /*!< PDM0_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Starts continuous PDM transfer                                            */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops PDM transfer                                                        */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[30];
  __IOM uint32_t  EVENTS_STARTED;               /*!< PDM transfer has started                                                  */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< PDM transfer has finished                                                 */
  __IOM uint32_t  EVENTS_END;                   /*!< The PDM has written the last sample specified by SAMPLE.MAXCNT
                                                     (or the last sample after a STOP task has been received)
                                                     to Data RAM                                                               */
  __IM  uint32_t  RESERVED2[29];
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IOM uint32_t  PUBLISH_END;                  /*!< Publish configuration for event END                                       */
  __IM  uint32_t  RESERVED3[93];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[125];
  __IOM uint32_t  ENABLE;                       /*!< PDM module enable register                                                */
  __IOM uint32_t  PDMCLKCTRL;                   /*!< PDM clock generator control                                               */
  __IOM uint32_t  MODE;                         /*!< Defines the routing of the connected PDM microphones' signals             */
  __IM  uint32_t  RESERVED5[3];
  __IOM uint32_t  GAINL;                        /*!< Left output gain adjustment                                               */
  __IOM uint32_t  GAINR;                        /*!< Right output gain adjustment                                              */
  __IOM uint32_t  RATIO;                        /*!< Selects the ratio between PDM_CLK and output sample rate. Change
                                                     PDMCLKCTRL accordingly.                                                   */
  __IM  uint32_t  RESERVED6[7];
  __IOM PDM_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  MCLKCONFIG;                   /*!< Master clock generator configuration                                      */
  __IM  uint32_t  RESERVED8[4];
  __IOM PDM_SAMPLE_Type SAMPLE;                 /*!< Unspecified                                                               */
} NRF_PDM_Type;                                 /*!< Size = 1384 (0x568)                                                       */



/* =========================================================================================================================== */
/* ================                                          I2S0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Inter-IC Sound 0 (I2S0_NS)
  */

typedef struct {                                /*!< I2S0_NS Structure                                                         */
  __OM  uint32_t  TASKS_START;                  /*!< Starts continuous I2S transfer. Also starts MCK generator when
                                                     this is enabled                                                           */
  __OM  uint32_t  TASKS_STOP;                   /*!< Stops I2S transfer and MCK generator. Triggering this task will
                                                     cause the event STOPPED to be generated.                                  */
  __IM  uint32_t  RESERVED[30];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IM  uint32_t  RESERVED1[31];
  __IOM uint32_t  EVENTS_RXPTRUPD;              /*!< The RXD.PTR register has been copied to internal double-buffers.
                                                     When the I2S module is started and RX is enabled, this
                                                     event will be generated for every RXTXD.MAXCNT words received
                                                     on the SDIN pin.                                                          */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< I2S transfer stopped.                                                     */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  EVENTS_TXPTRUPD;              /*!< The TDX.PTR register has been copied to internal double-buffers.
                                                     When the I2S module is started and TX is enabled, this
                                                     event will be generated for every RXTXD.MAXCNT words that
                                                     are sent on the SDOUT pin.                                                */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  EVENTS_FRAMESTART;            /*!< Frame start event, generated on the active edge of LRCK                   */
  __IM  uint32_t  RESERVED4[25];
  __IOM uint32_t  PUBLISH_RXPTRUPD;             /*!< Publish configuration for event RXPTRUPD                                  */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  PUBLISH_TXPTRUPD;             /*!< Publish configuration for event TXPTRUPD                                  */
  __IM  uint32_t  RESERVED6;
  __IOM uint32_t  PUBLISH_FRAMESTART;           /*!< Publish configuration for event FRAMESTART                                */
  __IM  uint32_t  RESERVED7[88];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED8[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable I2S module                                                         */
  __IOM I2S_CONFIG_Type CONFIG;                 /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED9[2];
  __IOM I2S_RXD_Type RXD;                       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED10;
  __IOM I2S_TXD_Type TXD;                       /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED11[3];
  __IOM I2S_RXTXD_Type RXTXD;                   /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED12[3];
  __IOM I2S_PSEL_Type PSEL;                     /*!< Unspecified                                                               */
} NRF_I2S_Type;                                 /*!< Size = 1396 (0x574)                                                       */



/* =========================================================================================================================== */
/* ================                                          IPC_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Interprocessor communication 0 (IPC_NS)
  */

typedef struct {                                /*!< IPC_NS Structure                                                          */
  __OM  uint32_t  TASKS_SEND[16];               /*!< Description collection: Trigger events on IPC channel enabled
                                                     in SEND_CNF[n]                                                            */
  __IM  uint32_t  RESERVED[16];
  __IOM uint32_t  SUBSCRIBE_SEND[16];           /*!< Description collection: Subscribe configuration for task SEND[n]          */
  __IM  uint32_t  RESERVED1[16];
  __IOM uint32_t  EVENTS_RECEIVE[16];           /*!< Description collection: Event received on one or more of the
                                                     enabled IPC channels in RECEIVE_CNF[n]                                    */
  __IM  uint32_t  RESERVED2[16];
  __IOM uint32_t  PUBLISH_RECEIVE[16];          /*!< Description collection: Publish configuration for event RECEIVE[n]        */
  __IM  uint32_t  RESERVED3[80];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED4[128];
  __IOM uint32_t  SEND_CNF[16];                 /*!< Description collection: Send event configuration for TASKS_SEND[n]        */
  __IM  uint32_t  RESERVED5[16];
  __IOM uint32_t  RECEIVE_CNF[16];              /*!< Description collection: Receive event configuration for EVENTS_RECEIVE[n] */
  __IM  uint32_t  RESERVED6[16];
  __IOM uint32_t  GPMEM[2];                     /*!< Description collection: General purpose memory                            */
} NRF_IPC_Type;                                 /*!< Size = 1560 (0x618)                                                       */



/* =========================================================================================================================== */
/* ================                                          QSPI_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief External flash interface 0 (QSPI_NS)
  */

typedef struct {                                /*!< QSPI_NS Structure                                                         */
  __OM  uint32_t  TASKS_ACTIVATE;               /*!< Activate QSPI interface                                                   */
  __OM  uint32_t  TASKS_READSTART;              /*!< Start transfer from external flash memory to internal RAM                 */
  __OM  uint32_t  TASKS_WRITESTART;             /*!< Start transfer from internal RAM to external flash memory                 */
  __OM  uint32_t  TASKS_ERASESTART;             /*!< Start external flash memory erase operation                               */
  __OM  uint32_t  TASKS_DEACTIVATE;             /*!< Deactivate QSPI interface                                                 */
  __IM  uint32_t  RESERVED[27];
  __IOM uint32_t  SUBSCRIBE_ACTIVATE;           /*!< Subscribe configuration for task ACTIVATE                                 */
  __IOM uint32_t  SUBSCRIBE_READSTART;          /*!< Subscribe configuration for task READSTART                                */
  __IOM uint32_t  SUBSCRIBE_WRITESTART;         /*!< Subscribe configuration for task WRITESTART                               */
  __IOM uint32_t  SUBSCRIBE_ERASESTART;         /*!< Subscribe configuration for task ERASESTART                               */
  __IOM uint32_t  SUBSCRIBE_DEACTIVATE;         /*!< Subscribe configuration for task DEACTIVATE                               */
  __IM  uint32_t  RESERVED1[27];
  __IOM uint32_t  EVENTS_READY;                 /*!< QSPI peripheral is ready. This event will be generated as a
                                                     response to all QSPI tasks except DEACTIVATE.                             */
  __IM  uint32_t  RESERVED2[31];
  __IOM uint32_t  PUBLISH_READY;                /*!< Publish configuration for event READY                                     */
  __IM  uint32_t  RESERVED3[95];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED4[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable QSPI peripheral and acquire the pins selected in PSELn
                                                     registers                                                                 */
  __IOM QSPI_READ_Type READ;                    /*!< Unspecified                                                               */
  __IOM QSPI_WRITE_Type WRITE;                  /*!< Unspecified                                                               */
  __IOM QSPI_ERASE_Type ERASE;                  /*!< Unspecified                                                               */
  __IOM QSPI_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IOM uint32_t  XIPOFFSET;                    /*!< Address offset into the external memory for Execute in Place
                                                     operation.                                                                */
  __IOM uint32_t  IFCONFIG0;                    /*!< Interface configuration.                                                  */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  XIPEN;                        /*!< Enable Execute in Place operation.                                        */
  __IM  uint32_t  RESERVED6[4];
  __IOM QSPI_XIP_ENC_Type XIP_ENC;              /*!< Unspecified                                                               */
  __IOM QSPI_DMA_ENC_Type DMA_ENC;              /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED7[24];
  __IOM uint32_t  IFCONFIG1;                    /*!< Interface configuration.                                                  */
  __IM  uint32_t  STATUS;                       /*!< Status register.                                                          */
  __IM  uint32_t  RESERVED8[3];
  __IOM uint32_t  DPMDUR;                       /*!< Set the duration required to enter/exit deep power-down mode
                                                     (DPM).                                                                    */
  __IM  uint32_t  RESERVED9[3];
  __IOM uint32_t  ADDRCONF;                     /*!< Extended address configuration.                                           */
  __IM  uint32_t  RESERVED10[3];
  __IOM uint32_t  CINSTRCONF;                   /*!< Custom instruction configuration register.                                */
  __IOM uint32_t  CINSTRDAT0;                   /*!< Custom instruction data register 0.                                       */
  __IOM uint32_t  CINSTRDAT1;                   /*!< Custom instruction data register 1.                                       */
  __IOM uint32_t  IFTIMING;                     /*!< SPI interface timing.                                                     */
} NRF_QSPI_Type;                                /*!< Size = 1604 (0x644)                                                       */



/* =========================================================================================================================== */
/* ================                                          NFCT_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief NFC-A compatible radio 0 (NFCT_NS)
  */

typedef struct {                                /*!< NFCT_NS Structure                                                         */
  __OM  uint32_t  TASKS_ACTIVATE;               /*!< Activate NFCT peripheral for incoming and outgoing frames, change
                                                     state to activated                                                        */
  __OM  uint32_t  TASKS_DISABLE;                /*!< Disable NFCT peripheral                                                   */
  __OM  uint32_t  TASKS_SENSE;                  /*!< Enable NFC sense field mode, change state to sense mode                   */
  __OM  uint32_t  TASKS_STARTTX;                /*!< Start transmission of an outgoing frame, change state to transmit         */
  __IM  uint32_t  RESERVED[3];
  __OM  uint32_t  TASKS_ENABLERXDATA;           /*!< Initializes the EasyDMA for receive.                                      */
  __IM  uint32_t  RESERVED1;
  __OM  uint32_t  TASKS_GOIDLE;                 /*!< Force state machine to IDLE state                                         */
  __OM  uint32_t  TASKS_GOSLEEP;                /*!< Force state machine to SLEEP_A state                                      */
  __IM  uint32_t  RESERVED2[21];
  __IOM uint32_t  SUBSCRIBE_ACTIVATE;           /*!< Subscribe configuration for task ACTIVATE                                 */
  __IOM uint32_t  SUBSCRIBE_DISABLE;            /*!< Subscribe configuration for task DISABLE                                  */
  __IOM uint32_t  SUBSCRIBE_SENSE;              /*!< Subscribe configuration for task SENSE                                    */
  __IOM uint32_t  SUBSCRIBE_STARTTX;            /*!< Subscribe configuration for task STARTTX                                  */
  __IM  uint32_t  RESERVED3[3];
  __IOM uint32_t  SUBSCRIBE_ENABLERXDATA;       /*!< Subscribe configuration for task ENABLERXDATA                             */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  SUBSCRIBE_GOIDLE;             /*!< Subscribe configuration for task GOIDLE                                   */
  __IOM uint32_t  SUBSCRIBE_GOSLEEP;            /*!< Subscribe configuration for task GOSLEEP                                  */
  __IM  uint32_t  RESERVED5[21];
  __IOM uint32_t  EVENTS_READY;                 /*!< The NFCT peripheral is ready to receive and send frames                   */
  __IOM uint32_t  EVENTS_FIELDDETECTED;         /*!< Remote NFC field detected                                                 */
  __IOM uint32_t  EVENTS_FIELDLOST;             /*!< Remote NFC field lost                                                     */
  __IOM uint32_t  EVENTS_TXFRAMESTART;          /*!< Marks the start of the first symbol of a transmitted frame                */
  __IOM uint32_t  EVENTS_TXFRAMEEND;            /*!< Marks the end of the last transmitted on-air symbol of a frame            */
  __IOM uint32_t  EVENTS_RXFRAMESTART;          /*!< Marks the end of the first symbol of a received frame                     */
  __IOM uint32_t  EVENTS_RXFRAMEEND;            /*!< Received data has been checked (CRC, parity) and transferred
                                                     to RAM, and EasyDMA has ended accessing the RX buffer                     */
  __IOM uint32_t  EVENTS_ERROR;                 /*!< NFC error reported. The ERRORSTATUS register contains details
                                                     on the source of the error.                                               */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  EVENTS_RXERROR;               /*!< NFC RX frame error reported. The FRAMESTATUS.RX register contains
                                                     details on the source of the error.                                       */
  __IOM uint32_t  EVENTS_ENDRX;                 /*!< RX buffer (as defined by PACKETPTR and MAXLEN) in Data RAM full.          */
  __IOM uint32_t  EVENTS_ENDTX;                 /*!< Transmission of data in RAM has ended, and EasyDMA has ended
                                                     accessing the TX buffer                                                   */
  __IM  uint32_t  RESERVED7;
  __IOM uint32_t  EVENTS_AUTOCOLRESSTARTED;     /*!< Auto collision resolution process has started                             */
  __IM  uint32_t  RESERVED8[3];
  __IOM uint32_t  EVENTS_COLLISION;             /*!< NFC auto collision resolution error reported.                             */
  __IOM uint32_t  EVENTS_SELECTED;              /*!< NFC auto collision resolution successfully completed                      */
  __IOM uint32_t  EVENTS_STARTED;               /*!< EasyDMA is ready to receive or send frames.                               */
  __IM  uint32_t  RESERVED9[11];
  __IOM uint32_t  PUBLISH_READY;                /*!< Publish configuration for event READY                                     */
  __IOM uint32_t  PUBLISH_FIELDDETECTED;        /*!< Publish configuration for event FIELDDETECTED                             */
  __IOM uint32_t  PUBLISH_FIELDLOST;            /*!< Publish configuration for event FIELDLOST                                 */
  __IOM uint32_t  PUBLISH_TXFRAMESTART;         /*!< Publish configuration for event TXFRAMESTART                              */
  __IOM uint32_t  PUBLISH_TXFRAMEEND;           /*!< Publish configuration for event TXFRAMEEND                                */
  __IOM uint32_t  PUBLISH_RXFRAMESTART;         /*!< Publish configuration for event RXFRAMESTART                              */
  __IOM uint32_t  PUBLISH_RXFRAMEEND;           /*!< Publish configuration for event RXFRAMEEND                                */
  __IOM uint32_t  PUBLISH_ERROR;                /*!< Publish configuration for event ERROR                                     */
  __IM  uint32_t  RESERVED10[2];
  __IOM uint32_t  PUBLISH_RXERROR;              /*!< Publish configuration for event RXERROR                                   */
  __IOM uint32_t  PUBLISH_ENDRX;                /*!< Publish configuration for event ENDRX                                     */
  __IOM uint32_t  PUBLISH_ENDTX;                /*!< Publish configuration for event ENDTX                                     */
  __IM  uint32_t  RESERVED11;
  __IOM uint32_t  PUBLISH_AUTOCOLRESSTARTED;    /*!< Publish configuration for event AUTOCOLRESSTARTED                         */
  __IM  uint32_t  RESERVED12[3];
  __IOM uint32_t  PUBLISH_COLLISION;            /*!< Publish configuration for event COLLISION                                 */
  __IOM uint32_t  PUBLISH_SELECTED;             /*!< Publish configuration for event SELECTED                                  */
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IM  uint32_t  RESERVED13[11];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED14[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED15[62];
  __IOM uint32_t  ERRORSTATUS;                  /*!< NFC Error Status register                                                 */
  __IM  uint32_t  RESERVED16;
  __IOM NFCT_FRAMESTATUS_Type FRAMESTATUS;      /*!< Unspecified                                                               */
  __IM  uint32_t  NFCTAGSTATE;                  /*!< Current operating state of NFC tag                                        */
  __IM  uint32_t  RESERVED17[3];
  __IM  uint32_t  SLEEPSTATE;                   /*!< Sleep state during automatic collision resolution                         */
  __IM  uint32_t  RESERVED18[6];
  __IM  uint32_t  FIELDPRESENT;                 /*!< Indicates the presence or not of a valid field                            */
  __IM  uint32_t  RESERVED19[49];
  __IOM uint32_t  FRAMEDELAYMIN;                /*!< Minimum frame delay                                                       */
  __IOM uint32_t  FRAMEDELAYMAX;                /*!< Maximum frame delay                                                       */
  __IOM uint32_t  FRAMEDELAYMODE;               /*!< Configuration register for the Frame Delay Timer                          */
  __IOM uint32_t  PACKETPTR;                    /*!< Packet pointer for TXD and RXD data storage in Data RAM                   */
  __IOM uint32_t  MAXLEN;                       /*!< Size of the RAM buffer allocated to TXD and RXD data storage
                                                     each                                                                      */
  __IOM NFCT_TXD_Type TXD;                      /*!< Unspecified                                                               */
  __IOM NFCT_RXD_Type RXD;                      /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED20;
  __IOM uint32_t  MODULATIONCTRL;               /*!< Enables the modulation output to a GPIO pin which can be connected
                                                     to a second external antenna.                                             */
  __IM  uint32_t  RESERVED21[2];
  __IOM uint32_t  MODULATIONPSEL;               /*!< Pin select for Modulation control                                         */
  __IM  uint32_t  RESERVED22[21];
  __IOM uint32_t  NFCID1_LAST;                  /*!< Last NFCID1 part (4, 7 or 10 bytes ID)                                    */
  __IOM uint32_t  NFCID1_2ND_LAST;              /*!< Second last NFCID1 part (7 or 10 bytes ID)                                */
  __IOM uint32_t  NFCID1_3RD_LAST;              /*!< Third last NFCID1 part (10 bytes ID)                                      */
  __IOM uint32_t  AUTOCOLRESCONFIG;             /*!< Controls the auto collision resolution function. This setting
                                                     must be done before the NFCT peripheral is activated.                     */
  __IOM uint32_t  SENSRES;                      /*!< NFC-A SENS_RES auto-response settings                                     */
  __IOM uint32_t  SELRES;                       /*!< NFC-A SEL_RES auto-response settings                                      */
} NRF_NFCT_Type;                                /*!< Size = 1448 (0x5a8)                                                       */



/* =========================================================================================================================== */
/* ================                                         MUTEX_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief MUTEX 0 (MUTEX_NS)
  */

typedef struct {                                /*!< MUTEX_NS Structure                                                        */
  __IM  uint32_t  RESERVED[256];
  __IOM uint32_t  MUTEX[16];                    /*!< Description collection: Mutex register                                    */
} NRF_MUTEX_Type;                               /*!< Size = 1088 (0x440)                                                       */



/* =========================================================================================================================== */
/* ================                                         QDEC0_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Quadrature Decoder 0 (QDEC0_NS)
  */

typedef struct {                                /*!< QDEC0_NS Structure                                                        */
  __OM  uint32_t  TASKS_START;                  /*!< Task starting the quadrature decoder                                      */
  __OM  uint32_t  TASKS_STOP;                   /*!< Task stopping the quadrature decoder                                      */
  __OM  uint32_t  TASKS_READCLRACC;             /*!< Read and clear ACC and ACCDBL                                             */
  __OM  uint32_t  TASKS_RDCLRACC;               /*!< Read and clear ACC                                                        */
  __OM  uint32_t  TASKS_RDCLRDBL;               /*!< Read and clear ACCDBL                                                     */
  __IM  uint32_t  RESERVED[27];
  __IOM uint32_t  SUBSCRIBE_START;              /*!< Subscribe configuration for task START                                    */
  __IOM uint32_t  SUBSCRIBE_STOP;               /*!< Subscribe configuration for task STOP                                     */
  __IOM uint32_t  SUBSCRIBE_READCLRACC;         /*!< Subscribe configuration for task READCLRACC                               */
  __IOM uint32_t  SUBSCRIBE_RDCLRACC;           /*!< Subscribe configuration for task RDCLRACC                                 */
  __IOM uint32_t  SUBSCRIBE_RDCLRDBL;           /*!< Subscribe configuration for task RDCLRDBL                                 */
  __IM  uint32_t  RESERVED1[27];
  __IOM uint32_t  EVENTS_SAMPLERDY;             /*!< Event being generated for every new sample value written to
                                                     the SAMPLE register                                                       */
  __IOM uint32_t  EVENTS_REPORTRDY;             /*!< Non-null report ready                                                     */
  __IOM uint32_t  EVENTS_ACCOF;                 /*!< ACC or ACCDBL register overflow                                           */
  __IOM uint32_t  EVENTS_DBLRDY;                /*!< Double displacement(s) detected                                           */
  __IOM uint32_t  EVENTS_STOPPED;               /*!< QDEC has been stopped                                                     */
  __IM  uint32_t  RESERVED2[27];
  __IOM uint32_t  PUBLISH_SAMPLERDY;            /*!< Publish configuration for event SAMPLERDY                                 */
  __IOM uint32_t  PUBLISH_REPORTRDY;            /*!< Publish configuration for event REPORTRDY                                 */
  __IOM uint32_t  PUBLISH_ACCOF;                /*!< Publish configuration for event ACCOF                                     */
  __IOM uint32_t  PUBLISH_DBLRDY;               /*!< Publish configuration for event DBLRDY                                    */
  __IOM uint32_t  PUBLISH_STOPPED;              /*!< Publish configuration for event STOPPED                                   */
  __IM  uint32_t  RESERVED3[27];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED4[64];
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED5[125];
  __IOM uint32_t  ENABLE;                       /*!< Enable the quadrature decoder                                             */
  __IOM uint32_t  LEDPOL;                       /*!< LED output pin polarity                                                   */
  __IOM uint32_t  SAMPLEPER;                    /*!< Sample period                                                             */
  __IM  int32_t   SAMPLE;                       /*!< Motion sample value                                                       */
  __IOM uint32_t  REPORTPER;                    /*!< Number of samples to be taken before REPORTRDY and DBLRDY events
                                                     can be generated                                                          */
  __IM  int32_t   ACC;                          /*!< Register accumulating the valid transitions                               */
  __IM  int32_t   ACCREAD;                      /*!< Snapshot of the ACC register, updated by the READCLRACC or RDCLRACC
                                                     task                                                                      */
  __IOM QDEC_PSEL_Type PSEL;                    /*!< Unspecified                                                               */
  __IOM uint32_t  DBFEN;                        /*!< Enable input debounce filters                                             */
  __IM  uint32_t  RESERVED6[5];
  __IOM uint32_t  LEDPRE;                       /*!< Time period the LED is switched ON prior to sampling                      */
  __IM  uint32_t  ACCDBL;                       /*!< Register accumulating the number of detected double transitions           */
  __IM  uint32_t  ACCDBLREAD;                   /*!< Snapshot of the ACCDBL, updated by the READCLRACC or RDCLRDBL
                                                     task                                                                      */
} NRF_QDEC_Type;                                /*!< Size = 1356 (0x54c)                                                       */



/* =========================================================================================================================== */
/* ================                                          USBD_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Universal serial bus device 0 (USBD_NS)
  */

typedef struct {                                /*!< USBD_NS Structure                                                         */
  __IM  uint32_t  RESERVED;
  __OM  uint32_t  TASKS_STARTEPIN[8];           /*!< Description collection: Captures the EPIN[n].PTR and EPIN[n].MAXCNT
                                                     registers values, and enables endpoint IN n to respond
                                                     to traffic from host                                                      */
  __OM  uint32_t  TASKS_STARTISOIN;             /*!< Captures the ISOIN.PTR and ISOIN.MAXCNT registers values, and
                                                     enables sending data on ISO endpoint                                      */
  __OM  uint32_t  TASKS_STARTEPOUT[8];          /*!< Description collection: Captures the EPOUT[n].PTR and EPOUT[n].MAXCNT
                                                     registers values, and enables endpoint n to respond to
                                                     traffic from host                                                         */
  __OM  uint32_t  TASKS_STARTISOOUT;            /*!< Captures the ISOOUT.PTR and ISOOUT.MAXCNT registers values,
                                                     and enables receiving of data on ISO endpoint                             */
  __OM  uint32_t  TASKS_EP0RCVOUT;              /*!< Allows OUT data stage on control endpoint 0                               */
  __OM  uint32_t  TASKS_EP0STATUS;              /*!< Allows status stage on control endpoint 0                                 */
  __OM  uint32_t  TASKS_EP0STALL;               /*!< Stalls data and status stage on control endpoint 0                        */
  __OM  uint32_t  TASKS_DPDMDRIVE;              /*!< Forces D+ and D- lines into the state defined in the DPDMVALUE
                                                     register                                                                  */
  __OM  uint32_t  TASKS_DPDMNODRIVE;            /*!< Stops forcing D+ and D- lines into any state (USB engine takes
                                                     control)                                                                  */
  __IM  uint32_t  RESERVED1[9];
  __IOM uint32_t  SUBSCRIBE_STARTEPIN[8];       /*!< Description collection: Subscribe configuration for task STARTEPIN[n]     */
  __IOM uint32_t  SUBSCRIBE_STARTISOIN;         /*!< Subscribe configuration for task STARTISOIN                               */
  __IOM uint32_t  SUBSCRIBE_STARTEPOUT[8];      /*!< Description collection: Subscribe configuration for task STARTEPOUT[n]    */
  __IOM uint32_t  SUBSCRIBE_STARTISOOUT;        /*!< Subscribe configuration for task STARTISOOUT                              */
  __IOM uint32_t  SUBSCRIBE_EP0RCVOUT;          /*!< Subscribe configuration for task EP0RCVOUT                                */
  __IOM uint32_t  SUBSCRIBE_EP0STATUS;          /*!< Subscribe configuration for task EP0STATUS                                */
  __IOM uint32_t  SUBSCRIBE_EP0STALL;           /*!< Subscribe configuration for task EP0STALL                                 */
  __IOM uint32_t  SUBSCRIBE_DPDMDRIVE;          /*!< Subscribe configuration for task DPDMDRIVE                                */
  __IOM uint32_t  SUBSCRIBE_DPDMNODRIVE;        /*!< Subscribe configuration for task DPDMNODRIVE                              */
  __IM  uint32_t  RESERVED2[8];
  __IOM uint32_t  EVENTS_USBRESET;              /*!< Signals that a USB reset condition has been detected on USB
                                                     lines                                                                     */
  __IOM uint32_t  EVENTS_STARTED;               /*!< Confirms that the EPIN[n].PTR and EPIN[n].MAXCNT, or EPOUT[n].PTR
                                                     and EPOUT[n].MAXCNT registers have been captured on all
                                                     endpoints reported in the EPSTATUS register                               */
  __IOM uint32_t  EVENTS_ENDEPIN[8];            /*!< Description collection: The whole EPIN[n] buffer has been consumed.
                                                     The buffer can be accessed safely by software.                            */
  __IOM uint32_t  EVENTS_EP0DATADONE;           /*!< An acknowledged data transfer has taken place on the control
                                                     endpoint                                                                  */
  __IOM uint32_t  EVENTS_ENDISOIN;              /*!< The whole ISOIN buffer has been consumed. The buffer can be
                                                     accessed safely by software.                                              */
  __IOM uint32_t  EVENTS_ENDEPOUT[8];           /*!< Description collection: The whole EPOUT[n] buffer has been consumed.
                                                     The buffer can be accessed safely by software.                            */
  __IOM uint32_t  EVENTS_ENDISOOUT;             /*!< The whole ISOOUT buffer has been consumed. The buffer can be
                                                     accessed safely by software.                                              */
  __IOM uint32_t  EVENTS_SOF;                   /*!< Signals that a SOF (start of frame) condition has been detected
                                                     on USB lines                                                              */
  __IOM uint32_t  EVENTS_USBEVENT;              /*!< An event or an error not covered by specific events has occurred.
                                                     Check EVENTCAUSE register to find the cause.                              */
  __IOM uint32_t  EVENTS_EP0SETUP;              /*!< A valid SETUP token has been received (and acknowledged) on
                                                     the control endpoint                                                      */
  __IOM uint32_t  EVENTS_EPDATA;                /*!< A data transfer has occurred on a data endpoint, indicated by
                                                     the EPDATASTATUS register                                                 */
  __IM  uint32_t  RESERVED3[7];
  __IOM uint32_t  PUBLISH_USBRESET;             /*!< Publish configuration for event USBRESET                                  */
  __IOM uint32_t  PUBLISH_STARTED;              /*!< Publish configuration for event STARTED                                   */
  __IOM uint32_t  PUBLISH_ENDEPIN[8];           /*!< Description collection: Publish configuration for event ENDEPIN[n]        */
  __IOM uint32_t  PUBLISH_EP0DATADONE;          /*!< Publish configuration for event EP0DATADONE                               */
  __IOM uint32_t  PUBLISH_ENDISOIN;             /*!< Publish configuration for event ENDISOIN                                  */
  __IOM uint32_t  PUBLISH_ENDEPOUT[8];          /*!< Description collection: Publish configuration for event ENDEPOUT[n]       */
  __IOM uint32_t  PUBLISH_ENDISOOUT;            /*!< Publish configuration for event ENDISOOUT                                 */
  __IOM uint32_t  PUBLISH_SOF;                  /*!< Publish configuration for event SOF                                       */
  __IOM uint32_t  PUBLISH_USBEVENT;             /*!< Publish configuration for event USBEVENT                                  */
  __IOM uint32_t  PUBLISH_EP0SETUP;             /*!< Publish configuration for event EP0SETUP                                  */
  __IOM uint32_t  PUBLISH_EPDATA;               /*!< Publish configuration for event EPDATA                                    */
  __IM  uint32_t  RESERVED4[7];
  __IOM uint32_t  SHORTS;                       /*!< Shortcuts between local events and tasks                                  */
  __IM  uint32_t  RESERVED5[63];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED6[61];
  __IOM uint32_t  EVENTCAUSE;                   /*!< Details on what caused the USBEVENT event                                 */
  __IM  uint32_t  RESERVED7[7];
  __IOM USBD_HALTED_Type HALTED;                /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED8;
  __IOM uint32_t  EPSTATUS;                     /*!< Provides information on which endpoint's EasyDMA registers have
                                                     been captured                                                             */
  __IOM uint32_t  EPDATASTATUS;                 /*!< Provides information on which endpoint(s) an acknowledged data
                                                     transfer has occurred (EPDATA event)                                      */
  __IM  uint32_t  USBADDR;                      /*!< Device USB address                                                        */
  __IM  uint32_t  RESERVED9[3];
  __IM  uint32_t  BMREQUESTTYPE;                /*!< SETUP data, byte 0, bmRequestType                                         */
  __IM  uint32_t  BREQUEST;                     /*!< SETUP data, byte 1, bRequest                                              */
  __IM  uint32_t  WVALUEL;                      /*!< SETUP data, byte 2, LSB of wValue                                         */
  __IM  uint32_t  WVALUEH;                      /*!< SETUP data, byte 3, MSB of wValue                                         */
  __IM  uint32_t  WINDEXL;                      /*!< SETUP data, byte 4, LSB of wIndex                                         */
  __IM  uint32_t  WINDEXH;                      /*!< SETUP data, byte 5, MSB of wIndex                                         */
  __IM  uint32_t  WLENGTHL;                     /*!< SETUP data, byte 6, LSB of wLength                                        */
  __IM  uint32_t  WLENGTHH;                     /*!< SETUP data, byte 7, MSB of wLength                                        */
  __IOM USBD_SIZE_Type SIZE;                    /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED10[15];
  __IOM uint32_t  ENABLE;                       /*!< Enable USB                                                                */
  __IOM uint32_t  USBPULLUP;                    /*!< Control of the USB pull-up                                                */
  __IOM uint32_t  DPDMVALUE;                    /*!< State D+ and D- lines will be forced into by the DPDMDRIVE task.
                                                     The DPDMNODRIVE task reverts the control of the lines to
                                                     MAC IP (no forcing).                                                      */
  __IOM uint32_t  DTOGGLE;                      /*!< Data toggle control and status                                            */
  __IOM uint32_t  EPINEN;                       /*!< Endpoint IN enable                                                        */
  __IOM uint32_t  EPOUTEN;                      /*!< Endpoint OUT enable                                                       */
  __OM  uint32_t  EPSTALL;                      /*!< STALL endpoints                                                           */
  __IOM uint32_t  ISOSPLIT;                     /*!< Controls the split of ISO buffers                                         */
  __IM  uint32_t  FRAMECNTR;                    /*!< Returns the current value of the start of frame counter                   */
  __IM  uint32_t  RESERVED11[2];
  __IOM uint32_t  LOWPOWER;                     /*!< Controls USBD peripheral low power mode during USB suspend                */
  __IOM uint32_t  ISOINCONFIG;                  /*!< Controls the response of the ISO IN endpoint to an IN token
                                                     when no data is ready to be sent                                          */
  __IM  uint32_t  RESERVED12[51];
  __IOM USBD_EPIN_Type EPIN[8];                 /*!< Unspecified                                                               */
  __IOM USBD_ISOIN_Type ISOIN;                  /*!< Unspecified                                                               */
  __IM  uint32_t  RESERVED13[21];
  __IOM USBD_EPOUT_Type EPOUT[8];               /*!< Unspecified                                                               */
  __IOM USBD_ISOOUT_Type ISOOUT;                /*!< Unspecified                                                               */
} NRF_USBD_Type;                                /*!< Size = 1964 (0x7ac)                                                       */



/* =========================================================================================================================== */
/* ================                                      USBREGULATOR_NS                                      ================ */
/* =========================================================================================================================== */


/**
  * @brief USB Regulator 0 (USBREGULATOR_NS)
  */

typedef struct {                                /*!< USBREGULATOR_NS Structure                                                 */
  __IM  uint32_t  RESERVED[64];
  __IOM uint32_t  EVENTS_USBDETECTED;           /*!< Voltage supply detected on VBUS                                           */
  __IOM uint32_t  EVENTS_USBREMOVED;            /*!< Voltage supply removed from VBUS                                          */
  __IOM uint32_t  EVENTS_USBPWRRDY;             /*!< USB 3.3 V supply ready                                                    */
  __IM  uint32_t  RESERVED1[29];
  __IOM uint32_t  PUBLISH_USBDETECTED;          /*!< Publish configuration for event USBDETECTED                               */
  __IOM uint32_t  PUBLISH_USBREMOVED;           /*!< Publish configuration for event USBREMOVED                                */
  __IOM uint32_t  PUBLISH_USBPWRRDY;            /*!< Publish configuration for event USBPWRRDY                                 */
  __IM  uint32_t  RESERVED2[93];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  RESERVED3[61];
  __IM  uint32_t  USBREGSTATUS;                 /*!< USB supply status                                                         */
} NRF_USBREG_Type;                              /*!< Size = 1028 (0x404)                                                       */



/* =========================================================================================================================== */
/* ================                                          KMU_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Key management unit 0 (KMU_NS)
  */

typedef struct {                                /*!< KMU_NS Structure                                                          */
  __OM  uint32_t  TASKS_PUSH_KEYSLOT;           /*!< Push a key slot over secure APB                                           */
  __IM  uint32_t  RESERVED[63];
  __IOM uint32_t  EVENTS_KEYSLOT_PUSHED;        /*!< Key slot successfully pushed over secure APB                              */
  __IOM uint32_t  EVENTS_KEYSLOT_REVOKED;       /*!< Key slot has been revoked and cannot be tasked for selection              */
  __IOM uint32_t  EVENTS_KEYSLOT_ERROR;         /*!< No key slot selected, no destination address defined, or error
                                                     during push operation                                                     */
  __IM  uint32_t  RESERVED1[125];
  __IOM uint32_t  INTEN;                        /*!< Enable or disable interrupt                                               */
  __IOM uint32_t  INTENSET;                     /*!< Enable interrupt                                                          */
  __IOM uint32_t  INTENCLR;                     /*!< Disable interrupt                                                         */
  __IM  uint32_t  INTPEND;                      /*!< Pending interrupts                                                        */
  __IM  uint32_t  RESERVED2[63];
  __IM  uint32_t  STATUS;                       /*!< Status bits for KMU operation                                             */
  __IM  uint32_t  RESERVED3[60];
  __IOM uint32_t  SELECTKEYSLOT;                /*!< Select key slot to be read over AHB or pushed over secure APB
                                                     when TASKS_PUSH_KEYSLOT is started                                        */
} NRF_KMU_Type;                                 /*!< Size = 1284 (0x504)                                                       */



/* =========================================================================================================================== */
/* ================                                          NVMC_NS                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Non-volatile memory controller 0 (NVMC_NS)
  */

typedef struct {                                /*!< NVMC_NS Structure                                                         */
  __IM  uint32_t  RESERVED[256];
  __IM  uint32_t  READY;                        /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED1;
  __IM  uint32_t  READYNEXT;                    /*!< Ready flag                                                                */
  __IM  uint32_t  RESERVED2[62];
  __IOM uint32_t  CONFIG;                       /*!< Configuration register                                                    */
  __IM  uint32_t  RESERVED3;
  __OM  uint32_t  ERASEALL;                     /*!< Register for erasing all non-volatile user memory                         */
  __IM  uint32_t  RESERVED4[3];
  __IOM uint32_t  ERASEPAGEPARTIALCFG;          /*!< Register for partial erase configuration                                  */
  __IM  uint32_t  RESERVED5[25];
  __IOM uint32_t  CONFIGNS;                     /*!< Non-secure configuration register                                         */
  __OM  uint32_t  WRITEUICRNS;                  /*!< Non-secure APPROTECT enable register                                      */
} NRF_NVMC_Type;                                /*!< Size = 1420 (0x58c)                                                       */



/* =========================================================================================================================== */
/* ================                                           P0_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief GPIO Port 0 (P0_NS)
  */

typedef struct {                                /*!< P0_NS Structure                                                           */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  OUT;                          /*!< Write GPIO port                                                           */
  __IOM uint32_t  OUTSET;                       /*!< Set individual bits in GPIO port                                          */
  __IOM uint32_t  OUTCLR;                       /*!< Clear individual bits in GPIO port                                        */
  __IM  uint32_t  IN;                           /*!< Read GPIO port                                                            */
  __IOM uint32_t  DIR;                          /*!< Direction of GPIO pins                                                    */
  __IOM uint32_t  DIRSET;                       /*!< DIR set register                                                          */
  __IOM uint32_t  DIRCLR;                       /*!< DIR clear register                                                        */
  __IOM uint32_t  LATCH;                        /*!< Latch register indicating what GPIO pins that have met the criteria
                                                     set in the PIN_CNF[n].SENSE registers                                     */
  __IOM uint32_t  DETECTMODE;                   /*!< Select between default DETECT signal behavior and LDETECT mode
                                                     (For non-secure pin only)                                                 */
  __IOM uint32_t  DETECTMODE_SEC;               /*!< Select between default DETECT signal behavior and LDETECT mode
                                                     (For secure pin only)                                                     */
  __IM  uint32_t  RESERVED1[117];
  __IOM uint32_t  PIN_CNF[32];                  /*!< Description collection: Configuration of GPIO pins                        */
} NRF_GPIO_Type;                                /*!< Size = 640 (0x280)                                                        */



/* =========================================================================================================================== */
/* ================                                       CRYPTOCELL_S                                        ================ */
/* =========================================================================================================================== */


/**
  * @brief ARM TrustZone CryptoCell register interface (CRYPTOCELL_S)
  */

typedef struct {                                /*!< CRYPTOCELL_S Structure                                                    */
  __IM  uint32_t  RESERVED[320];
  __IOM uint32_t  ENABLE;                       /*!< Enable CRYPTOCELL subsystem.                                              */
} NRF_CRYPTOCELL_Type;                          /*!< Size = 1284 (0x504)                                                       */



/* =========================================================================================================================== */
/* ================                                          VMC_NS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Volatile Memory controller 0 (VMC_NS)
  */

typedef struct {                                /*!< VMC_NS Structure                                                          */
  __IM  uint32_t  RESERVED[384];
  __IOM VMC_RAM_Type RAM[8];                    /*!< Unspecified                                                               */
} NRF_VMC_Type;                                 /*!< Size = 1664 (0x680)                                                       */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define NRF_CACHEDATA_S_BASE        0x00F00000UL
#define NRF_CACHEINFO_S_BASE        0x00F08000UL
#define NRF_FICR_S_BASE             0x00FF0000UL
#define NRF_UICR_S_BASE             0x00FF8000UL
#define NRF_CTI_S_BASE              0xE0042000UL
#define NRF_TAD_S_BASE              0xE0080000UL
#define NRF_DCNF_NS_BASE            0x40000000UL
#define NRF_FPU_NS_BASE             0x40000000UL
#define NRF_DCNF_S_BASE             0x50000000UL
#define NRF_FPU_S_BASE              0x50000000UL
#define NRF_CACHE_S_BASE            0x50001000UL
#define NRF_SPU_S_BASE              0x50003000UL
#define NRF_OSCILLATORS_NS_BASE     0x40004000UL
#define NRF_REGULATORS_NS_BASE      0x40004000UL
#define NRF_OSCILLATORS_S_BASE      0x50004000UL
#define NRF_REGULATORS_S_BASE       0x50004000UL
#define NRF_CLOCK_NS_BASE           0x40005000UL
#define NRF_POWER_NS_BASE           0x40005000UL
#define NRF_RESET_NS_BASE           0x40005000UL
#define NRF_CLOCK_S_BASE            0x50005000UL
#define NRF_POWER_S_BASE            0x50005000UL
#define NRF_RESET_S_BASE            0x50005000UL
#define NRF_CTRLAP_NS_BASE          0x40006000UL
#define NRF_CTRLAP_S_BASE           0x50006000UL
#define NRF_SPIM0_NS_BASE           0x40008000UL
#define NRF_SPIS0_NS_BASE           0x40008000UL
#define NRF_TWIM0_NS_BASE           0x40008000UL
#define NRF_TWIS0_NS_BASE           0x40008000UL
#define NRF_UARTE0_NS_BASE          0x40008000UL
#define NRF_SPIM0_S_BASE            0x50008000UL
#define NRF_SPIS0_S_BASE            0x50008000UL
#define NRF_TWIM0_S_BASE            0x50008000UL
#define NRF_TWIS0_S_BASE            0x50008000UL
#define NRF_UARTE0_S_BASE           0x50008000UL
#define NRF_SPIM1_NS_BASE           0x40009000UL
#define NRF_SPIS1_NS_BASE           0x40009000UL
#define NRF_TWIM1_NS_BASE           0x40009000UL
#define NRF_TWIS1_NS_BASE           0x40009000UL
#define NRF_UARTE1_NS_BASE          0x40009000UL
#define NRF_SPIM1_S_BASE            0x50009000UL
#define NRF_SPIS1_S_BASE            0x50009000UL
#define NRF_TWIM1_S_BASE            0x50009000UL
#define NRF_TWIS1_S_BASE            0x50009000UL
#define NRF_UARTE1_S_BASE           0x50009000UL
#define NRF_SPIM4_NS_BASE           0x4000A000UL
#define NRF_SPIM4_S_BASE            0x5000A000UL
#define NRF_SPIM2_NS_BASE           0x4000B000UL
#define NRF_SPIS2_NS_BASE           0x4000B000UL
#define NRF_TWIM2_NS_BASE           0x4000B000UL
#define NRF_TWIS2_NS_BASE           0x4000B000UL
#define NRF_UARTE2_NS_BASE          0x4000B000UL
#define NRF_SPIM2_S_BASE            0x5000B000UL
#define NRF_SPIS2_S_BASE            0x5000B000UL
#define NRF_TWIM2_S_BASE            0x5000B000UL
#define NRF_TWIS2_S_BASE            0x5000B000UL
#define NRF_UARTE2_S_BASE           0x5000B000UL
#define NRF_SPIM3_NS_BASE           0x4000C000UL
#define NRF_SPIS3_NS_BASE           0x4000C000UL
#define NRF_TWIM3_NS_BASE           0x4000C000UL
#define NRF_TWIS3_NS_BASE           0x4000C000UL
#define NRF_UARTE3_NS_BASE          0x4000C000UL
#define NRF_SPIM3_S_BASE            0x5000C000UL
#define NRF_SPIS3_S_BASE            0x5000C000UL
#define NRF_TWIM3_S_BASE            0x5000C000UL
#define NRF_TWIS3_S_BASE            0x5000C000UL
#define NRF_UARTE3_S_BASE           0x5000C000UL
#define NRF_GPIOTE0_S_BASE          0x5000D000UL
#define NRF_SAADC_NS_BASE           0x4000E000UL
#define NRF_SAADC_S_BASE            0x5000E000UL
#define NRF_TIMER0_NS_BASE          0x4000F000UL
#define NRF_TIMER0_S_BASE           0x5000F000UL
#define NRF_TIMER1_NS_BASE          0x40010000UL
#define NRF_TIMER1_S_BASE           0x50010000UL
#define NRF_TIMER2_NS_BASE          0x40011000UL
#define NRF_TIMER2_S_BASE           0x50011000UL
#define NRF_RTC0_NS_BASE            0x40014000UL
#define NRF_RTC0_S_BASE             0x50014000UL
#define NRF_RTC1_NS_BASE            0x40015000UL
#define NRF_RTC1_S_BASE             0x50015000UL
#define NRF_DPPIC_NS_BASE           0x40017000UL
#define NRF_DPPIC_S_BASE            0x50017000UL
#define NRF_WDT0_NS_BASE            0x40018000UL
#define NRF_WDT0_S_BASE             0x50018000UL
#define NRF_WDT1_NS_BASE            0x40019000UL
#define NRF_WDT1_S_BASE             0x50019000UL
#define NRF_COMP_NS_BASE            0x4001A000UL
#define NRF_LPCOMP_NS_BASE          0x4001A000UL
#define NRF_COMP_S_BASE             0x5001A000UL
#define NRF_LPCOMP_S_BASE           0x5001A000UL
#define NRF_EGU0_NS_BASE            0x4001B000UL
#define NRF_EGU0_S_BASE             0x5001B000UL
#define NRF_EGU1_NS_BASE            0x4001C000UL
#define NRF_EGU1_S_BASE             0x5001C000UL
#define NRF_EGU2_NS_BASE            0x4001D000UL
#define NRF_EGU2_S_BASE             0x5001D000UL
#define NRF_EGU3_NS_BASE            0x4001E000UL
#define NRF_EGU3_S_BASE             0x5001E000UL
#define NRF_EGU4_NS_BASE            0x4001F000UL
#define NRF_EGU4_S_BASE             0x5001F000UL
#define NRF_EGU5_NS_BASE            0x40020000UL
#define NRF_EGU5_S_BASE             0x50020000UL
#define NRF_PWM0_NS_BASE            0x40021000UL
#define NRF_PWM0_S_BASE             0x50021000UL
#define NRF_PWM1_NS_BASE            0x40022000UL
#define NRF_PWM1_S_BASE             0x50022000UL
#define NRF_PWM2_NS_BASE            0x40023000UL
#define NRF_PWM2_S_BASE             0x50023000UL
#define NRF_PWM3_NS_BASE            0x40024000UL
#define NRF_PWM3_S_BASE             0x50024000UL
#define NRF_PDM0_NS_BASE            0x40026000UL
#define NRF_PDM0_S_BASE             0x50026000UL
#define NRF_I2S0_NS_BASE            0x40028000UL
#define NRF_I2S0_S_BASE             0x50028000UL
#define NRF_IPC_NS_BASE             0x4002A000UL
#define NRF_IPC_S_BASE              0x5002A000UL
#define NRF_QSPI_NS_BASE            0x4002B000UL
#define NRF_QSPI_S_BASE             0x5002B000UL
#define NRF_NFCT_NS_BASE            0x4002D000UL
#define NRF_NFCT_S_BASE             0x5002D000UL
#define NRF_GPIOTE1_NS_BASE         0x4002F000UL
#define NRF_MUTEX_NS_BASE           0x40030000UL
#define NRF_MUTEX_S_BASE            0x50030000UL
#define NRF_QDEC0_NS_BASE           0x40033000UL
#define NRF_QDEC0_S_BASE            0x50033000UL
#define NRF_QDEC1_NS_BASE           0x40034000UL
#define NRF_QDEC1_S_BASE            0x50034000UL
#define NRF_USBD_NS_BASE            0x40036000UL
#define NRF_USBD_S_BASE             0x50036000UL
#define NRF_USBREGULATOR_NS_BASE    0x40037000UL
#define NRF_USBREGULATOR_S_BASE     0x50037000UL
#define NRF_KMU_NS_BASE             0x40039000UL
#define NRF_NVMC_NS_BASE            0x40039000UL
#define NRF_KMU_S_BASE              0x50039000UL
#define NRF_NVMC_S_BASE             0x50039000UL
#define NRF_P0_NS_BASE              0x40842500UL
#define NRF_P1_NS_BASE              0x40842800UL
#define NRF_P0_S_BASE               0x50842500UL
#define NRF_P1_S_BASE               0x50842800UL
#define NRF_CRYPTOCELL_S_BASE       0x50844000UL
#define NRF_VMC_NS_BASE             0x40081000UL
#define NRF_VMC_S_BASE              0x50081000UL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define NRF_CACHEDATA_S             ((NRF_CACHEDATA_Type*)     NRF_CACHEDATA_S_BASE)
#define NRF_CACHEINFO_S             ((NRF_CACHEINFO_Type*)     NRF_CACHEINFO_S_BASE)
#define NRF_FICR_S                  ((NRF_FICR_Type*)          NRF_FICR_S_BASE)
#define NRF_UICR_S                  ((NRF_UICR_Type*)          NRF_UICR_S_BASE)
#define NRF_CTI_S                   ((NRF_CTI_Type*)           NRF_CTI_S_BASE)
#define NRF_TAD_S                   ((NRF_TAD_Type*)           NRF_TAD_S_BASE)
#define NRF_DCNF_NS                 ((NRF_DCNF_Type*)          NRF_DCNF_NS_BASE)
#define NRF_FPU_NS                  ((NRF_FPU_Type*)           NRF_FPU_NS_BASE)
#define NRF_DCNF_S                  ((NRF_DCNF_Type*)          NRF_DCNF_S_BASE)
#define NRF_FPU_S                   ((NRF_FPU_Type*)           NRF_FPU_S_BASE)
#define NRF_CACHE_S                 ((NRF_CACHE_Type*)         NRF_CACHE_S_BASE)
#define NRF_SPU_S                   ((NRF_SPU_Type*)           NRF_SPU_S_BASE)
#define NRF_OSCILLATORS_NS          ((NRF_OSCILLATORS_Type*)   NRF_OSCILLATORS_NS_BASE)
#define NRF_REGULATORS_NS           ((NRF_REGULATORS_Type*)    NRF_REGULATORS_NS_BASE)
#define NRF_OSCILLATORS_S           ((NRF_OSCILLATORS_Type*)   NRF_OSCILLATORS_S_BASE)
#define NRF_REGULATORS_S            ((NRF_REGULATORS_Type*)    NRF_REGULATORS_S_BASE)
#define NRF_CLOCK_NS                ((NRF_CLOCK_Type*)         NRF_CLOCK_NS_BASE)
#define NRF_POWER_NS                ((NRF_POWER_Type*)         NRF_POWER_NS_BASE)
#define NRF_RESET_NS                ((NRF_RESET_Type*)         NRF_RESET_NS_BASE)
#define NRF_CLOCK_S                 ((NRF_CLOCK_Type*)         NRF_CLOCK_S_BASE)
#define NRF_POWER_S                 ((NRF_POWER_Type*)         NRF_POWER_S_BASE)
#define NRF_RESET_S                 ((NRF_RESET_Type*)         NRF_RESET_S_BASE)
#define NRF_CTRLAP_NS               ((NRF_CTRLAPPERI_Type*)    NRF_CTRLAP_NS_BASE)
#define NRF_CTRLAP_S                ((NRF_CTRLAPPERI_Type*)    NRF_CTRLAP_S_BASE)
#define NRF_SPIM0_NS                ((NRF_SPIM_Type*)          NRF_SPIM0_NS_BASE)
#define NRF_SPIS0_NS                ((NRF_SPIS_Type*)          NRF_SPIS0_NS_BASE)
#define NRF_TWIM0_NS                ((NRF_TWIM_Type*)          NRF_TWIM0_NS_BASE)
#define NRF_TWIS0_NS                ((NRF_TWIS_Type*)          NRF_TWIS0_NS_BASE)
#define NRF_UARTE0_NS               ((NRF_UARTE_Type*)         NRF_UARTE0_NS_BASE)
#define NRF_SPIM0_S                 ((NRF_SPIM_Type*)          NRF_SPIM0_S_BASE)
#define NRF_SPIS0_S                 ((NRF_SPIS_Type*)          NRF_SPIS0_S_BASE)
#define NRF_TWIM0_S                 ((NRF_TWIM_Type*)          NRF_TWIM0_S_BASE)
#define NRF_TWIS0_S                 ((NRF_TWIS_Type*)          NRF_TWIS0_S_BASE)
#define NRF_UARTE0_S                ((NRF_UARTE_Type*)         NRF_UARTE0_S_BASE)
#define NRF_SPIM1_NS                ((NRF_SPIM_Type*)          NRF_SPIM1_NS_BASE)
#define NRF_SPIS1_NS                ((NRF_SPIS_Type*)          NRF_SPIS1_NS_BASE)
#define NRF_TWIM1_NS                ((NRF_TWIM_Type*)          NRF_TWIM1_NS_BASE)
#define NRF_TWIS1_NS                ((NRF_TWIS_Type*)          NRF_TWIS1_NS_BASE)
#define NRF_UARTE1_NS               ((NRF_UARTE_Type*)         NRF_UARTE1_NS_BASE)
#define NRF_SPIM1_S                 ((NRF_SPIM_Type*)          NRF_SPIM1_S_BASE)
#define NRF_SPIS1_S                 ((NRF_SPIS_Type*)          NRF_SPIS1_S_BASE)
#define NRF_TWIM1_S                 ((NRF_TWIM_Type*)          NRF_TWIM1_S_BASE)
#define NRF_TWIS1_S                 ((NRF_TWIS_Type*)          NRF_TWIS1_S_BASE)
#define NRF_UARTE1_S                ((NRF_UARTE_Type*)         NRF_UARTE1_S_BASE)
#define NRF_SPIM4_NS                ((NRF_SPIM_Type*)          NRF_SPIM4_NS_BASE)
#define NRF_SPIM4_S                 ((NRF_SPIM_Type*)          NRF_SPIM4_S_BASE)
#define NRF_SPIM2_NS                ((NRF_SPIM_Type*)          NRF_SPIM2_NS_BASE)
#define NRF_SPIS2_NS                ((NRF_SPIS_Type*)          NRF_SPIS2_NS_BASE)
#define NRF_TWIM2_NS                ((NRF_TWIM_Type*)          NRF_TWIM2_NS_BASE)
#define NRF_TWIS2_NS                ((NRF_TWIS_Type*)          NRF_TWIS2_NS_BASE)
#define NRF_UARTE2_NS               ((NRF_UARTE_Type*)         NRF_UARTE2_NS_BASE)
#define NRF_SPIM2_S                 ((NRF_SPIM_Type*)          NRF_SPIM2_S_BASE)
#define NRF_SPIS2_S                 ((NRF_SPIS_Type*)          NRF_SPIS2_S_BASE)
#define NRF_TWIM2_S                 ((NRF_TWIM_Type*)          NRF_TWIM2_S_BASE)
#define NRF_TWIS2_S                 ((NRF_TWIS_Type*)          NRF_TWIS2_S_BASE)
#define NRF_UARTE2_S                ((NRF_UARTE_Type*)         NRF_UARTE2_S_BASE)
#define NRF_SPIM3_NS                ((NRF_SPIM_Type*)          NRF_SPIM3_NS_BASE)
#define NRF_SPIS3_NS                ((NRF_SPIS_Type*)          NRF_SPIS3_NS_BASE)
#define NRF_TWIM3_NS                ((NRF_TWIM_Type*)          NRF_TWIM3_NS_BASE)
#define NRF_TWIS3_NS                ((NRF_TWIS_Type*)          NRF_TWIS3_NS_BASE)
#define NRF_UARTE3_NS               ((NRF_UARTE_Type*)         NRF_UARTE3_NS_BASE)
#define NRF_SPIM3_S                 ((NRF_SPIM_Type*)          NRF_SPIM3_S_BASE)
#define NRF_SPIS3_S                 ((NRF_SPIS_Type*)          NRF_SPIS3_S_BASE)
#define NRF_TWIM3_S                 ((NRF_TWIM_Type*)          NRF_TWIM3_S_BASE)
#define NRF_TWIS3_S                 ((NRF_TWIS_Type*)          NRF_TWIS3_S_BASE)
#define NRF_UARTE3_S                ((NRF_UARTE_Type*)         NRF_UARTE3_S_BASE)
#define NRF_GPIOTE0_S               ((NRF_GPIOTE_Type*)        NRF_GPIOTE0_S_BASE)
#define NRF_SAADC_NS                ((NRF_SAADC_Type*)         NRF_SAADC_NS_BASE)
#define NRF_SAADC_S                 ((NRF_SAADC_Type*)         NRF_SAADC_S_BASE)
#define NRF_TIMER0_NS               ((NRF_TIMER_Type*)         NRF_TIMER0_NS_BASE)
#define NRF_TIMER0_S                ((NRF_TIMER_Type*)         NRF_TIMER0_S_BASE)
#define NRF_TIMER1_NS               ((NRF_TIMER_Type*)         NRF_TIMER1_NS_BASE)
#define NRF_TIMER1_S                ((NRF_TIMER_Type*)         NRF_TIMER1_S_BASE)
#define NRF_TIMER2_NS               ((NRF_TIMER_Type*)         NRF_TIMER2_NS_BASE)
#define NRF_TIMER2_S                ((NRF_TIMER_Type*)         NRF_TIMER2_S_BASE)
#define NRF_RTC0_NS                 ((NRF_RTC_Type*)           NRF_RTC0_NS_BASE)
#define NRF_RTC0_S                  ((NRF_RTC_Type*)           NRF_RTC0_S_BASE)
#define NRF_RTC1_NS                 ((NRF_RTC_Type*)           NRF_RTC1_NS_BASE)
#define NRF_RTC1_S                  ((NRF_RTC_Type*)           NRF_RTC1_S_BASE)
#define NRF_DPPIC_NS                ((NRF_DPPIC_Type*)         NRF_DPPIC_NS_BASE)
#define NRF_DPPIC_S                 ((NRF_DPPIC_Type*)         NRF_DPPIC_S_BASE)
#define NRF_WDT0_NS                 ((NRF_WDT_Type*)           NRF_WDT0_NS_BASE)
#define NRF_WDT0_S                  ((NRF_WDT_Type*)           NRF_WDT0_S_BASE)
#define NRF_WDT1_NS                 ((NRF_WDT_Type*)           NRF_WDT1_NS_BASE)
#define NRF_WDT1_S                  ((NRF_WDT_Type*)           NRF_WDT1_S_BASE)
#define NRF_COMP_NS                 ((NRF_COMP_Type*)          NRF_COMP_NS_BASE)
#define NRF_LPCOMP_NS               ((NRF_LPCOMP_Type*)        NRF_LPCOMP_NS_BASE)
#define NRF_COMP_S                  ((NRF_COMP_Type*)          NRF_COMP_S_BASE)
#define NRF_LPCOMP_S                ((NRF_LPCOMP_Type*)        NRF_LPCOMP_S_BASE)
#define NRF_EGU0_NS                 ((NRF_EGU_Type*)           NRF_EGU0_NS_BASE)
#define NRF_EGU0_S                  ((NRF_EGU_Type*)           NRF_EGU0_S_BASE)
#define NRF_EGU1_NS                 ((NRF_EGU_Type*)           NRF_EGU1_NS_BASE)
#define NRF_EGU1_S                  ((NRF_EGU_Type*)           NRF_EGU1_S_BASE)
#define NRF_EGU2_NS                 ((NRF_EGU_Type*)           NRF_EGU2_NS_BASE)
#define NRF_EGU2_S                  ((NRF_EGU_Type*)           NRF_EGU2_S_BASE)
#define NRF_EGU3_NS                 ((NRF_EGU_Type*)           NRF_EGU3_NS_BASE)
#define NRF_EGU3_S                  ((NRF_EGU_Type*)           NRF_EGU3_S_BASE)
#define NRF_EGU4_NS                 ((NRF_EGU_Type*)           NRF_EGU4_NS_BASE)
#define NRF_EGU4_S                  ((NRF_EGU_Type*)           NRF_EGU4_S_BASE)
#define NRF_EGU5_NS                 ((NRF_EGU_Type*)           NRF_EGU5_NS_BASE)
#define NRF_EGU5_S                  ((NRF_EGU_Type*)           NRF_EGU5_S_BASE)
#define NRF_PWM0_NS                 ((NRF_PWM_Type*)           NRF_PWM0_NS_BASE)
#define NRF_PWM0_S                  ((NRF_PWM_Type*)           NRF_PWM0_S_BASE)
#define NRF_PWM1_NS                 ((NRF_PWM_Type*)           NRF_PWM1_NS_BASE)
#define NRF_PWM1_S                  ((NRF_PWM_Type*)           NRF_PWM1_S_BASE)
#define NRF_PWM2_NS                 ((NRF_PWM_Type*)           NRF_PWM2_NS_BASE)
#define NRF_PWM2_S                  ((NRF_PWM_Type*)           NRF_PWM2_S_BASE)
#define NRF_PWM3_NS                 ((NRF_PWM_Type*)           NRF_PWM3_NS_BASE)
#define NRF_PWM3_S                  ((NRF_PWM_Type*)           NRF_PWM3_S_BASE)
#define NRF_PDM0_NS                 ((NRF_PDM_Type*)           NRF_PDM0_NS_BASE)
#define NRF_PDM0_S                  ((NRF_PDM_Type*)           NRF_PDM0_S_BASE)
#define NRF_I2S0_NS                 ((NRF_I2S_Type*)           NRF_I2S0_NS_BASE)
#define NRF_I2S0_S                  ((NRF_I2S_Type*)           NRF_I2S0_S_BASE)
#define NRF_IPC_NS                  ((NRF_IPC_Type*)           NRF_IPC_NS_BASE)
#define NRF_IPC_S                   ((NRF_IPC_Type*)           NRF_IPC_S_BASE)
#define NRF_QSPI_NS                 ((NRF_QSPI_Type*)          NRF_QSPI_NS_BASE)
#define NRF_QSPI_S                  ((NRF_QSPI_Type*)          NRF_QSPI_S_BASE)
#define NRF_NFCT_NS                 ((NRF_NFCT_Type*)          NRF_NFCT_NS_BASE)
#define NRF_NFCT_S                  ((NRF_NFCT_Type*)          NRF_NFCT_S_BASE)
#define NRF_GPIOTE1_NS              ((NRF_GPIOTE_Type*)        NRF_GPIOTE1_NS_BASE)
#define NRF_MUTEX_NS                ((NRF_MUTEX_Type*)         NRF_MUTEX_NS_BASE)
#define NRF_MUTEX_S                 ((NRF_MUTEX_Type*)         NRF_MUTEX_S_BASE)
#define NRF_QDEC0_NS                ((NRF_QDEC_Type*)          NRF_QDEC0_NS_BASE)
#define NRF_QDEC0_S                 ((NRF_QDEC_Type*)          NRF_QDEC0_S_BASE)
#define NRF_QDEC1_NS                ((NRF_QDEC_Type*)          NRF_QDEC1_NS_BASE)
#define NRF_QDEC1_S                 ((NRF_QDEC_Type*)          NRF_QDEC1_S_BASE)
#define NRF_USBD_NS                 ((NRF_USBD_Type*)          NRF_USBD_NS_BASE)
#define NRF_USBD_S                  ((NRF_USBD_Type*)          NRF_USBD_S_BASE)
#define NRF_USBREGULATOR_NS         ((NRF_USBREG_Type*)        NRF_USBREGULATOR_NS_BASE)
#define NRF_USBREGULATOR_S          ((NRF_USBREG_Type*)        NRF_USBREGULATOR_S_BASE)
#define NRF_KMU_NS                  ((NRF_KMU_Type*)           NRF_KMU_NS_BASE)
#define NRF_NVMC_NS                 ((NRF_NVMC_Type*)          NRF_NVMC_NS_BASE)
#define NRF_KMU_S                   ((NRF_KMU_Type*)           NRF_KMU_S_BASE)
#define NRF_NVMC_S                  ((NRF_NVMC_Type*)          NRF_NVMC_S_BASE)
#define NRF_P0_NS                   ((NRF_GPIO_Type*)          NRF_P0_NS_BASE)
#define NRF_P1_NS                   ((NRF_GPIO_Type*)          NRF_P1_NS_BASE)
#define NRF_P0_S                    ((NRF_GPIO_Type*)          NRF_P0_S_BASE)
#define NRF_P1_S                    ((NRF_GPIO_Type*)          NRF_P1_S_BASE)
#define NRF_CRYPTOCELL_S            ((NRF_CRYPTOCELL_Type*)    NRF_CRYPTOCELL_S_BASE)
#define NRF_VMC_NS                  ((NRF_VMC_Type*)           NRF_VMC_NS_BASE)
#define NRF_VMC_S                   ((NRF_VMC_Type*)           NRF_VMC_S_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


#ifdef __cplusplus
}
#endif

#endif /* NRF5340_APPLICATION_H */


/** @} */ /* End of group nrf5340_application */

/** @} */ /* End of group Nordic Semiconductor */
